(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  this.Ng = {
    annotateDependencies: function(Class, props) {
      var deps, name;
      if (props == null) {
        props = {};
      }
      Class.$inject || (Class.$inject = []);
      Class.$injected || (Class.$injected = []);
      for (name in props) {
        deps = props[name];
        deps = [deps].flatten();
        Class.$inject.push(deps.shift());
        Class.$injected.push({
          name: name,
          params: deps
        });
      }
      return Class;
    },
    assignDependencies: function(inst, injected) {
      var i, index, len, name, params, ref, ref1, ref2;
      if (inst.constructor.$injected != null) {
        ref = inst.constructor.$injected;
        for (index = i = 0, len = ref.length; i < len; index = ++i) {
          ref1 = ref[index], name = ref1.name, params = ref1.params;
          inst[name] = params.length > 0 ? (ref2 = injected[index]) != null ? ref2.apply(null, params) : void 0 : injected[index];
        }
      }
      return inst;
    },
    getTransformedName: function(Class, defaultTransform) {
      if (defaultTransform == null) {
        defaultTransform = 'classify';
      }
      if (Class.registerAs != null) {
        return Class.registerAs;
      }
      switch (Class.nameTransform || defaultTransform) {
        case 'dasherize':
          return Class.name.dasherize();
        case 'camelize':
          return Class.name.camelize(false);
        case 'underscore':
          return Class.name.underscore();
        case 'classify':
          return Class.name.camelize();
        default:
          return Class.name;
      }
    },
    getModule: function(Class, autoCreate) {
      var deps, error, ex;
      if (autoCreate == null) {
        autoCreate = true;
      }
      try {
        return angular.module(Class.module);
      } catch (error) {
        ex = error;
        if (autoCreate) {
          deps = Class.moduleDeps || [];
          return angular.module(Class.module, deps);
        } else {
          throw ex;
        }
      }
    }
  };

  Ng.Base = (function() {
    Base.module = 'app';

    Base.nameTransform = 'classify';

    Base.inject = function(props) {
      var moduleName;
      if (this.type == null) {
        return;
      }
      if (this.type === 'module') {
        this.moduleDeps = [this.moduleDeps || [], Array.create(arguments)].flatten();
        if (this.module === 'app') {
          this.module = Ng.getTransformedName(this);
        }
        Ng.getModule(this, true);
        moduleName = this.module;
        this.Base = (function(superClass) {
          extend(Base, superClass);

          function Base() {
            return Base.__super__.constructor.apply(this, arguments);
          }

          Base.module = moduleName;

          return Base;

        })(Ng.Base);
        this.Controller = (function(superClass) {
          extend(Controller, superClass);

          function Controller() {
            return Controller.__super__.constructor.apply(this, arguments);
          }

          Controller.module = moduleName;

          return Controller;

        })(Ng.Controller);
        this.Service = (function(superClass) {
          extend(Service, superClass);

          function Service() {
            return Service.__super__.constructor.apply(this, arguments);
          }

          Service.module = moduleName;

          return Service;

        })(Ng.Service);
        return this.Factory = (function(superClass) {
          extend(Factory, superClass);

          function Factory() {
            return Factory.__super__.constructor.apply(this, arguments);
          }

          Factory.module = moduleName;

          return Factory;

        })(Ng.Factory);
      } else {
        Ng.annotateDependencies(this, props);
        return Ng.getModule(this)[this.type](Ng.getTransformedName(this), this);
      }
    };

    Base.animation = function(name, fn) {
      var def;
      def = typeof fn === 'function' ? fn : (function() {
        return fn;
      });
      return Ng.getModule(this).animation(name, def);
    };

    Base.config = function(fn) {
      return Ng.getModule(this).config(fn);
    };

    Base.directive = function(name, config) {
      var def;
      def = typeof config === 'function' ? config : (function() {
        return config;
      });
      return Ng.getModule(this).directive(name, def);
    };

    Base.filter = function(name, fn) {
      return Ng.getModule(this).filter(name, (function() {
        return fn;
      }));
    };

    Base.run = function(fn) {
      return Ng.getModule(this).run(fn);
    };

    Base.constant = function(name, value) {
      return Ng.getModule(this).constant(name, value);
    };

    Base.value = function(name, value) {
      return Ng.getModule(this).value(name, value);
    };

    Base.factory = function(name, fn) {
      return Ng.getModule(this).factory(name, fn);
    };

    function Base() {
      var init_result, injected, ref, type;
      injected = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      if ((type = (ref = this.$get) != null ? ref.type : void 0) && type === 'factory') {
        return (function(func, args, ctor) {
          ctor.prototype = func.prototype;
          var child = new ctor, result = func.apply(child, args);
          return Object(result) === result ? result : child;
        })(this.$get, injected, function(){});
      }
      Ng.assignDependencies(this, injected);
      init_result = typeof this.initialize === "function" ? this.initialize.apply(this, injected) : void 0;
      if (this.constructor.type === 'factory') {
        return init_result;
      }
    }

    return Base;

  })();

  Ng.Module = (function(superClass) {
    extend(Module, superClass);

    function Module() {
      return Module.__super__.constructor.apply(this, arguments);
    }

    Module.nameTransform = 'dasherize';

    Module.type = 'module';

    return Module;

  })(Ng.Base);

  Ng.Controller = (function(superClass) {
    extend(Controller, superClass);

    function Controller() {
      return Controller.__super__.constructor.apply(this, arguments);
    }

    Controller.type = 'controller';

    return Controller;

  })(Ng.Base);

  Ng.Service = (function(superClass) {
    extend(Service, superClass);

    function Service() {
      return Service.__super__.constructor.apply(this, arguments);
    }

    Service.nameTransform = 'camelize';

    Service.type = 'service';

    return Service;

  })(Ng.Base);

  Ng.Factory = (function(superClass) {
    extend(Factory, superClass);

    function Factory() {
      return Factory.__super__.constructor.apply(this, arguments);
    }

    Factory.type = 'factory';

    return Factory;

  })(Ng.Base);

}).call(this);
;(function() {
  var iOSVersion, isAppMode, isApple, isBrokeniOS7, isDesktop, isMobile, isNative, isNativeDebug, isiOS;

  isApple = navigator.platform.match(/(Mac|iPhone|iPod|iPad)/i) ? true : false;

  iOSVersion = (function() {
    var build, major, match, minor, version;
    if (!/iP(hone|od|ad)/.test(navigator.platform)) {
      return null;
    }
    match = navigator.appVersion.match(/OS (\d+)_(\d+)_?(\d+)?/);
    major = parseInt(match[1], 10);
    minor = parseInt(match[2] || 0, 10);
    build = parseInt(match[3] || 0, 10);
    version = [major, "" + minor + build];
    return parseFloat(version.join('.'));
  })();

  isiOS = (function() {
    return iOSVersion > 0;
  })();

  isBrokeniOS7 = (function() {
    return iOSVersion > 7 && iOSVersion < 7.03;
  })();

  isNative = (function() {
    if (location.href.indexOf('pg=true') > 0 || window.NATIVE === true || window.location.hostname === "") {
      return true;
    } else {
      return false;
    }
  })();

  isNativeDebug = (function() {
    if (isNative && window.NATIVE_DEBUG === true) {
      return true;
    }
    return false;
  })();

  isAppMode = window.navigator.standalone === true;

  isMobile = (function() {
    return (function(a) {
      if (/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a) || /1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0, 4))) {
        return true;
      } else {
        return false;
      }
    })(navigator.userAgent || navigator.vendor || window.opera);
  })();

  isDesktop = !isMobile;

  this.Browser = {
    isApple: isApple,
    isMobile: isMobile,
    isDesktop: isDesktop,
    isAppMode: isAppMode,
    isNative: isNative,
    iOSVersion: iOSVersion,
    isiOS: isiOS,
    isBrokeniOS7: isBrokeniOS7,
    isNativeDebug: isNativeDebug
  };

}).call(this);
;(function() {
  var ensureWWW, host, hostContains, iOSVersion, isBrokeniOS7, isDebug, isLocal, isNative, isNativeDebug, isProduction, isStaging, isiOS,
    slice = [].slice;

  host = window.location.hostname;

  hostContains = function() {
    var i, len, name, names;
    names = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    for (i = 0, len = names.length; i < len; i++) {
      name = names[i];
      if (host.indexOf(name) >= 0) {
        return true;
      }
    }
    return false;
  };

  iOSVersion = Browser.iOSVersion, isiOS = Browser.isiOS, isBrokeniOS7 = Browser.isBrokeniOS7, isNative = Browser.isNative, isNativeDebug = Browser.isNativeDebug;

  isLocal = hostContains('localhost', '.dev', '.local', '192.168');

  isStaging = (function() {
    if (isLocal || (isNative && isNativeDebug)) {
      return true;
    }
    return hostContains('test.com');
  })();

  isProduction = (function() {
    if (isLocal) {
      return false;
    }
    return hostContains('dfw.com', 'phx.com');
  })();

  isDebug = (function() {
    if (isNative && isNativeDebug) {
      return true;
    }
    if (isLocal) {
      return true;
    }
    if (isStaging) {
      return true;
    }
  })();

  ensureWWW = function() {
    if (host === 'freedomparkdfw.com') {
      window.location.href = 'https://www.freedomparkdfw.com' + window.location.pathname + window.location.hash;
      return false;
    }
    if (host === 'freedomparkphx.com') {
      window.location.href = 'https://www.freedomparkphx.com' + window.location.pathname + window.location.hash;
      return false;
    }
    if (host === 'freedomparktest.com') {
      window.location.href = 'https://www.freedomparktest.com' + window.location.pathname + window.location.hash;
      return false;
    }
    return true;
  };

  this.Host = {
    isLocal: isLocal,
    isStaging: isStaging,
    isProduction: isProduction,
    isNative: isNative,
    isNativeDebug: isNativeDebug,
    ensureWWW: ensureWWW,
    isiOS: isiOS,
    iOSVersion: iOSVersion,
    isBrokeniOS7: isBrokeniOS7
  };

  if (isNative) {
    document.documentElement.className += " native";
  }

}).call(this);
;(function() {
  var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  (function() {
    window.AudioContext = window.AudioContext || window.webkitAudioContext;
    navigator.vibrate = navigator.vibrate || navigator.webkitVibrate || navigator.mozVibrate || navigator.msVibrate;
    return Host.ensureWWW();
  })();

  this.App = (function(superClass) {
    extend(App, superClass);

    function App() {
      return App.__super__.constructor.apply(this, arguments);
    }

    App.inject('ionic', 'ngCordova', 'ionic.service.core', 'ngAnimate', 'templates', 'ngPrettyJson', 'ngIOS9UIWebViewPatch');

    App.config(function($httpProvider) {
      return $httpProvider.defaults.useXDomain = true;
    });

    App.run(function($ionicPlatform, $templateCache, $rootScope, $ionicLoading, $state, app, auth) {
      var is_updating;
      console.debug("FP.Mobile - Start");
      $rootScope.$state = $state;
      $rootScope.$on("$stateChangeError", function() {
        var args;
        args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
        return console.error.apply(console, ["!(route)"].concat(slice.call(args)));
      });
      $rootScope.$on('$stateChangeStart', function(e, to, params) {
        var ref;
        if ((ref = to.data) != null ? ref.secure : void 0) {
          if (!app.auth.loggedIn) {
            console.info("ROUTER BOUNCER: You're NOT on the list.", to, 'params:', params);
            e.preventDefault();
            app.redirectTo.name = to.name;
            app.redirectTo.params = params;
            return $state.go('main.home', null, {
              notify: true
            });
          } else {
            return console.info("ROUTER BOUNCER: You're in.", to);
          }
        }
      });
      $ionicPlatform.ready(function() {
        if (window.StatusBar) {
          return StatusBar.styleDefault();
        }
      });
      is_updating = false;
      app.updater.watchForUpdates(1 * MINUTES, 5 * SECONDS).then(function() {
        is_updating = true;
        return $ionicLoading.show({
          template: '<div>Applying application updates...</div>',
          noBackdrop: false
        });
      });
      $rootScope.$on('loading:show', function(event, command) {
        var loadingMessage, ref;
        console.debug('loading:show', command);
        loadingMessage = '<ion-spinner icon="bubbles" style="fill: white;"></ion-spinner>';
        if (typeof ionic !== "undefined" && ionic !== null ? (ref = ionic.Platform) != null ? typeof ref.isAndroid === "function" ? ref.isAndroid() : void 0 : void 0 : void 0) {
          loadingMessage = '<div>Loading...</div>';
        }
        return $ionicLoading.show({
          template: loadingMessage,
          noBackdrop: true
        });
      });
      return $rootScope.$on('loading:hide', function(event, command) {
        if (is_updating) {
          return;
        }
        console.debug('loading:hide', command);
        return $ionicLoading.hide();
      });
    });

    return App;

  })(Ng.Module);

}).call(this);
;(function() {
  var Logger, LoggerImpl,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    slice = [].slice,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  LoggerImpl = (function() {
    var log;

    log = null;

    function LoggerImpl(prefix, logger) {
      var ref;
      if (logger == null) {
        logger = console;
      }
      this.error = bind(this.error, this);
      this.warn = bind(this.warn, this);
      this.debug = bind(this.debug, this);
      this.info = bind(this.info, this);
      this.log = bind(this.log, this);
      this.prefix = typeof prefix === 'string' ? prefix + ":" : (prefix.name || ((ref = prefix.constructor) != null ? ref.name : void 0) || prefix || '~') + ":";
      if (log !== logger) {
        log = logger;
      }
    }

    LoggerImpl.prototype.log = function() {
      return log.log.apply(log, [this.prefix].concat(slice.call(arguments)));
    };

    LoggerImpl.prototype.info = function() {
      return log.info.apply(log, [this.prefix].concat(slice.call(arguments)));
    };

    LoggerImpl.prototype.debug = function() {
      return log.debug.apply(log, [this.prefix].concat(slice.call(arguments)));
    };

    LoggerImpl.prototype.out = LoggerImpl.prototype.debug;

    LoggerImpl.prototype.warn = function() {
      return log.warn.apply(log, [this.prefix].concat(slice.call(arguments)));
    };

    LoggerImpl.prototype.error = function() {
      return log.error.apply(log, [this.prefix].concat(slice.call(arguments)));
    };

    return LoggerImpl;

  })();

  Logger = (function(superClass) {
    extend(Logger, superClass);

    function Logger() {
      return Logger.__super__.constructor.apply(this, arguments);
    }

    Logger.factory('Logger', function($log) {
      var _log;
      _log = $log;
      if (Host.isProduction) {
        return function() {
          var api;
          api = function() {};
          Object.merge(api, {
            log: function() {},
            info: function() {},
            debug: function() {},
            out: function() {},
            warn: function() {},
            error: function() {}
          });
          return api;
        };
      }
      return function(prefix) {
        var api, logger;
        logger = new LoggerImpl(prefix, _log);
        api = function() {
          return logger.debug.apply(logger, arguments);
        };
        return Object.merge(api, logger);
      };
    });

    return Logger;

  })(Ng.Factory);

}).call(this);
;(function() {
  var ModalHelper,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ModalHelper = (function(superClass) {
    extend(ModalHelper, superClass);

    function ModalHelper() {
      return ModalHelper.__super__.constructor.apply(this, arguments);
    }

    ModalHelper.inject({
      ionicModal: '$ionicModal',
      root: '$rootScope',
      log: ['Logger', ModalHelper],
      promise: '$q',
      events: 'events',
      platform: '$ionicPlatform'
    });

    ModalHelper.prototype.initialize = function($ionicModal, $rootScope, log, promise, events, platform) {
      log = this.log;
      return log("modal helper initialize");
    };

    ModalHelper.prototype.createFor = function(controller, scope) {
      var events, ionicModal, log, platform, promise, root;
      ionicModal = this.ionicModal, root = this.root, log = this.log, promise = this.promise, events = this.events, platform = this.platform;
      return {
        close: function() {
          var ref;
          if (scope.closeActiveModal != null) {
            return scope.closeActiveModal({
              cancel: true
            });
          } else {
            return (ref = scope.activeModal) != null ? ref.remove() : void 0;
          }
        },
        show: function(template, callback) {
          var local_callback, modal_results;
          modal_results = promise.defer();
          local_callback = function(m) {
            var dereg, onBack, unpreventBack;
            log("showing modal", m);
            onBack = function() {
              return scope.closeActiveModal({
                cancel: true
              });
            };
            dereg = platform.registerBackButtonAction(onBack, 999);
            unpreventBack = scope.$on('$locationChangeStart', (function(_this) {
              return function(e) {
                e.preventDefault();
                return scope.closeActiveModal({
                  cancel: true
                });
              };
            })(this));
            scope.activeModal = m;
            scope.closeActiveModal = function(result) {
              unpreventBack();
              m.remove();
              events.trigger('modal.hide', m, result);
              scope.activeModal = null;
              scope.modalStatusFormValue = null;
              if ((result != null ? result.cancel : void 0) === true) {
                modal_results.reject(new Error("Canceled action."));
              } else {
                modal_results.resolve(result);
              }
              if (typeof dereg === "function") {
                dereg();
              }
              return scope.closeActiveModal = null;
            };
            m.show().then(function() {
              log("show animation complete.");
              if ($('body').is('.loading-active')) {
                log("BODY has loading-active, may be broken");
                return $('body').removeClass('loading-active');
              } else {
                return log("Everything SEEMS ok.");
              }
            });
            events.trigger('modal.show', m);
            return typeof callback === "function" ? callback(m) : void 0;
          };
          root.callingPage = controller;
          ionicModal.fromTemplateUrl(template, local_callback, {
            scope: scope,
            animation: 'slide-in-up'
          });
          return modal_results.promise;
        }
      };
    };

    ModalHelper.prototype.createForUrl = function(url, controller, scope) {
      var events, ionicModal, log, modalCtrl, modalResolver, platform, promise, root;
      ionicModal = this.ionicModal, root = this.root, log = this.log, promise = this.promise, events = this.events, platform = this.platform;
      modalCtrl = null;
      modalResolver = ionicModal.fromTemplateUrl(url, {
        scope: scope,
        animation: 'slide-in-up'
      }).then((function(_this) {
        return function(modal) {
          modalCtrl = modal;
          return scope.$on('$destroy', function() {
            log("Removing modal!", url);
            return modalCtrl.remove();
          });
        };
      })(this));
      return {
        close: function() {
          var ref;
          if (scope.closeActiveModal != null) {
            return scope.closeActiveModal({
              cancel: true
            });
          } else {
            return (ref = scope.activeModal) != null ? ref.remove() : void 0;
          }
        },
        show: function(params) {
          var dereg, modal_results, onBack, unpreventBack;
          if (params == null) {
            params = {};
          }
          modal_results = promise.defer();
          root.callingPage = controller;
          onBack = function() {
            return scope.closeActiveModal({
              cancel: true
            });
          };
          dereg = platform.registerBackButtonAction(onBack, 999);
          unpreventBack = scope.$on('$locationChangeStart', (function(_this) {
            return function(e) {
              e.preventDefault();
              return scope.closeActiveModal({
                cancel: true
              });
            };
          })(this));
          scope.activeModal = modalCtrl;
          scope.activeModalParams = params;
          scope.closeActiveModal = function(result) {
            unpreventBack();
            events.trigger('modal.hide', modalCtrl, result);
            scope.activeModal = null;
            scope.activeModalParams = null;
            modalCtrl.hide();
            if (typeof dereg === "function") {
              dereg();
            }
            scope.closeActiveModal = null;
            if ((result != null ? result.cancel : void 0) === true) {
              return modal_results.reject(new Error("Canceled action."));
            } else {
              return modal_results.resolve(result);
            }
          };
          modalResolver.then((function(_this) {
            return function() {
              return modalCtrl.show().then(function() {
                log("show animation complete.");
                if ($('body').is('.loading-active')) {
                  log("BODY has loading-active, may be broken");
                  $('body').removeClass('loading-active');
                } else {
                  log("Everything SEEMS ok.");
                }
                return events.trigger('modal.show', modalCtrl);
              });
            };
          })(this));
          return modal_results.promise;
        }
      };
    };

    return ModalHelper;

  })(App.Service);

}).call(this);
;(function() {
  var MemoryStorage, NgSession, Session,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  NgSession = (function(superClass) {
    extend(NgSession, superClass);

    function NgSession() {
      return NgSession.__super__.constructor.apply(this, arguments);
    }

    NgSession.factory('Session', function() {
      return function() {
        return (function(func, args, ctor) {
          ctor.prototype = func.prototype;
          var child = new ctor, result = func.apply(child, args);
          return Object(result) === result ? result : child;
        })(Session, arguments, function(){});
      };
    });

    return NgSession;

  })(Ng.Factory);

  Session = (function() {
    function Session(prefix, storage) {
      this.prefix = prefix != null ? prefix : 'session';
      if (storage == null) {
        storage = 'local';
      }
      this._type = storage;
      this._store = storage === 'local' && window.localStorage ? window.localStorage : storage === 'session' && window.sessionStorage ? window.sessionStorage : new MemoryStorage;
    }

    Session.prototype.set = function(name, value) {
      var attrs, key, obj, val;
      attrs = arguments.length === 2 ? (obj = {}, obj[name] = value, obj) : name;
      for (key in attrs) {
        if (!hasProp.call(attrs, key)) continue;
        val = attrs[key];
        this._store.setItem(this._keyName(key), JSON.stringify(val));
      }
      return attrs;
    };

    Session.prototype.get = function(name, defaultValue) {
      var src;
      src = this._store.getItem(this._keyName(name));
      if (src != null) {
        return JSON.parse(src);
      } else {
        return defaultValue || null;
      }
    };

    Session.prototype.remove = function(name) {
      return this._store.removeItem(this._keyName(name));
    };

    Session.prototype.clear = function() {
      var i, j, key, ref, results;
      if (window.localStorage) {
        results = [];
        for (i = j = 0, ref = this._store.length; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
          key = this._store.key(i);
          if ((key != null) && key.startsWith(this.prefix)) {
            results.push(this._store.removeItem(key));
          } else {
            results.push(void 0);
          }
        }
        return results;
      } else {
        return this._store.clear();
      }
    };

    Session.prototype._keyName = function(key) {
      return this.prefix + "-" + key;
    };

    return Session;

  })();

  MemoryStorage = (function() {
    function MemoryStorage() {
      this.clear();
    }

    MemoryStorage.prototype.setItem = function(name, value) {
      return this._cache[name] = value;
    };

    MemoryStorage.prototype.getItem = function(name) {
      return this._cache[name];
    };

    MemoryStorage.prototype.removeItem = function(name) {
      return delete this._cache[name];
    };

    MemoryStorage.prototype.clear = function() {
      return this._cache = {};
    };

    return MemoryStorage;

  })();

}).call(this);
;(function() {
  var Delay,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Delay = (function(superClass) {
    extend(Delay, superClass);

    function Delay() {
      return Delay.__super__.constructor.apply(this, arguments);
    }

    Delay.factory('delay', function($timeout) {
      var _timeout;
      _timeout = $timeout;
      return function(amount, callback) {
        return _timeout(callback, amount);
      };
    });

    return Delay;

  })(App.Factory);

  this.delay = function(amount, callback) {
    return setTimeout(callback, amount);
  };

}).call(this);
;(function() {
  var FORMATS, FieldFormatter,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  FORMATS = {
    time: 'hh:mm A',
    date: 'MM/DD/YYYY'
  };

  FieldFormatter = (function(superClass) {
    extend(FieldFormatter, superClass);

    function FieldFormatter() {
      return FieldFormatter.__super__.constructor.apply(this, arguments);
    }

    FieldFormatter.inject({
      log: ['Logger', FieldFormatter]
    });

    FieldFormatter.prototype.initialize = function() {
      this.log('Initialize!');
      return window.fieldFormatter = this;
    };

    FieldFormatter.prototype.fieldFormats = function(data, fields) {
      var key, result, type;
      result = _.clone(data);
      for (key in fields) {
        type = fields[key];
        result[key] = this.mungeField(data[key], type);
      }
      return result;
    };

    FieldFormatter.prototype.mungeField = function(value, type) {
      var date;
      date = moment(value);
      if (date.isValid()) {
        return date.format(FORMATS[type]);
      } else {
        return value;
      }
    };

    return FieldFormatter;

  })(App.Service);

}).call(this);
;(function() {
  var GateFormatter, reEast, reWest, stripEastAndWest,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  reEast = /(\-EAST)$/;

  reWest = /(\-WEST)$/;

  stripEastAndWest = function(value) {
    return String(value).replace(reEast, '').replace(reWest, '');
  };

  GateFormatter = (function(superClass) {
    extend(GateFormatter, superClass);

    function GateFormatter() {
      return GateFormatter.__super__.constructor.apply(this, arguments);
    }

    GateFormatter.inject({
      log: ['Logger', GateFormatter]
    });

    GateFormatter.filter('gateFormat', function(value) {
      return stripEastAndWest(value);
    });

    return GateFormatter;

  })(App.Service);

}).call(this);
;(function() {
  var ApiField, BASE_URL, DATE_FORMAT, DATE_FORMAT_RE, DATE_LONG_FORMAT, DATE_SHORT_FORMAT, Formatters, NUMBER_STRIPPER_RE, PHONE_PARTS_RE, ROOT_URI, Schema, TIME_FORMAT, active_requests, createXhrReq, known_auth_token, known_cellnumber, portal_url, ref, tools,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    hasProp = {}.hasOwnProperty,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  BASE_URL = "";

  ROOT_URI = "/Mobile/FPMobile.asmx";

  DATE_FORMAT = "YYYY-MM-DDTHH:mm:ss";

  DATE_FORMAT_RE = /^[\d]{4}-[\d]{2}-[\d]{2}T[\d]{1,2}:[\d]{2}:[\d]{2}$/;

  PHONE_PARTS_RE = /^([\d]{3})([\d]{3})([\d]{4})$/;

  NUMBER_STRIPPER_RE = /([^0-9\.]?)/g;

  DATE_SHORT_FORMAT = "MM/YYYY";

  DATE_LONG_FORMAT = "M/D/YYYY h:mm A";

  TIME_FORMAT = "h:mm A";

  active_requests = 0;

  known_auth_token = null;

  known_cellnumber = null;

  if (typeof jQuery !== "undefined" && jQuery !== null) {
    if ((ref = jQuery.support) != null) {
      ref.cors = true;
    }
  }

  tools = {
    parseDate: function(string) {
      return moment(string, DATE_FORMAT).toDate();
    },
    parseMoment: function(string) {
      return moment(string, DATE_FORMAT);
    },
    str2date: function(string) {
      return this.parseDate(string);
    },
    str2moment: function(string) {
      return this.parseMoment(string);
    },
    date2str: function(date) {
      return moment(date).format(DATE_FORMAT);
    },
    verifyDateString: function(string) {
      return string.match(DATE_FORMAT_RE) === !null;
    },
    portal_url: function(path) {
      if (path == null) {
        path = '';
      }
      return "" + BASE_URL + ROOT_URI + "/" + path;
    },
    createXhrReq: function() {
      if (window.ActiveXObject != null) {
        return new ActiveXObject("Microsoft.XMLHTTP");
      } else if (window.XMLHttpRequest != null) {
        return new XMLHttpRequest();
      } else {
        throw new Error("No suitable XMLHttpRequest analog found for this platform!");
      }
    }
  };

  portal_url = tools.portal_url, createXhrReq = tools.createXhrReq;

  this.API = {
    _EventRoot: $(document),
    getAuthToken: function() {
      return {
        known_auth_token: known_auth_token,
        known_cellnumber: known_cellnumber
      };
    },
    setEventRoot: function(root) {
      return API._EventRoot = root;
    },
    setAuthToken: function(info) {
      if (!((info.token != null) && (info.cellnumber != null))) {
        console.error("Invalid API info", info);
        throw new Error("Invalid API auth info!");
      }
      known_auth_token = info.token;
      known_cellnumber = info.cellnumber;
      return this;
    },
    clearAuthToken: function() {
      known_auth_token = null;
      return known_cellnumber = null;
    },
    setBaseUrl: function(url) {
      BASE_URL = url;
      return this;
    },
    DATE_FORMAT: DATE_FORMAT,
    DATE_SHORT_FORMAT: DATE_SHORT_FORMAT,
    DATE_LONG_FORMAT: DATE_LONG_FORMAT,
    TIME_FORMAT: TIME_FORMAT,
    CLASSES: {},
    Config: {}
  };

  API.Method = (function() {
    Method.prototype.isCrossDomain = true;

    function Method(params1, callback1) {
      this.params = params1 != null ? params1 : {};
      this.callback = callback1;
      this.serverDidRespond = bind(this.serverDidRespond, this);
      this.err = null;
      this.data = null;
      this._defer = $.Deferred();
      if (this.callback) {
        this._defer.always(this.callback);
      }
      this.promise = this._defer.promise();
      this.validateParams();
    }

    Method.prototype.validateParams = function() {
      var field, i, len, missing, ref1;
      this.verifyParamTypes();
      missing = [];
      if (this.config.requireToken || this.config.requireTokenAndCell) {
        this.params['token'] = known_auth_token;
      }
      if (this.config.requireCellnumber || this.config.requireTokenAndCell) {
        this.params['cellnumber'] = known_cellnumber;
      }
      if (this.config.requireParams) {
        ref1 = this.config.requireParams;
        for (i = 0, len = ref1.length; i < len; i++) {
          field = ref1[i];
          if (!this.params[field]) {
            missing.push(field);
          }
        }
      }
      if (missing.length > 0) {
        this.err = new Error(this.config.name + " (" + this.config.action + ") requires parameters: " + (missing.join(', ')));
        return typeof console !== "undefined" && console !== null ? console.warn('validateParams failed:', this.err) : void 0;
      }
    };

    Method.prototype.run = function() {
      this.preFlight();
      if (this.err != null) {
        return this.triggerCallback();
      }
      return this.callServer();
    };

    Method.prototype.buildUrl = function() {
      return portal_url(this.config.action);
    };

    Method.prototype.preFlight = function() {};

    Method.prototype.callServer = function() {
      var endpoint;
      if (this.config.spinner) {
        active_requests += 1;
        if (active_requests === 1) {
          API._EventRoot.trigger('spinner.show', this.config.name);
        }
      }
      endpoint = this.buildUrl();
      endpoint += endpoint.indexOf('?') > 0 ? "&" : "?";
      endpoint += "timestamp=" + ((new Date).getTime());
      return $.ajax({
        url: endpoint,
        type: 'POST',
        headers: {
          "Content-type": "application/json; charset=utf-8"
        },
        timeout: 1000 * 30,
        dataType: 'json',
        data: JSON.stringify(this.params),
        processData: false,
        crossDomain: this.isCrossDomain
      }).always(this.serverDidRespond);
    };

    Method.prototype.serverDidRespond = function(response, status, extra) {
      var hideIt, validAuth;
      if (status !== 'success') {
        if (extra === 'timeout') {
          this.err = new Error("The server failed to respond in a timely manner. Please try again later.");
        } else {
          try {
            this.servererr = JSON.parse(response.responseText);
          } catch (undefined) {}
          if (this.servererr && this.servererr.Message) {
            this.err = new Error("Server Error: " + this.servererr.Message);
            if (typeof console !== "undefined" && console !== null) {
              console.error("server error", this.servererr);
            }
          } else {
            this.err = new Error(extra + " (" + response.status + ")");
          }
        }
      } else {
        this.data = this.extractFluff(response);
        validAuth = this.validateAuthToken();
        if (this.err === null && validAuth) {
          this.verifyDataTypes();
          this.handleResponse();
        }
      }
      if ((this.err != null) || validAuth) {
        this.triggerCallback();
      }
      if (this.config.spinner) {
        hideIt = function() {
          active_requests -= 1;
          if (active_requests === 0) {
            return API._EventRoot.trigger('spinner.hide');
          }
        };
        return setTimeout(hideIt, 100);
      }
    };

    Method.prototype.extractFluff = function(response) {
      var data, error, ex;
      data = {};
      try {
        if (response !== null) {
          data = response.d ? response.d : response;
        }
      } catch (error) {
        ex = error;
        console.error("Error parsing the server response!", ex, response);
        ex.originalMessage = ex.message;
        ex.message = "Error parsing the server response! (" + this.config.action + ")";
        this.err = ex;
      }
      return data;
    };

    Method.prototype.validateAuthToken = function() {
      var ref1;
      if (((ref1 = this.data) != null ? ref1.failuretype : void 0) === "UNAUTHORIZED") {
        API._EventRoot.trigger('api.unauthorized');
        this.err = new Error("Unauthorized API call.");
        return false;
      } else {
        return true;
      }
    };

    Method.prototype.handleResponse = function() {};

    Method.prototype.verifyParamTypes = function() {
      if (this.field_expects != null) {
        this.original_params = _.clone(this.params);
        return this.params = this.field_expects.getAttributesFrom(this.params, {
          null_strings: true,
          upstream: true
        });
      }
    };

    Method.prototype.verifyDataTypes = function() {
      if (this.field_schema != null) {
        this.rawdata = _.clone(this.data);
        return this.attributes = this.field_schema.getAttributesFrom(this.data, {
          downstream: true
        });
      } else {
        this.rawdata = this.data;
        return this.attributes = this.data;
      }
    };

    Method.prototype.triggerCallback = function() {
      var error, ex;
      try {
        if (this.err) {
          this._defer.reject(this.err, this.data, this.attributes);
        } else {
          this._defer.resolve(this.err, this.data, this.attributes);
        }
      } catch (error) {
        ex = error;
        if (typeof console !== "undefined" && console !== null) {
          console.log(this.config.name, ": Callback threw an exception", ex, ex.stack, this._defer, $.controller());
        }
      }
      if (this.deferredError) {
        throw this.deferredError;
      }
    };

    Method.prototype.raiseError = function(msg) {
      return this.deferredError = new Error(msg);
    };

    Method.defaultSettings = {
      requireToken: true,
      spinner: true
    };

    Method.configure = function(opts) {
      var key, klass, value;
      klass = this;
      if (opts.name == null) {
        throw new Error("Must specify a name!");
      }
      if (opts.action == null) {
        throw new Error("Must specify an action!");
      }
      klass.prototype.config = _.clone(this.defaultSettings);
      for (key in opts) {
        if (!hasProp.call(opts, key)) continue;
        value = opts[key];
        klass.prototype.config[key] = value;
      }
      API.CLASSES[opts.name] = klass;
      return API[opts.name] = this.defer_schema_parse(opts.name, klass);
    };

    Method.schema = function(builder) {
      var klass;
      klass = this;
      return klass.prototype._schema = builder;
    };

    Method.expects = function(builder) {
      var klass;
      klass = this;
      return klass.prototype._expects = builder;
    };

    Method.defer_schema_parse = function(name, klass) {
      return function(params, callback) {
        if (klass.prototype._schema) {
          klass.prototype.field_schema = new Schema(klass, klass.prototype._schema);
          klass.prototype._schema = null;
        }
        if (klass.prototype._expects) {
          klass.prototype.field_expects = new Schema(klass, klass.prototype._expects, true);
          klass.prototype._expects = null;
        }
        API[name] = klass.execute_command(klass);
        if (!(params != null ? params.parse_only : void 0)) {
          return API[name](params, callback);
        }
      };
    };

    Method.execute_command = function(klass) {
      return function(params, callback) {
        var cmd, ref1;
        if (callback == null) {
          ref1 = [callback, params], params = ref1[0], callback = ref1[1];
        }
        cmd = new klass(params, callback);
        _.defer(function() {
          return cmd.run();
        });
        return cmd.promise;
      };
    };

    return Method;

  })();

  API.PortalMethod = (function(superClass) {
    extend(PortalMethod, superClass);

    function PortalMethod() {
      return PortalMethod.__super__.constructor.apply(this, arguments);
    }

    PortalMethod.prototype.isCrossDomain = true;

    PortalMethod.prototype.buildUrl = function() {
      return portal_url(this.config.action);
    };

    return PortalMethod;

  })(API.Method);

  ApiField = (function() {
    function ApiField(schema1, opts1) {
      this.schema = schema1;
      this.opts = opts1 != null ? opts1 : {};
      this.isArray = this.opts.builder ? (this.subschema = new Schema(null, this.opts.builder), true) : false;
    }

    ApiField.prototype.populateAttributes = function(atts, data, opts) {
      var arr, i, inner_data, len, src_arr;
      if (!this.isArray) {
        return atts[this.opts.clientname] = this.formatData(data[this.opts.servername], opts);
      } else {
        arr = [];
        src_arr = data[this.opts.servername];
        if (_.isArray(src_arr)) {
          for (i = 0, len = src_arr.length; i < len; i++) {
            inner_data = src_arr[i];
            arr.push(this.subschema.getAttributesFrom(inner_data, opts));
          }
        }
        return atts[this.opts.clientname] = arr;
      }
    };

    ApiField.prototype.dataToDate = function(data, opts) {
      if ((data === null || _.isEmpty(data)) && this.opts.nullable) {
        return data;
      }
      if (_.isDate(data)) {
        return data;
      } else {
        if (opts.downstream) {
          return moment(String(data), DATE_FORMAT).toDate();
        } else {
          return moment(String(data), this.opts.format).toDate();
        }
      }
    };

    ApiField.prototype.dataToString = function(data, opts) {
      if (data === null || _.isUndefined(data) || data === "") {
        if (opts.null_strings) {
          return null;
        } else {
          return "";
        }
      } else {
        return String(data);
      }
    };

    ApiField.prototype.dataToNumber = function(data, opts) {
      if (!_.isUndefined(data) && data !== null && data !== '') {
        return Number(String(data).replace(NUMBER_STRIPPER_RE, ''));
      } else {
        return null;
      }
    };

    ApiField.prototype.dataToBoolean = function(data, opts) {
      return data === true || data === 'true' || data === 1 || data === '1' || data === 'on' || data === 'yes';
    };

    ApiField.prototype.formatData = function(data, opts) {
      var typed_data;
      typed_data = (function() {
        switch (this.opts.type) {
          case 'string':
            return this.dataToString(data, opts);
          case 'number':
            return this.dataToNumber(data, opts);
          case 'date':
            return this.dataToDate(data, opts);
          case 'boolean':
            return this.dataToBoolean(data, opts);
          default:
            throw new Error("UNKNOWN DATA TYPE: " + this.opts.type);
        }
      }).call(this);
      if (this.opts.type === 'date' && this.schema.upstream) {
        return Formatters.convert('serverdate', typed_data, this.opts);
      } else {
        return Formatters.convert(this.opts.format, typed_data, this.opts);
      }
    };

    return ApiField;

  })();

  Formatters = {
    _items: {},
    define: function(name, fn) {
      return this._items[name] = fn;
    },
    convert: function(name, data, opts) {
      var fmt;
      if (_.isFunction(name)) {
        return name(data);
      } else if (data === null || _.isUndefined(data)) {
        return data;
      } else if (fmt = this._items[name]) {
        return fmt(data);
      } else if (opts.type === 'date' && _.isString(name)) {
        return moment(data).format(name);
      } else {
        return data;
      }
    }
  };

  Formatters.define('phone', function(data) {
    var parts;
    if (parts = String(data).match(PHONE_PARTS_RE)) {
      return parts[1] + "-" + parts[2] + "-" + parts[3];
    } else {
      log("Cannot format " + data + " into phone number");
      return data;
    }
  });

  Formatters.define('serverdate', function(data) {
    return moment(data).format(DATE_FORMAT);
  });

  Formatters.define('currency', function(val) {
    return Number(Number(val).toFixed(2));
  });

  Schema = (function() {
    function Schema(klass1, builder1, upstream) {
      this.klass = klass1;
      this.builder = builder1;
      this.upstream = upstream != null ? upstream : false;
      this.fields = {};
      this.build();
    }

    Schema.prototype.getAttributesFrom = function(data, opts) {
      var atts, field, ref1, schema;
      if (opts == null) {
        opts = {};
      }
      atts = {};
      ref1 = this.fields;
      for (field in ref1) {
        if (!hasProp.call(ref1, field)) continue;
        schema = ref1[field];
        schema.populateAttributes(atts, data, opts);
      }
      return atts;
    };

    Schema.prototype.build = function() {
      return this.builder.call(this);
    };

    Schema.prototype.field = function(type, name, opts) {
      if (opts == null) {
        opts = {};
      }
      opts.name = name;
      opts.type = type;
      opts.clientname = opts.as || name;
      opts.servername = name;
      this.fields[name] = new ApiField(this, opts);
      return this;
    };

    Schema.prototype.number = function(name, opts) {
      return this.field('number', name, opts);
    };

    Schema.prototype.string = function(name, opts) {
      return this.field('string', name, opts);
    };

    Schema.prototype.date = function(name, opts) {
      return this.field('date', name, opts);
    };

    Schema.prototype.boolean = function(name, opts) {
      return this.field('boolean', name, opts);
    };

    Schema.prototype.bool = function(name, opts) {
      return this.boolean(name, opts);
    };

    Schema.prototype.array = function(name, fn) {
      return this.field('array', name, {
        builder: fn
      });
    };

    return Schema;

  })();

}).call(this);
;(function() {
  var Authenticate, ForgotPassword, IsAuthenticated, Logout,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Authenticate = (function(superClass) {
    extend(Authenticate, superClass);

    function Authenticate() {
      return Authenticate.__super__.constructor.apply(this, arguments);
    }

    Authenticate.configure({
      name: 'authenticate',
      action: 'AuthenticateUser',
      requireToken: false,
      requireParams: ['cellnumber', 'password']
    });

    return Authenticate;

  })(API.PortalMethod);

  ForgotPassword = (function(superClass) {
    extend(ForgotPassword, superClass);

    function ForgotPassword() {
      return ForgotPassword.__super__.constructor.apply(this, arguments);
    }

    ForgotPassword.configure({
      name: 'forgotPassword',
      action: 'ResetPassword',
      requireToken: false,
      requireParams: ['cellnumber']
    });

    return ForgotPassword;

  })(API.PortalMethod);

  IsAuthenticated = (function(superClass) {
    extend(IsAuthenticated, superClass);

    function IsAuthenticated() {
      return IsAuthenticated.__super__.constructor.apply(this, arguments);
    }

    IsAuthenticated.configure({
      name: 'isAuthenticated',
      action: 'IsAuthenticated',
      requireToken: true,
      spinner: false
    });

    return IsAuthenticated;

  })(API.PortalMethod);

  Logout = (function(superClass) {
    extend(Logout, superClass);

    function Logout() {
      return Logout.__super__.constructor.apply(this, arguments);
    }

    Logout.configure({
      name: 'logout',
      action: 'Logoff',
      requireToken: true
    });

    return Logout;

  })(API.PortalMethod);

}).call(this);
;(function() {
  var AddCreditCard, AddVehicle, ChangePassword, DeleteCreditCard, DeleteVehicle, GetAirlines, GetCreditCard, GetCreditCards, GetProfileDefaults, GetVehicle, HasExpiredCreditCards, Makes, Models, ProfileDefaults, ProfileDetails, ProfileVehicles, SetDefaultCreditCard, SetDefaultVehicle, UpdateCreditCard, UpdateProfileDetails, UpdateVehicle,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ProfileDetails = (function(superClass) {
    extend(ProfileDetails, superClass);

    function ProfileDetails() {
      return ProfileDetails.__super__.constructor.apply(this, arguments);
    }

    ProfileDetails.configure({
      name: 'profileDetails',
      action: 'GetProfile',
      requireTokenAndCell: true
    });

    ProfileDetails.schema(function() {
      this.string('firstname');
      this.string('lastname');
      this.string('emailaddress');
      this.string('altemailaddress');
      this.number('mobilephone', {
        format: 'phone'
      });
      this.number('homephone', {
        format: 'phone'
      });
      this.number('workphone', {
        format: 'phone'
      });
      return this.string('securityphrase');
    });

    return ProfileDetails;

  })(API.PortalMethod);

  UpdateProfileDetails = (function(superClass) {
    extend(UpdateProfileDetails, superClass);

    function UpdateProfileDetails() {
      return UpdateProfileDetails.__super__.constructor.apply(this, arguments);
    }

    UpdateProfileDetails.configure({
      name: 'updateProfileDetails',
      action: 'UpdateProfile',
      requireTokenAndCell: true
    });

    UpdateProfileDetails.expects(function() {
      this.string('adminid');
      this.string('firstname');
      this.string('lastname');
      this.string('emailaddress');
      this.string('altemailaddress');
      this.number('mobilephone');
      this.number('homephone');
      this.number('workphone');
      return this.string('securityphrase');
    });

    return UpdateProfileDetails;

  })(API.PortalMethod);

  ChangePassword = (function(superClass) {
    extend(ChangePassword, superClass);

    function ChangePassword() {
      return ChangePassword.__super__.constructor.apply(this, arguments);
    }

    ChangePassword.configure({
      name: 'changePassword',
      action: 'ChangePassword',
      requireTokenAndCell: true
    });

    ChangePassword.expects(function() {
      this.string('oldpassword');
      return this.string('newpassword');
    });

    return ChangePassword;

  })(API.PortalMethod);

  ProfileVehicles = (function(superClass) {
    extend(ProfileVehicles, superClass);

    function ProfileVehicles() {
      return ProfileVehicles.__super__.constructor.apply(this, arguments);
    }

    ProfileVehicles.configure({
      name: 'profileVehicles',
      action: 'GetVehicles',
      requireTokenAndCell: true
    });

    ProfileVehicles.schema(function() {
      return this.array('vehicles', function() {
        this.number('vehicleid');
        this.string('licensenumber');
        this.string('licensestate');
        this.string('make');
        this.string('model');
        this.number('year');
        this.string('color');
        return this.bool('isdefault');
      });
    });

    return ProfileVehicles;

  })(API.PortalMethod);

  AddVehicle = (function(superClass) {
    extend(AddVehicle, superClass);

    function AddVehicle() {
      return AddVehicle.__super__.constructor.apply(this, arguments);
    }

    AddVehicle.configure({
      name: 'addVehicle',
      action: 'AddVehicle',
      requireTokenAndCell: true
    });

    AddVehicle.expects(function() {
      this.string('licensenumber');
      this.string('licensestate');
      this.string('make');
      this.string('model');
      this.number('year');
      return this.string('color');
    });

    return AddVehicle;

  })(API.PortalMethod);

  UpdateVehicle = (function(superClass) {
    extend(UpdateVehicle, superClass);

    function UpdateVehicle() {
      return UpdateVehicle.__super__.constructor.apply(this, arguments);
    }

    UpdateVehicle.configure({
      name: 'updateVehicle',
      action: 'UpdateVehicle',
      requireTokenAndCell: true
    });

    UpdateVehicle.expects(function() {
      this.number('vehicleid');
      this.string('licensenumber');
      this.string('licensestate');
      this.string('make');
      this.string('model');
      this.number('year');
      return this.string('color');
    });

    return UpdateVehicle;

  })(API.PortalMethod);

  DeleteVehicle = (function(superClass) {
    extend(DeleteVehicle, superClass);

    function DeleteVehicle() {
      return DeleteVehicle.__super__.constructor.apply(this, arguments);
    }

    DeleteVehicle.configure({
      name: 'deleteVehicle',
      action: 'DeleteVehicle',
      requireTokenAndCell: true
    });

    DeleteVehicle.expects(function() {
      return this.number('vehicleid');
    });

    return DeleteVehicle;

  })(API.PortalMethod);

  SetDefaultVehicle = (function(superClass) {
    extend(SetDefaultVehicle, superClass);

    function SetDefaultVehicle() {
      return SetDefaultVehicle.__super__.constructor.apply(this, arguments);
    }

    SetDefaultVehicle.configure({
      name: 'setDefaultVehicle',
      action: 'SetDefaultVehicle',
      requireTokenAndCell: true
    });

    SetDefaultVehicle.expects(function() {
      return this.number('vehicleid');
    });

    return SetDefaultVehicle;

  })(API.PortalMethod);

  GetVehicle = (function(superClass) {
    extend(GetVehicle, superClass);

    function GetVehicle() {
      return GetVehicle.__super__.constructor.apply(this, arguments);
    }

    GetVehicle.configure({
      name: 'getVehicle',
      action: 'GetVehicle',
      requireTokenAndCell: true
    });

    GetVehicle.expects(function() {
      return this.number('vehicleid');
    });

    GetVehicle.schema(function() {
      this.number('vehicleid');
      this.string('licensenumber');
      this.string('licensestate');
      this.string('make');
      this.string('model');
      this.number('year');
      return this.string('color');
    });

    return GetVehicle;

  })(API.PortalMethod);

  Makes = (function(superClass) {
    extend(Makes, superClass);

    function Makes() {
      return Makes.__super__.constructor.apply(this, arguments);
    }

    Makes.configure({
      name: 'getVehicleMakes',
      action: 'GetAutoMakes'
    });

    Makes.schema(function() {
      return this.array('automakes', function() {
        this.number('makeid');
        return this.string('name');
      });
    });

    return Makes;

  })(API.PortalMethod);

  Models = (function(superClass) {
    extend(Models, superClass);

    function Models() {
      return Models.__super__.constructor.apply(this, arguments);
    }

    Models.configure({
      name: 'getVehicleModels',
      action: 'GetAutoModels'
    });

    Models.expects(function() {
      return this.number('makeid');
    });

    Models.schema(function() {
      return this.array('automodels', function() {
        this.number('modelid');
        return this.string('name');
      });
    });

    return Models;

  })(API.PortalMethod);

  HasExpiredCreditCards = (function(superClass) {
    extend(HasExpiredCreditCards, superClass);

    function HasExpiredCreditCards() {
      return HasExpiredCreditCards.__super__.constructor.apply(this, arguments);
    }

    HasExpiredCreditCards.configure({
      name: 'hasExpiredCreditCards',
      action: 'HasExpiredCreditCards',
      requireTokenAndCell: true
    });

    HasExpiredCreditCards.schema(function() {
      return this.bool('expiredcreditcards');
    });

    return HasExpiredCreditCards;

  })(API.PortalMethod);

  SetDefaultCreditCard = (function(superClass) {
    extend(SetDefaultCreditCard, superClass);

    function SetDefaultCreditCard() {
      return SetDefaultCreditCard.__super__.constructor.apply(this, arguments);
    }

    SetDefaultCreditCard.configure({
      name: 'setDefaultCreditCard',
      action: 'SetDefaultCreditCard',
      requireTokenAndCell: true
    });

    SetDefaultCreditCard.expects(function() {
      this.number('creditcardid');
      this.bool('parking', {
        "default": false
      });
      this.bool('services', {
        "default": false
      });
      return this.bool('tip', {
        "default": false
      });
    });

    return SetDefaultCreditCard;

  })(API.PortalMethod);

  GetCreditCards = (function(superClass) {
    extend(GetCreditCards, superClass);

    function GetCreditCards() {
      return GetCreditCards.__super__.constructor.apply(this, arguments);
    }

    GetCreditCards.configure({
      name: 'getCreditCards',
      action: 'GetCreditCards',
      requireTokenAndCell: true
    });

    GetCreditCards.schema(function() {
      return this.array('creditcards', function() {
        this.number('creditcardid');
        this.string('lastfourdigits');
        this.date('expdate');
        this.string('nameoncard');
        this.string('cardtype');
        this.bool('servicesdefault');
        this.bool('traveldefault');
        this.bool('tipdefault');
        this.string('description');
        this.string('address1');
        this.string('address2');
        this.string('city');
        this.string('state');
        return this.string('zip');
      });
    });

    return GetCreditCards;

  })(API.PortalMethod);

  GetCreditCard = (function(superClass) {
    extend(GetCreditCard, superClass);

    function GetCreditCard() {
      return GetCreditCard.__super__.constructor.apply(this, arguments);
    }

    GetCreditCard.configure({
      name: 'getCreditCard',
      action: 'GetCreditCard',
      requireTokenAndCell: true
    });

    GetCreditCard.expects(function() {
      return this.number('creditcardid');
    });

    GetCreditCard.schema(function() {
      this.number('creditcardid');
      this.string('lastfourdigits');
      this.string('nameoncard');
      this.string('cardtype');
      this.date('expdate');
      this.string('description');
      this.string('address1');
      this.string('address2');
      this.string('city');
      this.string('state');
      return this.string('zip');
    });

    return GetCreditCard;

  })(API.PortalMethod);

  AddCreditCard = (function(superClass) {
    extend(AddCreditCard, superClass);

    function AddCreditCard() {
      return AddCreditCard.__super__.constructor.apply(this, arguments);
    }

    AddCreditCard.configure({
      name: 'addCreditCard',
      action: 'AddCreditCard',
      requireTokenAndCell: true
    });

    AddCreditCard.expects(function() {
      this.string('cardnumber');
      this.string('nameoncard');
      this.string('cardtype');
      this.date('expdate');
      this.string('description');
      this.string('address1');
      this.string('address2');
      this.string('city');
      this.string('state');
      return this.string('zip');
    });

    return AddCreditCard;

  })(API.PortalMethod);

  UpdateCreditCard = (function(superClass) {
    extend(UpdateCreditCard, superClass);

    function UpdateCreditCard() {
      return UpdateCreditCard.__super__.constructor.apply(this, arguments);
    }

    UpdateCreditCard.configure({
      name: 'updateCreditCard',
      action: 'UpdateCreditCard',
      requireTokenAndCell: true
    });

    UpdateCreditCard.expects(function() {
      this.number('creditcardid');
      this.string('cardnumber');
      this.string('nameoncard');
      this.string('cardtype');
      this.date('expdate');
      this.string('description');
      this.string('address1');
      this.string('address2');
      this.string('city');
      this.string('state');
      return this.string('zip');
    });

    return UpdateCreditCard;

  })(API.PortalMethod);

  DeleteCreditCard = (function(superClass) {
    extend(DeleteCreditCard, superClass);

    function DeleteCreditCard() {
      return DeleteCreditCard.__super__.constructor.apply(this, arguments);
    }

    DeleteCreditCard.configure({
      name: 'deleteCreditCard',
      action: 'DeleteCreditCard',
      requireTokenAndCell: true
    });

    DeleteCreditCard.expects(function() {
      return this.number('creditcardid');
    });

    return DeleteCreditCard;

  })(API.PortalMethod);

  GetProfileDefaults = (function(superClass) {
    extend(GetProfileDefaults, superClass);

    function GetProfileDefaults() {
      return GetProfileDefaults.__super__.constructor.apply(this, arguments);
    }

    GetProfileDefaults.configure({
      name: 'getDefaults',
      action: 'GetProfileDefaults',
      requireTokenAndCell: true
    });

    GetProfileDefaults.schema(function() {
      this.string('defaultairline');
      this.number('defaultvehicle');
      this.string('defaultvehicledisplay');
      this.number('defaultcctravel');
      this.string('defaultcctraveldisplay');
      this.number('defaultccservices');
      this.string('defaultccservicesdisplay');
      this.number('defaultcctip');
      this.string('defaultcctipdisplay');
      return this.number('defaulttip');
    });

    return GetProfileDefaults;

  })(API.PortalMethod);

  ProfileDefaults = (function(superClass) {
    extend(ProfileDefaults, superClass);

    function ProfileDefaults() {
      return ProfileDefaults.__super__.constructor.apply(this, arguments);
    }

    ProfileDefaults.configure({
      name: 'updateDefaults',
      action: 'UpdateProfileDefaults',
      requireTokenAndCell: true
    });

    ProfileDefaults.expects(function() {
      this.string('defaultairline');
      this.string('defaultvehicle');
      this.string('defaultcctravel');
      this.string('defaultccservices');
      this.string('defaultcctip');
      return this.number('defaulttip');
    });

    return ProfileDefaults;

  })(API.PortalMethod);

  GetAirlines = (function(superClass) {
    extend(GetAirlines, superClass);

    function GetAirlines() {
      return GetAirlines.__super__.constructor.apply(this, arguments);
    }

    GetAirlines.configure({
      name: 'getAirlines',
      action: 'GetAirlineCodes'
    });

    GetAirlines.schema(function() {
      return this.array('airlinecodes', function() {
        this.string('code');
        return this.string('name');
      });
    });

    return GetAirlines;

  })(API.PortalMethod);

}).call(this);
;(function() {
  var GetAPIVersion, RandomQuote,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  RandomQuote = (function(superClass) {
    extend(RandomQuote, superClass);

    function RandomQuote() {
      return RandomQuote.__super__.constructor.apply(this, arguments);
    }

    RandomQuote.configure({
      name: 'getRandomQuote',
      action: 'GetCustomerQuote',
      requireToken: false,
      spinner: false
    });

    RandomQuote.schema(function() {
      this.string('Quote', {
        "default": '...',
        as: 'message'
      });
      this.string('CustomerName', {
        "default": 'Anonymous',
        as: 'author'
      });
      return this.date('DateCreated', {
        format: 'MMM YYYY',
        as: 'date'
      });
    });

    return RandomQuote;

  })(API.PortalMethod);

  GetAPIVersion = (function(superClass) {
    extend(GetAPIVersion, superClass);

    function GetAPIVersion() {
      return GetAPIVersion.__super__.constructor.apply(this, arguments);
    }

    GetAPIVersion.configure({
      name: 'apiVersion',
      action: 'GetAPIVersion',
      requireToken: false
    });

    return GetAPIVersion;

  })(API.PortalMethod);

}).call(this);
;(function() {
  var AddReservation, AddReservationWithServices, CancelReservation, GetActiveReservations, GetFlightInfo, GetFutureReservations, GetRawReservation, GetReservation, GetServices, LastFiveReservationHistory, RunningEarly, RunningLate, RunningOnTime, SearchReservationHistory, SendReceipt, UpdateDirection, UpdateLuggage, UpdateReservation, UpdateReservationWithServices, reservation_builder,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  reservation_builder = function() {
    this.number('orderid');
    this.string('customername');
    this.string('reservationnumber');
    this.string('specialinstructions');
    this.string('exitdirections');
    this.string('status');
    this.number('vehicleid');
    this.bool('international');
    this.bool('luggage');
    this.bool('runningearly');
    this.bool('runninglate');
    this.string('inairline');
    this.date('indate', {
      nullable: true,
      format: 'M/D/YYYY'
    });
    this.string('indeparturecity');
    this.date('indeparturetime', {
      nullable: true,
      format: 'h:mm A'
    });
    this.string('inflight');
    this.date('intime', {
      nullable: true,
      format: 'h:mm A'
    });
    this.string('indeparturegate');
    this.string('ingate');
    this.string('inbaggage');
    this.string('arrivalvalet');
    this.string('arrivalvaletthumbnail');
    this.string('arrivalvaletimage');
    this.string('outairline');
    this.string('outarrivalcity');
    this.date('outarrivaltime', {
      nullable: true,
      format: 'h:mm A'
    });
    this.date('outdate', {
      nullable: true,
      format: 'M/D/YYYY'
    });
    this.string('outflight');
    this.date('outmeetstart', {
      nullable: true,
      format: 'h:mm A'
    });
    this.date('outmeetend', {
      nullable: true,
      format: 'h:mm A'
    });
    this.date('outtime', {
      nullable: true,
      format: 'h:mm A'
    });
    this.string('outarrivalgate');
    this.bool('outcomplete');
    this.string('outgate');
    this.string('departurevalet');
    this.string('departurevaletthumbnail');
    this.string('departurevaletimage');
    this.string('departuredirections');
    this.string('inexitdirection');
    return this.string('outentrydirection');
  };

  SearchReservationHistory = (function(superClass) {
    extend(SearchReservationHistory, superClass);

    function SearchReservationHistory() {
      return SearchReservationHistory.__super__.constructor.apply(this, arguments);
    }

    SearchReservationHistory.configure({
      name: 'searchForReservations',
      action: 'GetReservationHistory',
      requireTokenAndCell: true
    });

    SearchReservationHistory.expects(function() {
      this.string('startdate');
      this.string('enddate');
      this.number('pagesize');
      return this.number('page');
    });

    SearchReservationHistory.schema(function() {
      this.array('reservations', reservation_builder);
      this.number('pages');
      this.number('pagesize');
      return this.number('records');
    });

    return SearchReservationHistory;

  })(API.PortalMethod);

  LastFiveReservationHistory = (function(superClass) {
    extend(LastFiveReservationHistory, superClass);

    function LastFiveReservationHistory() {
      return LastFiveReservationHistory.__super__.constructor.apply(this, arguments);
    }

    LastFiveReservationHistory.configure({
      name: 'lastFiveReservations',
      action: 'GetReservationHistory',
      requireTokenAndCell: true
    });

    LastFiveReservationHistory.expects(function() {
      this.string('startdate');
      this.string('enddate');
      this.number('pagesize');
      return this.number('page');
    });

    LastFiveReservationHistory.schema(function() {
      return this.array('reservations', reservation_builder);
    });

    return LastFiveReservationHistory;

  })(API.PortalMethod);

  GetReservation = (function(superClass) {
    extend(GetReservation, superClass);

    function GetReservation() {
      return GetReservation.__super__.constructor.apply(this, arguments);
    }

    GetReservation.configure({
      name: 'getReservation',
      action: 'GetReservation',
      requireTokenAndCell: true
    });

    GetReservation.expects(function() {
      return this.number('orderid');
    });

    GetReservation.schema(function() {
      this.number('orderid');
      this.string('reservationnumber');
      this.string('status');
      this.number('vehicleid');
      this.string('vehicledisplay');
      this.number('parkingcharge', {
        format: 'currency'
      });
      this.string('parkingcreditcardid');
      this.string('parkingcreditcarddisplay');
      this.date('outdate', {
        nullable: true,
        format: 'M/D/YYYY'
      });
      this.date('outtime', {
        nullable: true,
        format: 'h:mm A'
      });
      this.date('outmeetstart', {
        nullable: true,
        format: 'h:mm A'
      });
      this.date('outmeetend', {
        nullable: true,
        format: 'h:mm A'
      });
      this.string('outairline');
      this.string('outairlinename');
      this.string('outflight');
      this.string('outgate');
      this.string('outarrivalcity');
      this.string('outarrivalgate');
      this.date('outarrivaltime', {
        nullable: true,
        format: 'h:mm A'
      });
      this.date('indate', {
        nullable: true,
        format: 'M/D/YYYY'
      });
      this.date('intime', {
        nullable: true,
        format: 'h:mm A'
      });
      this.string('inairline');
      this.string('inairlinename');
      this.string('inflight');
      this.string('ingate');
      this.string('inbaggage');
      this.string('indeparturecity');
      this.string('indeparturegate');
      this.date('indeparturetime', {
        nullable: true,
        format: 'h:mm A'
      });
      this.bool('luggage');
      this.bool('international');
      this.string('specialinstructions');
      this.number('tip');
      this.string('tipcreditcardid');
      this.string('tipcreditcarddisplay');
      this.bool('canupdatedeparture');
      this.bool('canupdatearrival');
      this.bool('canaddservices');
      this.bool('cancancelreservation');
      this.bool('ishistory');
      this.string('inexitdirection');
      this.string('outentrydirection');
      return this.array('reservationservices', function() {
        this.number('serviceid');
        this.number('chargeid');
        this.number('backofficechargeid');
        this.number('creditcardid');
        this.string('creditcarddisplay');
        this.string('servicetype');
        this.number('quantity');
        this.number('rate');
        this.number('servicefee');
        this.number('totalcharge');
        this.bool('canupdateservice');
        this.string('status');
        this.string('grade');
        return this.bool('rainorshine');
      });
    });

    return GetReservation;

  })(API.PortalMethod);

  GetRawReservation = (function(superClass) {
    extend(GetRawReservation, superClass);

    function GetRawReservation() {
      return GetRawReservation.__super__.constructor.apply(this, arguments);
    }

    GetRawReservation.configure({
      name: 'getRawReservation',
      action: 'GetReservation',
      requireTokenAndCell: true
    });

    GetRawReservation.expects(function() {
      return this.number('orderid');
    });

    GetRawReservation.schema(function() {
      this.number('orderid');
      this.string('reservationnumber');
      this.string('status');
      this.number('vehicleid');
      this.string('vehicledisplay');
      this.number('parkingcharge');
      this.number('parkingcreditcardid');
      this.string('parkingcreditcarddisplay');
      this.date('outdate');
      this.date('outtime');
      this.date('outmeetstart');
      this.date('outmeetend');
      this.string('outairline');
      this.string('outairlinename');
      this.string('outflight');
      this.string('outarrivalcity');
      this.date('outarrivaltime');
      this.date('indate');
      this.date('intime');
      this.string('inairline');
      this.string('inairlinename');
      this.string('inflight');
      this.string('indeparturecity');
      this.date('indeparturetime');
      this.bool('luggage');
      this.bool('international');
      this.string('specialinstructions');
      this.number('tip');
      this.number('tipcreditcardid');
      this.string('tipcreditcarddisplay');
      this.bool('canupdatedeparture');
      this.bool('canupdatearrival');
      this.bool('canaddservices');
      this.bool('cancancelreservation');
      this.bool('ishistory');
      this.string('inexitdirection');
      this.string('outentrydirection');
      return this.array('reservationservices', function() {
        this.number('serviceid');
        this.number('chargeid');
        this.number('backofficechargeid');
        this.number('creditcardid');
        this.string('creditcarddisplay');
        this.string('servicetype');
        this.number('quantity');
        this.number('rate');
        this.number('servicefee');
        this.number('totalcharge');
        this.bool('canupdateservice');
        this.string('status');
        this.string('grade');
        return this.bool('rainorshine');
      });
    });

    return GetRawReservation;

  })(API.PortalMethod);

  SendReceipt = (function(superClass) {
    extend(SendReceipt, superClass);

    function SendReceipt() {
      return SendReceipt.__super__.constructor.apply(this, arguments);
    }

    SendReceipt.configure({
      name: 'sendReceipt',
      action: 'SendReceipt',
      requireTokenAndCell: true
    });

    SendReceipt.expects(function() {
      return this.number('orderid');
    });

    return SendReceipt;

  })(API.PortalMethod);

  GetActiveReservations = (function(superClass) {
    extend(GetActiveReservations, superClass);

    function GetActiveReservations() {
      return GetActiveReservations.__super__.constructor.apply(this, arguments);
    }

    GetActiveReservations.configure({
      name: 'getActiveReservations',
      action: 'GetActiveReservations',
      requireTokenAndCell: true
    });

    GetActiveReservations.schema(function() {
      return this.array('activereservations', reservation_builder);
    });

    return GetActiveReservations;

  })(API.PortalMethod);

  GetFutureReservations = (function(superClass) {
    extend(GetFutureReservations, superClass);

    function GetFutureReservations() {
      return GetFutureReservations.__super__.constructor.apply(this, arguments);
    }

    GetFutureReservations.configure({
      name: 'getFutureReservations',
      action: 'GetFutureReservations',
      requireTokenAndCell: true
    });

    GetFutureReservations.schema(function() {
      return this.array('futurereservations', reservation_builder);
    });

    return GetFutureReservations;

  })(API.PortalMethod);

  UpdateLuggage = (function(superClass) {
    extend(UpdateLuggage, superClass);

    function UpdateLuggage() {
      return UpdateLuggage.__super__.constructor.apply(this, arguments);
    }

    UpdateLuggage.configure({
      name: 'updateLuggage',
      action: 'UpdateLuggage',
      requireTokenAndCell: true
    });

    UpdateLuggage.expects(function() {
      this.number('reservationnumber');
      return this.bool('luggage');
    });

    return UpdateLuggage;

  })(API.PortalMethod);

  RunningEarly = (function(superClass) {
    extend(RunningEarly, superClass);

    function RunningEarly() {
      return RunningEarly.__super__.constructor.apply(this, arguments);
    }

    RunningEarly.configure({
      name: 'runningEarly',
      action: 'RunningEarly',
      requireTokenAndCell: true
    });

    RunningEarly.expects(function() {
      return this.number('reservationnumber');
    });

    return RunningEarly;

  })(API.PortalMethod);

  UpdateDirection = (function(superClass) {
    extend(UpdateDirection, superClass);

    function UpdateDirection() {
      return UpdateDirection.__super__.constructor.apply(this, arguments);
    }

    UpdateDirection.configure({
      name: 'updateDirection',
      action: 'UpdateDirection',
      requireTokenAndCell: true
    });

    UpdateDirection.expects(function() {
      this.number('reservationnumber');
      this.string('direction');
      return this.string('leg');
    });

    return UpdateDirection;

  })(API.PortalMethod);

  RunningOnTime = (function(superClass) {
    extend(RunningOnTime, superClass);

    function RunningOnTime() {
      return RunningOnTime.__super__.constructor.apply(this, arguments);
    }

    RunningOnTime.configure({
      name: 'runningOnTime',
      action: 'RunningOntime',
      requireTokenAndCell: true
    });

    RunningOnTime.expects(function() {
      return this.number('reservationnumber');
    });

    return RunningOnTime;

  })(API.PortalMethod);

  RunningLate = (function(superClass) {
    extend(RunningLate, superClass);

    function RunningLate() {
      return RunningLate.__super__.constructor.apply(this, arguments);
    }

    RunningLate.configure({
      name: 'runningLate',
      action: 'RunningLate',
      requireTokenAndCell: true
    });

    RunningLate.expects(function() {
      return this.number('reservationnumber');
    });

    return RunningLate;

  })(API.PortalMethod);

  GetServices = (function(superClass) {
    extend(GetServices, superClass);

    function GetServices() {
      return GetServices.__super__.constructor.apply(this, arguments);
    }

    GetServices.configure({
      name: 'getServices',
      action: 'GetServices'
    });

    GetServices.schema(function() {
      return this.array('services', function() {
        this.number('serviceid');
        this.string('type');
        this.string('servicename');
        this.string('servicedesc');
        this.number('unitrate');
        this.number('servicefee');
        this.bool('userainorshine');
        return this.bool('usegrade');
      });
    });

    return GetServices;

  })(API.PortalMethod);

  CancelReservation = (function(superClass) {
    extend(CancelReservation, superClass);

    function CancelReservation() {
      return CancelReservation.__super__.constructor.apply(this, arguments);
    }

    CancelReservation.configure({
      name: 'cancelReservation',
      action: 'CancelReservation',
      requireTokenAndCell: true
    });

    CancelReservation.expects(function() {
      this.number('orderid');
      return this.number('reservationnumber');
    });

    return CancelReservation;

  })(API.PortalMethod);

  AddReservationWithServices = (function(superClass) {
    extend(AddReservationWithServices, superClass);

    function AddReservationWithServices() {
      return AddReservationWithServices.__super__.constructor.apply(this, arguments);
    }

    AddReservationWithServices.configure({
      name: 'addReservationWithServices',
      action: 'AddReservationWithServices',
      requireTokenAndCell: true
    });

    AddReservationWithServices.expects(function() {
      this.bool('ismobile');
      this.number('vehicleid');
      this.string('parkingcreditcardid');
      this.string('outdate');
      this.string('outtime');
      this.string('outmeetstart');
      this.string('outairline');
      this.string('outflight');
      this.string('outarrivalcity');
      this.string('outarrivaltime');
      this.bool('luggage');
      this.bool('international');
      this.string('indate');
      this.string('intime');
      this.string('inairline');
      this.string('inflight');
      this.string('indeparturecity');
      this.string('indeparturetime');
      this.string('specialinstructions');
      this.string('tip');
      this.string('tipcreditcardid');
      this.string('inexitdirection');
      this.string('outentrydirection');
      return this.array('services', function() {
        this.number('serviceid');
        this.number('creditcardid');
        this.bool('rainorshine');
        return this.string('grade');
      });
    });

    return AddReservationWithServices;

  })(API.PortalMethod);

  AddReservation = (function(superClass) {
    extend(AddReservation, superClass);

    function AddReservation() {
      return AddReservation.__super__.constructor.apply(this, arguments);
    }

    AddReservation.configure({
      name: 'addReservation',
      action: 'AddReservation',
      requireTokenAndCell: true
    });

    AddReservation.expects(function() {
      this.bool('ismobile');
      this.number('vehicleid');
      this.string('parkingcreditcardid');
      this.string('outdate');
      this.string('outtime');
      this.string('outmeetstart');
      this.string('outairline');
      this.string('outflight');
      this.string('outarrivalcity');
      this.string('outarrivaltime');
      this.bool('luggage');
      this.bool('international');
      this.string('indate');
      this.string('intime');
      this.string('inairline');
      this.string('inflight');
      this.string('indeparturecity');
      this.string('indeparturetime');
      this.string('specialinstructions');
      this.string('tip');
      this.string('tipcreditcardid');
      this.string('inexitdirection');
      return this.string('outentrydirection');
    });

    return AddReservation;

  })(API.PortalMethod);

  GetFlightInfo = (function(superClass) {
    extend(GetFlightInfo, superClass);

    function GetFlightInfo() {
      return GetFlightInfo.__super__.constructor.apply(this, arguments);
    }

    GetFlightInfo.configure({
      name: 'getFlightInfo',
      action: 'GetFlightInfo'
    });

    GetFlightInfo.expects(function() {
      this.string('type');
      this.string('airline');
      this.string('flight');
      return this.string('date');
    });

    return GetFlightInfo;

  })(API.PortalMethod);

  UpdateReservationWithServices = (function(superClass) {
    extend(UpdateReservationWithServices, superClass);

    function UpdateReservationWithServices() {
      return UpdateReservationWithServices.__super__.constructor.apply(this, arguments);
    }

    UpdateReservationWithServices.configure({
      name: 'updateReservationWithServices',
      action: 'UpdateReservationWithServices',
      requireTokenAndCell: true
    });

    UpdateReservationWithServices.expects(function() {
      this.number('orderid');
      this.number('vehicleid');
      this.string('parkingcreditcardid');
      this.string('outdate');
      this.string('outtime');
      this.string('outmeetstart');
      this.string('outairline');
      this.string('outflight');
      this.string('outarrivalcity');
      this.string('outarrivaltime');
      this.bool('luggage');
      this.bool('international');
      this.string('indate');
      this.string('intime');
      this.string('inairline');
      this.string('inflight');
      this.string('indeparturecity');
      this.string('indeparturetime');
      this.string('specialinstructions');
      this.string('tip');
      this.string('tipcreditcardid');
      this.string('inexitdirection');
      this.string('outentrydirection');
      return this.array('services', function() {
        this.number('serviceid');
        this.number('creditcardid');
        this.bool('rainorshine');
        return this.string('grade');
      });
    });

    return UpdateReservationWithServices;

  })(API.PortalMethod);

  UpdateReservation = (function(superClass) {
    extend(UpdateReservation, superClass);

    function UpdateReservation() {
      return UpdateReservation.__super__.constructor.apply(this, arguments);
    }

    UpdateReservation.configure({
      name: 'updateReservation',
      action: 'UpdateReservation',
      requireTokenAndCell: true
    });

    UpdateReservation.expects(function() {
      this.number('orderid');
      this.number('vehicleid');
      this.string('parkingcreditcardid');
      this.string('outdate');
      this.string('outtime');
      this.string('outmeetstart');
      this.string('outairline');
      this.string('outflight');
      this.string('outarrivalcity');
      this.string('outarrivaltime');
      this.bool('luggage');
      this.bool('international');
      this.string('indate');
      this.string('intime');
      this.string('inairline');
      this.string('inflight');
      this.string('indeparturecity');
      this.string('indeparturetime');
      this.string('specialinstructions');
      this.string('tip');
      this.string('tipcreditcardid');
      this.string('inexitdirection');
      return this.string('outentrydirection');
    });

    return UpdateReservation;

  })(API.PortalMethod);

}).call(this);
;(function() {
  var GetConnectionString, TestDate, WaitForIt,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  GetConnectionString = (function(superClass) {
    extend(GetConnectionString, superClass);

    function GetConnectionString() {
      return GetConnectionString.__super__.constructor.apply(this, arguments);
    }

    GetConnectionString.configure({
      name: 'getConn',
      action: 'GetConnectionString',
      requireToken: true
    });

    return GetConnectionString;

  })(API.PortalMethod);

  WaitForIt = (function(superClass) {
    extend(WaitForIt, superClass);

    function WaitForIt() {
      return WaitForIt.__super__.constructor.apply(this, arguments);
    }

    WaitForIt.configure({
      name: 'testTimeout',
      action: 'WaitForIt',
      requireToken: false
    });

    WaitForIt.expects(function() {
      return this.number('seconds');
    });

    WaitForIt.prototype.handleResponse = function() {
      WaitForIt.__super__.handleResponse.apply(this, arguments);
      return console.log("RESPONSE:", this.data, this.err);
    };

    return WaitForIt;

  })(API.PortalMethod);

  TestDate = (function(superClass) {
    extend(TestDate, superClass);

    function TestDate() {
      return TestDate.__super__.constructor.apply(this, arguments);
    }

    TestDate.configure({
      name: 'testDate',
      action: 'TestDate',
      requireToken: false
    });

    TestDate.expects(function() {
      return this.string('test');
    });

    TestDate.prototype.handleResponse = function() {
      TestDate.__super__.handleResponse.call(this);
      return console.log("RESPONSE:", this.data, this.err, this.xhr.responseText);
    };

    return TestDate;

  })(API.PortalMethod);

}).call(this);
;(function() {
  var Api, NOOP,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  NOOP = function() {};

  Api = (function(superClass) {
    extend(Api, superClass);

    function Api() {
      return Api.__super__.constructor.apply(this, arguments);
    }

    Api.inject({
      events: 'events',
      location: 'location',
      log: ['Logger', Api],
      promise: '$q',
      root: '$rootScope'
    });

    Api.prototype.initialize = function() {
      this.log('initialize');
      this.lastResponse = null;
      API.setBaseUrl(this.location.url());
      API.setEventRoot(this.events);
      this.events.on('location.changed', (function(_this) {
        return function() {
          _this.log('location changed! Set URL to API!', _this.location.url());
          return API.setBaseUrl(_this.location.url());
        };
      })(this));
      this.events.on('spinner.show', (function(_this) {
        return function(event, command) {
          return _this.root.$broadcast('loading:show', '...');
        };
      })(this));
      return this.events.on('spinner.hide', (function(_this) {
        return function(event, command) {
          return _this.root.$broadcast('loading:hide', '...');
        };
      })(this));
    };

    Api.prototype.setAuthToken = function(token) {
      this.log('setting API auth token', token);
      if (token != null) {
        return API.setAuthToken(token);
      } else {
        return this.clearAuthToken();
      }
    };

    Api.prototype.clearAuthToken = function() {
      this.log('Clearing API auth token');
      return API.clearAuthToken();
    };

    Api.prototype.run = function(command, params, callback) {
      var Command, api_result, error, error1;
      if (params == null) {
        params = {};
      }
      if (callback == null) {
        callback = NOOP;
      }
      if (_.isFunction(params)) {
        callback = params;
        params = {};
      }
      api_result = this.promise.defer();
      try {
        Command = API[command];
        if (Command) {
          this.log('Running command:', command, params);
          Command(params, function() {}).always((function(_this) {
            return function(err, raw, data) {
              _this.lastResponse = {
                err: err,
                data: data,
                raw: raw
              };
              _this.log(command, 'Response:', _this.lastResponse);
              if ((raw != null ? raw.failuretype : void 0) === 'UNAUTHORIZED') {
                _this.log.warn("UNAUTHORIZED");
                _this.events.trigger('api.unauthorized');
              }
              if (err != null) {
                api_result.reject(err);
                return callback(err, null);
              } else {
                api_result.resolve(data);
                return callback(null, data);
              }
            };
          })(this));
        } else {
          this.log('Endpoint not found:', command);
          api_result.reject(new Error("Endpoint " + command + " not found!"));
        }
      } catch (error1) {
        error = error1;
        api_result.reject(error);
      }
      return api_result.promise;
    };

    return Api;

  })(App.Service);

}).call(this);
;(function() {
  var AppManager,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  AppManager = (function(superClass) {
    extend(AppManager, superClass);

    function AppManager() {
      return AppManager.__super__.constructor.apply(this, arguments);
    }

    AppManager.registerAs = 'app';

    AppManager.inject({
      api: 'api',
      auth: 'auth',
      cache: ['Session', 'fp-session', 'session'],
      config: 'config',
      data: 'data',
      errors: 'errors',
      events: 'events',
      location: 'location',
      log: ['Logger', AppManager],
      navigator: 'navigator',
      promise: '$q',
      root: '$rootScope',
      session: ['Session', 'fp-cache'],
      updater: 'updater'
    });

    AppManager.prototype.initialize = function() {
      var href;
      this.supportMultipleLocations = true;
      this.params = Object.fromQueryString(document.location.search, true);
      this.redirectTo = {
        name: 'main.secure.reservation-list',
        params: null
      };
      this.debug = 'debug' in this.params ? this.params.debug : this.config.debug;
      if (this.params.reset) {
        this.config.forget();
        href = document.location.href.replace('reset=true', '');
        document.location = href;
      }
      if (!this.supportMultipleLocations) {
        this.location.set('DFW');
        this.location._locked = true;
      }
      this.log('initialized!', this.api);
      window._app = this;
      return this.isEnabled = true;
    };

    AppManager.prototype.disable = function(err) {
      return this.isEnabled = false;
    };

    AppManager.prototype.goHome = function() {
      return this.navigateTo('main.welcome');
    };

    AppManager.prototype.onDataError = function(err) {
      return this.root.$broadcast('flash.error', "" + err);
    };

    AppManager.prototype.on = function(event, handler) {
      return this.events.on(event, handler);
    };

    AppManager.prototype.off = function(event, handler) {
      return this.events.off(event, handler);
    };

    AppManager.prototype.navigate = function() {
      var ref;
      return (ref = this.navigator) != null ? ref.go.apply(ref, arguments) : void 0;
    };

    AppManager.prototype.navigateTo = AppManager.prototype.navigate;

    AppManager.prototype.backOrNavigateTo = function() {
      var ref;
      return (ref = this.navigator) != null ? ref.backOrGo.apply(ref, arguments) : void 0;
    };

    return AppManager;

  })(App.Service);

}).call(this);
;(function() {
  var Auth,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Auth = (function(superClass) {
    extend(Auth, superClass);

    function Auth() {
      this._validate_didRun = bind(this._validate_didRun, this);
      this._authenticate_didRun = bind(this._authenticate_didRun, this);
      this._api_didError = bind(this._api_didError, this);
      return Auth.__super__.constructor.apply(this, arguments);
    }

    Auth.inject({
      api: 'api',
      cache: ['Session', 'fp-auth'],
      data: 'data',
      errors: 'errors',
      events: 'events',
      log: ['Logger', Auth],
      promise: '$q'
    });

    Auth.prototype.initialize = function() {
      var ref, whenReady;
      this.log('initialize');
      whenReady = this.promise.defer();
      this._token = this.cache.get('token');
      this.loggedIn = false;
      this.hasCreditHold = (ref = this._token) != null ? ref.credithold : void 0;
      this.ready = whenReady.promise;
      if (this.hasToken()) {
        this.api.setAuthToken(this._token);
        this.autoLogin().then((function(_this) {
          return function(data) {
            return whenReady.resolve(true);
          };
        })(this))["catch"]((function(_this) {
          return function() {
            return whenReady.resolve(true);
          };
        })(this));
      } else {
        whenReady.resolve(true);
      }
      return this.events.on('api.unauthorized', (function(_this) {
        return function() {
          _this._token = null;
          _this.api.setAuthToken(null);
          _this.loggedIn = false;
          _this.hasCreditHold = false;
          _this.log("API unauthorized, clearing auth info!");
          _this.cache.set('token', null);
          return _this.events.trigger('auth.changed', _this.loggedIn);
        };
      })(this));
    };

    Auth.prototype.hasToken = function() {
      return this._token != null;
    };

    Auth.prototype.welcomeMessage = function() {
      if (this._token != null) {
        return this._token.welcome || ' ';
      } else {
        return ' ';
      }
    };

    Auth.prototype.autoLogin = function() {
      var respond;
      respond = this.promise.defer();
      if (this.hasToken()) {
        this.api.setAuthToken(this._token);
        this.validate().then((function(_this) {
          return function(data) {
            var success;
            success = data.success;
            return respond.resolve({
              success: success
            });
          };
        })(this))["catch"]((function(_this) {
          return function(err) {
            return respond.resolve({
              success: false
            });
          };
        })(this));
      } else {
        respond.resolve({
          success: false
        });
      }
      return respond.promise;
    };

    Auth.prototype.login = function(formData) {
      var hostname, params;
      params = _.omit(formData, ['rememberme', 'location']);
      hostname = Host.isNative ? 'phonegap' : window.location.hostname.startsWith('192.168.') ? 'localhost' : window.location.hostname;
      params['key'] = md5(hostname + params.password);
      return this.api.run('authenticate', params).then(this._authenticate_didRun)["catch"](this._api_didError);
    };

    Auth.prototype.logout = function(param) {
      if (param == null) {
        param = {};
      }
      this.log('Logging out.');
      this._token = null;
      this.loggedIn = false;
      this.hasCreditHold = false;
      this.cache.set('token', null);
      this.data.clearCache();
      return this.api.run('logout').then((function(_this) {
        return function() {
          _this.api.setAuthToken(null);
          return _this.events.trigger('auth.changed', _this.loggedIn);
        };
      })(this))["catch"]((function(_this) {
        return function() {
          _this.api.setAuthToken(null);
          return _this.events.trigger('auth.changed', _this.loggedIn);
        };
      })(this));
    };

    Auth.prototype.validate = function() {
      return this.api.run('isAuthenticated').then(this._validate_didRun);
    };

    Auth.prototype._api_didError = function(error) {
      this.log("Login unsuccessful, clear api token and its cache!", error);
      this.cache.set('token', null);
      this.errors.show(error);
      return error;
    };

    Auth.prototype._authenticate_didRun = function(data) {
      var ref;
      if (data.success) {
        this.log("Login successful, assign api token and cache it.", data);
        this._token = _.pick(data, ['cellnumber', 'credithold', 'executives', 'isadmin', 'token', 'welcome']);
        this.log('Token:', this._token);
        this.cache.set('token', this._token);
        this.loggedIn = true;
        this.hasCreditHold = (ref = this._token) != null ? ref.credithold : void 0;
        this.api.setAuthToken(this._token);
      } else {
        this.log("Login unsuccessful, clear api token and its cache!", data);
        this.cache.set('token', null);
        this.errors.show(data.failure);
        this.loggedIn = false;
        this.api.setAuthToken(null);
      }
      this.events.trigger('auth.changed', this.loggedIn);
      return data;
    };

    Auth.prototype._validate_didRun = function(data) {
      this.log('IsAuthenticated:', data);
      if (data.success) {
        this.loggedIn = true;
      } else {
        this.loggedIn = false;
        this._token = null;
        this.cache.set('token', null);
        this.api.setAuthToken(null);
      }
      this.events.trigger('auth.changed', this.loggedIn);
      return data;
    };

    return Auth;

  })(App.Service);

}).call(this);
;(function() {
  var Config,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Config = (function(superClass) {
    extend(Config, superClass);

    function Config() {
      this.set = bind(this.set, this);
      this.save = bind(this.save, this);
      this.load = bind(this.load, this);
      return Config.__super__.constructor.apply(this, arguments);
    }

    Config.registerAs = 'config';

    Config.inject({
      log: ['Logger', Config],
      events: 'events',
      session: ['Session', 'fp-jobtracker']
    });

    Config.prototype.initialize = function() {
      this.log('initialize');
      this.debug = Host.isStaging || Host.isLocal;
      this.connectionInfo = true;
      return this.load();
    };

    Config.prototype.forget = function() {
      return this.session.clear();
    };

    Config.prototype.load = function() {
      var data;
      if (data = this.session.get('config')) {
        return this.set(data, false);
      }
    };

    Config.prototype.save = function() {
      return this.session.set({
        config: {
          debug: this.debug,
          connectionInfo: this.connectionInfo
        }
      });
    };

    Config.prototype.set = function(values, triggerChange) {
      var key, val;
      if (values == null) {
        values = {};
      }
      if (triggerChange == null) {
        triggerChange = true;
      }
      for (key in values) {
        if (!hasProp.call(values, key)) continue;
        val = values[key];
        this[key] = val;
      }
      if (triggerChange) {
        this.save();
        this.events.globalTrigger('config.change');
      }
      return this;
    };

    return Config;

  })(App.Service);

}).call(this);
;(function() {
  var Confirm,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Confirm = (function(superClass) {
    extend(Confirm, superClass);

    function Confirm() {
      return Confirm.__super__.constructor.apply(this, arguments);
    }

    Confirm.inject({
      log: ['Logger', Confirm],
      popup: '$ionicPopup'
    });

    Confirm.prototype.initialize = function() {
      return this.log("initialize");
    };

    Confirm.prototype.objectDelete = function(name) {};

    Confirm.prototype.mayLoseChanges = function(prefix) {
      if (prefix == null) {
        prefix = 'Leaving this screen';
      }
      return this.custom({
        title: "Unsaved Changes",
        template: "<p>" + prefix + " will lose any changes you've made.</p>"
      });
    };

    Confirm.prototype.logout = function() {};

    Confirm.prototype.custom = function(options) {
      return this.popup.confirm(options);
    };

    return Confirm;

  })(App.Service);

}).call(this);
;(function() {
  var Crud,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Crud = (function(superClass) {
    extend(Crud, superClass);

    function Crud() {
      return Crud.__super__.constructor.apply(this, arguments);
    }

    Crud.inject({
      log: ['Logger', Crud]
    });

    Crud.prototype.initialize = function() {
      return this.log('initialize');
    };

    return Crud;

  })(App.Service);

}).call(this);
;(function() {
  var CREDIT_CARD_TYPE_LIST, Data, STATE_LIST,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  Data = (function(superClass) {
    extend(Data, superClass);

    function Data() {
      this._bindDeleteApiCalls = bind(this._bindDeleteApiCalls, this);
      this._bindApiCalls = bind(this._bindApiCalls, this);
      this.getProfileDefaults = bind(this.getProfileDefaults, this);
      this.getProfileDetails = bind(this.getProfileDetails, this);
      return Data.__super__.constructor.apply(this, arguments);
    }

    Data.inject({
      api: 'api',
      delay: 'delay',
      errors: 'errors',
      log: ['Logger', Data],
      popup: '$ionicPopup',
      promise: '$q'
    });

    Data.prototype.initialize = function() {
      this.log('initialize');
      this.cache = {};
      this._bindApiCalls({
        cache: true
      }, 'getAirlines', 'getActiveReservations', 'getFutureReservations', 'profileVehicles', 'getVehicleMakes', 'getCreditCards', 'getDefaults', 'profileDetails', 'getServices', 'hasExpiredCreditCards');
      this._bindApiCalls({
        cache: false
      }, 'getVehicle', 'getVehicleModels', 'getCreditCard', 'getReservation', 'getRawReservation');
      return this._bindDeleteApiCalls({
        'Vehicle': 'deleteVehicle',
        'Credit Card': 'deleteCreditCard'
      });
    };

    Data.prototype.all = function(promises) {
      return this.promise.all(promises);
    };

    Data.prototype.allMerged = function(promises) {
      this.log('allMerged source:', promises);
      return this.promise.all(promises).then((function(_this) {
        return function(datalist) {
          var data, i, len, result;
          result = {};
          for (i = 0, len = datalist.length; i < len; i++) {
            data = datalist[i];
            _.extend(result, data);
          }
          _this.log('allMerged result:', result);
          return result;
        };
      })(this));
    };

    Data.prototype.callApi = function(apiName, params) {
      return this.api.run(apiName, params);
    };

    Data.prototype.clearCache = function(name) {
      this.log('clearCache', name, this.cache);
      if (name != null) {
        delete this.cache[name];
      } else {
        this.cache = {};
      }
      return this.log('clearCache (after)', this.cache);
    };

    Data.prototype.fetchPreflightData = function() {
      return this.allMerged([this.getAirlines(), this.getProfileDetails(), this.getProfileDefaults(), this.getActiveReservations(), this.getFutureReservations(), this.profileVehicles(), this.getVehicleMakes(), this.getCreditCards(), this.hasExpiredCreditCards()]);
    };

    Data.prototype.cardTypeList = function() {
      return CREDIT_CARD_TYPE_LIST;
    };

    Data.prototype.stateList = function() {
      return STATE_LIST;
    };

    Data.prototype.getProfileDetails = function() {
      return this.profileDetails().then(function(data) {
        return {
          profile: data
        };
      });
    };

    Data.prototype.getProfileDefaults = function() {
      return this.getDefaults().then(function(data) {
        return {
          defaults: data
        };
      });
    };

    Data.prototype._bindApiCalls = function() {
      var fn, i, len, name, names, options;
      options = arguments[0], names = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      fn = (function(_this) {
        return function(name, options) {
          return _this[name] = function(params, settings) {
            if (params == null) {
              params = {};
            }
            if (settings == null) {
              settings = {};
            }
            _this.log('-> name:', name, 'options:', options, 'params:', params, 'settings:', settings);
            if ((_this.cache[name] != null) && options.cache && !settings.refresh) {
              _this.log('Returning cached data!', name);
              return _this.cache[name].data;
            } else {
              _this.log('Calling API!', name);
              return _this.callApi(name, params).then(function(data) {
                if (options.cache) {
                  _this.cache[name] = {
                    data: _this.promise.resolve(data)
                  };
                }
                return data;
              });
            }
          };
        };
      })(this);
      for (i = 0, len = names.length; i < len; i++) {
        name = names[i];
        fn(name, options);
      }
      return this;
    };

    Data.prototype._bindDeleteApiCalls = function(conf, options) {
      if (options == null) {
        options = {};
      }
      Object.keys(conf).each((function(_this) {
        return function(type) {
          var apiName, deleteApiCall, methodName;
          methodName = "delete" + (type.replace(/\s/g, ''));
          apiName = conf[type];
          _this.log('define', methodName, '->', apiName);
          deleteApiCall = function(params, promise) {
            return _this.api.run(apiName, params).then(function(data) {
              if (data.success) {
                return promise.resolve({
                  deleted: true
                });
              } else {
                return promise.resolve({
                  deleted: false
                });
              }
            })["catch"](function(err) {
              _this.errors.show(err);
              return promise.resolve({
                deleted: false
              });
            });
          };
          return _this[methodName] = function(params, settings) {
            var result;
            if (params == null) {
              params = {};
            }
            if (settings == null) {
              settings = {};
            }
            _this.log('->', apiName);
            result = _this.promise.defer();
            if (!(options.prompt === false || settings.prompt === false)) {
              _this.popup.confirm({
                title: "Delete " + type + "?",
                template: "Removing this " + (type.toLowerCase()) + " cannot be undone."
              }).then(function(res) {
                _this.log("POPOVER RESPONSE:", res);
                if (res) {
                  return deleteApiCall(params, result);
                } else {
                  _this.log("Cancel!");
                  return result.resolve({
                    deleted: false
                  });
                }
              });
            } else {
              deleteApiCall(params, result);
            }
            return result.promise;
          };
        };
      })(this));
      return this;
    };

    return Data;

  })(App.Service);

  CREDIT_CARD_TYPE_LIST = [
    {
      code: 'Visa',
      name: 'Visa'
    }, {
      code: 'MasterCard',
      name: 'MasterCard'
    }, {
      code: 'AMEX',
      name: 'American Express'
    }, {
      code: 'Discover',
      name: 'Discover'
    }
  ];

  STATE_LIST = [
    {
      code: 'AL',
      name: "Alabama"
    }, {
      code: 'AK',
      name: "Alaska"
    }, {
      code: 'AZ',
      name: "Arizona"
    }, {
      code: 'AR',
      name: "Arkansas"
    }, {
      code: 'CA',
      name: "California"
    }, {
      code: 'CO',
      name: "Colorado"
    }, {
      code: 'CT',
      name: "Connecticut"
    }, {
      code: 'DE',
      name: "Delaware"
    }, {
      code: 'DC',
      name: "District Of Columbia"
    }, {
      code: 'FL',
      name: "Florida"
    }, {
      code: 'GA',
      name: "Georgia"
    }, {
      code: 'HI',
      name: "Hawaii"
    }, {
      code: 'ID',
      name: "Idaho"
    }, {
      code: 'IL',
      name: "Illinois"
    }, {
      code: 'IN',
      name: "Indiana"
    }, {
      code: 'IA',
      name: "Iowa"
    }, {
      code: 'KS',
      name: "Kansas"
    }, {
      code: 'KY',
      name: "Kentucky"
    }, {
      code: 'LA',
      name: "Louisiana"
    }, {
      code: 'ME',
      name: "Maine"
    }, {
      code: 'MD',
      name: "Maryland"
    }, {
      code: 'MA',
      name: "Massachusetts"
    }, {
      code: 'MI',
      name: "Michigan"
    }, {
      code: 'MN',
      name: "Minnesota"
    }, {
      code: 'MS',
      name: "Mississippi"
    }, {
      code: 'MO',
      name: "Missouri"
    }, {
      code: 'MT',
      name: "Montana"
    }, {
      code: 'NE',
      name: "Nebraska"
    }, {
      code: 'NV',
      name: "Nevada"
    }, {
      code: 'NH',
      name: "New Hampshire"
    }, {
      code: 'NJ',
      name: "New Jersey"
    }, {
      code: 'NM',
      name: "New Mexico"
    }, {
      code: 'NY',
      name: "New York"
    }, {
      code: 'NC',
      name: "North Carolina"
    }, {
      code: 'ND',
      name: "North Dakota"
    }, {
      code: 'OH',
      name: "Ohio"
    }, {
      code: 'OK',
      name: "Oklahoma"
    }, {
      code: 'OR',
      name: "Oregon"
    }, {
      code: 'PA',
      name: "Pennsylvania"
    }, {
      code: 'RI',
      name: "Rhode Island"
    }, {
      code: 'SC',
      name: "South Carolina"
    }, {
      code: 'SD',
      name: "South Dakota"
    }, {
      code: 'TN',
      name: "Tennessee"
    }, {
      code: 'TX',
      name: "Texas"
    }, {
      code: 'UT',
      name: "Utah"
    }, {
      code: 'VT',
      name: "Vermont"
    }, {
      code: 'VA',
      name: "Virginia"
    }, {
      code: 'WA',
      name: "Washington"
    }, {
      code: 'WV',
      name: "West Virginia"
    }, {
      code: 'WI',
      name: "Wisconsin"
    }, {
      code: 'WY',
      name: "Wyoming"
    }
  ];

}).call(this);
;(function() {
  var Errors,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Errors = (function(superClass) {
    extend(Errors, superClass);

    function Errors() {
      this.clear = bind(this.clear, this);
      this.error = bind(this.error, this);
      this.notify = bind(this.notify, this);
      this.warning = bind(this.warning, this);
      this["catch"] = bind(this["catch"], this);
      return Errors.__super__.constructor.apply(this, arguments);
    }

    Errors.inject({
      root: '$rootScope'
    });

    Errors.prototype["catch"] = function(message) {
      return (function(_this) {
        return function(reason) {
          return _this.error(message, reason);
        };
      })(this);
    };

    Errors.prototype.warning = function(message, ctx) {
      return this.root.$broadcast('flash.warning', message.message || message, ctx);
    };

    Errors.prototype.warn = Errors.prototype.warning;

    Errors.prototype.notify = function(message, ctx) {
      return this.root.$broadcast('flash.error', message, ctx);
    };

    Errors.prototype.info = function(message, ctx) {
      return this.root.$broadcast('flash.info', message, ctx);
    };

    Errors.prototype.error = function(message, reason) {
      var base, base1;
      if (message == null) {
        console.error("Trying to show a null error!", message, reason);
        return;
      }
      if (typeof message === 'string') {
        return typeof (base = this.root).addError === "function" ? base.addError({
          message: message,
          reason: reason
        }) : void 0;
      } else {
        return typeof (base1 = this.root).addError === "function" ? base1.addError(message) : void 0;
      }
    };

    Errors.prototype.show = Errors.prototype.error;

    Errors.prototype.clear = function() {
      return this.root.$broadcast('flash.clear');
    };

    Errors.run(function($rootScope) {
      $rootScope.errors = [];
      $rootScope.isDuplicateError = function(msg) {
        var errData, i, len, ref;
        return false;
        if (typeof console !== "undefined" && console !== null) {
          console.debug('checking for error in:', $rootScope.errors);
        }
        if ($rootScope.errors.length === 0) {
          return false;
        }
        ref = $rootScope.errors;
        for (i = 0, len = ref.length; i < len; i++) {
          errData = ref[i];
          if (msg === errData.message) {
            if (typeof console !== "undefined" && console !== null) {
              console.debug('YES: isDuplicateError', msg);
            }
            return true;
          }
        }
        if (typeof console !== "undefined" && console !== null) {
          console.debug('NO: isDuplicateError', msg);
        }
        return false;
      };
      return $rootScope.addError = function(err) {
        var errdata, msg;
        console.warn("ERROR DETECTED:", err);
        msg = err.message || err || "An unknown error has occurred.";
        errdata = {
          message: msg,
          reason: err
        };
        if ($rootScope.isDuplicateError(msg)) {
          return;
        }
        $rootScope.errors.push(errdata);
        if (!String(msg).has("replaceChild")) {
          return $rootScope.$broadcast('flash.error', msg);
        } else {
          return console.error("IGNORING ERROR:", msg);
        }
      };
    });

    return Errors;

  })(App.Service);

}).call(this);
;(function() {
  var EventCollector, EventCollectorNG, Events,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  Events = (function(superClass) {
    var _known_handlers;

    extend(Events, superClass);

    function Events() {
      return Events.__super__.constructor.apply(this, arguments);
    }

    _known_handlers = [];

    Events.inject({
      root: '$rootScope'
    });

    Events.prototype.initialize = function() {
      return this.root.$on('$destroy', (function(_this) {
        return function() {
          var handlers, i, len;
          for (i = 0, len = _known_handlers.length; i < len; i++) {
            handlers = _known_handlers[i];
            try {
              if (typeof handlers.dereg === "function") {
                handlers.dereg();
              }
            } catch (undefined) {}
          }
          return _known_handlers = [];
        };
      })(this));
    };

    Events.prototype.each = function(map) {
      var event, handler;
      for (event in map) {
        handler = map[event];
        this.on(event, handler);
      }
      return this;
    };

    Events.prototype.on = function(event, handler) {
      if (handler.dereg != null) {
        throw new Error("Event handler can only handle a single event!");
      }
      handler.dereg = this.root.$on(event, handler);
      _known_handlers.push(handler);
      return handler.dereg;
    };

    Events.prototype.once = function(event, handler) {
      var dereg;
      return dereg = this.root.$on(event, function() {
        try {
          return handler.apply(null, arguments);
        } finally {
          dereg();
        }
      });
    };

    Events.prototype.off = function(handler) {
      if (typeof handler.dereg === "function") {
        handler.dereg();
      }
      return this;
    };

    Events.prototype.trigger = function() {
      var data, event, ref;
      event = arguments[0], data = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      (ref = this.root).$emit.apply(ref, [event].concat(slice.call(data)));
      return this;
    };

    Events.prototype.fire = Events.prototype.trigger;

    Events.prototype.emit = Events.prototype.trigger;

    Events.prototype.globalTrigger = function() {
      var data, event, ref;
      event = arguments[0], data = 2 <= arguments.length ? slice.call(arguments, 1) : [];
      (ref = this.root).$broadcast.apply(ref, [event].concat(slice.call(data)));
      return this;
    };

    Events.prototype.broadcast = Events.prototype.globalTrigger;

    Events.prototype.scoped = function(scope) {
      return new EventCollector(scope, this);
    };

    Events.prototype.boundTo = Events.prototype.scoped;

    return Events;

  })(App.Service);

  EventCollector = (function() {
    function EventCollector(scope, events) {
      this.events = events;
      this.clear = bind(this.clear, this);
      this.add = bind(this.add, this);
      this.list = [];
      if (scope != null) {
        scope.$on('$destroy', this.clear);
      }
    }

    EventCollector.prototype.add = function(stop) {
      this.list.push(stop);
      return stop;
    };

    EventCollector.prototype.clear = function() {
      var i, len, ref, stop;
      ref = this.list;
      for (i = 0, len = ref.length; i < len; i++) {
        stop = ref[i];
        if (typeof stop === "function") {
          stop();
        }
      }
      return this;
    };

    EventCollector.prototype.on = function(event, fn) {
      var ev, handler, results;
      if (arguments.length === 1 && typeof event === 'object') {
        results = [];
        for (ev in map) {
          handler = map[ev];
          results.push(this.add(this.events.on(ev, handler)));
        }
        return results;
      } else {
        return this.add(this.events.on(event, fn));
      }
    };

    EventCollector.prototype.once = function(event, fn) {
      return this.add(this.events.once(event, fn));
    };

    return EventCollector;

  })();

  EventCollectorNG = (function(superClass) {
    extend(EventCollectorNG, superClass);

    function EventCollectorNG() {
      return EventCollectorNG.__super__.constructor.apply(this, arguments);
    }

    EventCollectorNG.registerAs = 'EventCollector';

    EventCollectorNG.inject();

    EventCollectorNG.prototype.initialize = function() {
      return EventCollector;
    };

    EventCollectorNG.factory = function() {
      return EventCollector;
    };

    return EventCollectorNG;

  })(App.Factory);

}).call(this);
;(function() {
  var LOCATIONS, Location, VALID_LOCATIONS,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  LOCATIONS = {
    DFW: {
      airport: 'D/FW International',
      url: 'https://www.freedomparkdfw.com',
      state: 'TX',
      phone: '18667275339',
      phoneDisplay: '(866) PARK-DFW'
    },
    PHX: {
      airport: 'Sky Harbor International',
      url: 'https://www.freedomparkphx.com',
      state: 'AZ',
      phone: '18447275749',
      phoneDisplay: '(844) PARK-PHX'
    }
  };

  VALID_LOCATIONS = Object.keys(LOCATIONS);

  Location = (function(superClass) {
    extend(Location, superClass);

    function Location() {
      return Location.__super__.constructor.apply(this, arguments);
    }

    Location.inject({
      cache: ['Session', 'fp-location'],
      events: 'events',
      log: ['Logger', Location]
    });

    Location.prototype.initialize = function() {
      this.log('initialize');
      this._locked = false;
      this._current = 'DFW';
      this._scryLocation();
      this.log('locked', this._locked);
      this.log('current', this._current);
      return this.log('url', this.url());
    };

    Location.prototype.get = function() {
      return this._current;
    };

    Location.prototype.state = function() {
      return LOCATIONS[this._current].state;
    };

    Location.prototype.airport = function() {
      return LOCATIONS[this._current].aiport;
    };

    Location.prototype.phone = function() {
      return LOCATIONS[this._current].phone;
    };

    Location.prototype.phoneDisplay = function() {
      return LOCATIONS[this._current].phoneDisplay;
    };

    Location.prototype.set = function(location) {
      if (this._locked) {
        return this.log.warn('Location locked. Cannot be changed.');
      } else if (this._isValidLocation(location)) {
        this._current = location;
        this.cache.set('current', this._current);
        return this.events.fire('location.changed');
      } else {
        return this.log.error('Invalid location:', location);
      }
    };

    Location.prototype.url = function() {
      return LOCATIONS[this._current].url;
      if (Host.isLocal) {
        return LOCATIONS[this._current].url;
      } else if (Host.isNative) {
        return LOCATIONS[this._current].url;
      } else {
        return "";
      }
    };

    Location.prototype._isValidLocation = function(location) {
      return VALID_LOCATIONS.indexOf(location) >= 0;
    };

    Location.prototype._scryLocation = function() {
      var location;
      if (document.location.hostname.endsWith('phx.com')) {
        this._current = 'PHX';
        return this._locked = true;
      } else if (document.location.hostname.endsWith('dfw.com')) {
        this._current = 'DFW';
        return this._locked = true;
      } else {
        location = this.cache.get('current');
        if (location != null) {
          return this._current = location;
        }
      }
    };

    return Location;

  })(App.Service);

}).call(this);
;(function() {
  var Navigator,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Navigator = (function(superClass) {
    extend(Navigator, superClass);

    function Navigator() {
      return Navigator.__super__.constructor.apply(this, arguments);
    }

    Navigator.inject({
      log: ['Logger', Navigator],
      ionicHistory: '$ionicHistory',
      state: '$state',
      delay: 'delay'
    });

    Navigator.prototype.go = function(stateName, params, options) {
      return this._changeState(stateName, params, options);
    };

    Navigator.prototype.goBack = function(stateName, params, options) {
      if (options == null) {
        options = {};
      }
      if (options.clearHistory == null) {
        options.clearHistory = true;
      }
      return this._changeState(stateName, params, options);
    };

    Navigator.prototype.backOrGo = function(stateName, params, options) {
      if (options == null) {
        options = {};
      }
      this.log("History length?", this);
      if (options.clearHistory == null) {
        options.clearHistory = true;
      }
      return this._changeState(stateName, params, options);
    };

    Navigator.prototype._changeState = function(stateName, params, options) {
      if (options == null) {
        options = {};
      }
      if (options.clearHistory) {
        delete options.clearHistory;
        this.ionicHistory.nextViewOptions({
          historyRoot: true
        });
        this.delay(100, (function(_this) {
          return function() {
            _this.log.info('Clearing history');
            return _this.ionicHistory.clearHistory();
          };
        })(this));
      }
      return this.state.go(stateName, params, options);
    };

    return Navigator;

  })(App.Service);

}).call(this);
;(function() {
  var Updater,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  this.SECONDS = 1000;

  this.MINUTES = 60 * SECONDS;

  Updater = (function(superClass) {
    extend(Updater, superClass);

    function Updater() {
      this.updateApp = bind(this.updateApp, this);
      return Updater.__super__.constructor.apply(this, arguments);
    }

    Updater.inject({
      log: ['Logger', Updater],
      promise: '$q'
    });

    Updater.prototype.initialize = function() {
      var error, error1;
      this.log('Initialize!');
      this.available = false;
      this.hasUpdate = false;
      try {
        this.deploy = new Ionic.Deploy();
        return this.available = true;
      } catch (error1) {
        error = error1;
        this.log.error('Ionic.Deploy error!', error);
        return alert("NO DEPLOY AVAILABLE!");
      }
    };

    Updater.prototype.checkForUpdates = function() {
      if (!this.available) {
        return false;
      }
      return this.deploy.check().then((function(_this) {
        return function(hasUpdate) {
          _this.log('Ionic Deploy: Update available: ', hasUpdate);
          return _this.hasUpdate = hasUpdate;
        };
      })(this), (function(_this) {
        return function(err) {
          return _this.log.error('Ionic Deploy: Unable to check for updates', err);
        };
      })(this));
    };

    Updater.prototype.watchForUpdates = function(interval, initialDelay) {
      var noop, updating_promise;
      updating_promise = this.promise.defer();
      if (interval == null) {
        interval = 10 * MINUTES;
      }
      if (initialDelay == null) {
        initialDelay = 10 * SECONDS;
      }
      noop = function() {};
      if (!this.available) {
        updating_promise.reject(new Error('Updater not available'));
        return updating_promise.promise;
      }
      this.log("Watching for updates every " + interval + "ms, after " + initialDelay + "ms.");
      this.deploy.watch({
        interval: interval,
        initialDelay: initialDelay
      }).then(noop, noop, (function(_this) {
        return function(hasUpdate) {
          _this.log("Is an update available?", hasUpdate);
          if (hasUpdate) {
            _this.log("Show updating modal dialog!");
            _this.hasUpdate = hasUpdate;
            updating_promise.resolve(true);
            return setTimeout(_this.updateApp, 3 * SECONDS);
          } else {
            return _this.log("No update available yet...");
          }
        };
      })(this));
      return updating_promise.promise;
    };

    Updater.prototype.updateApp = function() {
      if (!this.available) {
        return false;
      }
      return this.deploy.update().then((function(_this) {
        return function(res) {
          return _this.log('Ionic Deploy: Update Success! ', res);
        };
      })(this), (function(_this) {
        return function(err) {
          return _this.log.error('Ionic Deploy: Update error! ', err);
        };
      })(this), (function(_this) {
        return function(prog) {
          return _this.log('Ionic Deploy: Progress... ', prog);
        };
      })(this));
    };

    return Updater;

  })(App.Service);

}).call(this);
;(function() {
  var DATE_LIKE, Wizard, build_reservation, massageDates,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Wizard = (function(superClass) {
    extend(Wizard, superClass);

    function Wizard() {
      this._deferSave = bind(this._deferSave, this);
      this.saveDraft = bind(this.saveDraft, this);
      return Wizard.__super__.constructor.apply(this, arguments);
    }

    Wizard.inject({
      app: 'app',
      cache: ['Session', 'fp-res-wiz'],
      log: ['Logger', Wizard],
      promise: '$q',
      timeout: '$timeout'
    });

    Wizard.prototype.initialize = function() {
      this.log('initialize');
      return this._timer = null;
    };

    Wizard.prototype.newReservation = function() {
      if (this.hasDraft()) {
        return this.promise.resolve(this.getDraft());
      } else {
        return this.promise.resolve(this.buildReservation());
      }
    };

    Wizard.prototype.buildReservation = function() {
      return build_reservation(this.app.defaults);
    };

    Wizard.prototype.scheduleSave = function(data) {
      if (this._timer != null) {
        this.timeout.cancel(this._timer);
      }
      return this._timer = this.timeout(this._deferSave(data), 1000);
    };

    Wizard.prototype.saveDraft = function(source) {
      this.log('Saving draft', source);
      this.cache.set('draft', angular.toJson(source));
      return this._timer = null;
    };

    Wizard.prototype.clearDraft = function() {
      return this.cache.set('draft', null);
    };

    Wizard.prototype.hasDraft = function() {
      return this.cache.get('draft') != null;
    };

    Wizard.prototype.getDraft = function() {
      var draft, value;
      draft = this.cache.get('draft', false);
      if (draft != null) {
        value = massageDates(angular.fromJson(draft));
        value.$fromDraft = true;
        return value;
      } else {
        return null;
      }
    };

    Wizard.prototype._deferSave = function(data) {
      return (function(_this) {
        return function() {
          return _this.saveDraft(data);
        };
      })(this);
    };

    return Wizard;

  })(App.Service);

  build_reservation = function(defaults) {
    if (defaults == null) {
      defaults = {};
    }
    return {
      $fromDraft: false,
      ismobile: true,
      ishistory: false,
      canupdatedeparture: true,
      canupdatearrival: true,
      canaddservices: true,
      reservationservices: [],
      vehicleid: null,
      parkingcreditcardid: null,
      outairline: null,
      tip: null,
      tiptype: 'fixed',
      tipcreditcardid: null,
      luggage: false,
      international: false,
      outdate: '',
      outtime: '',
      outmeetstart: '',
      outflight: '',
      outarrivalcity: '',
      outarrivaltime: '',
      indate: '',
      intime: '',
      inairline: '',
      inflight: '',
      indeparturecity: '',
      indeparturetime: '',
      specialinstructions: '',
      inexitdirection: '',
      outentrydirection: ''
    };
  };

  DATE_LIKE = /\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}\.?\d{0,3}Z/i;

  massageDates = function(source) {
    var result;
    result = {};
    Object.keys(source).forEach(function(key) {
      var value;
      value = source[key];
      if (typeof value === 'string' && value.match(DATE_LIKE)) {
        value = new Date(value);
      }
      return result[key] = value;
    });
    return result;
  };

  this.DATE_LIKE = DATE_LIKE;

}).call(this);
;(function() {
  var Routes,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Routes = (function(superClass) {
    extend(Routes, superClass);

    function Routes() {
      return Routes.__super__.constructor.apply(this, arguments);
    }

    Routes.config(function($stateProvider, $urlRouterProvider) {
      $urlRouterProvider.otherwise('/main/home');
      return $stateProvider.state('main', {
        abstract: true,
        url: '/main',
        templateUrl: 'views/main/menu.html',
        controller: 'MenuController as menu',
        resolve: {
          preload: function(auth) {
            console.warn("> main > preload");
            return auth.ready.then(function(data) {
              console.warn("<- preload resolved");
              return data;
            });
          }
        }
      }).state('main.home', {
        url: '/home',
        views: {
          menuContent: {
            templateUrl: 'views/main/home.html',
            controller: 'HomeController as home'
          }
        },
        resolve: {
          beforeInit: function(preload) {
            console.warn("> main.home > beforeInit");
            return preload;
          }
        }
      }).state('main.welcome', {
        url: '/welcome',
        views: {
          menuContent: {
            templateUrl: 'views/screens/welcome/welcome.html',
            controller: 'WelcomeController as welcome'
          }
        },
        resolve: {
          beforeInit: function(preload) {
            return preload;
          }
        }
      }).state('main.login', {
        url: '/login',
        views: {
          menuContent: {
            templateUrl: 'views/screens/login/login.html',
            controller: 'LoginController as login'
          }
        },
        resolve: {
          beforeInit: function(preload) {
            return preload;
          }
        }
      }).state('main.reset', {
        url: '/reset/:cellnumber',
        views: {
          menuContent: {
            templateUrl: 'views/screens/reset/reset.html',
            controller: 'ResetController as reset'
          }
        },
        resolve: {
          beforeInit: function(preload) {
            return preload;
          },
          cellnumber: function($stateParams) {
            return $stateParams.cellnumber || '';
          }
        }
      }).state('main.secure', {
        url: '/secure',
        abstract: true,
        data: {
          secure: true
        },
        views: {
          menuContent: {
            templateUrl: 'views/screens/secure/secure.html',
            controller: 'SecureController as secure'
          }
        },
        resolve: {
          preflight: function(app, preload, auth, data, errors) {
            console.warn("> main.secure > preflight()");
            return data.fetchPreflightData()["catch"]((function(_this) {
              return function(err) {
                app.disable(err);
                console.warn("preflight data error!", err);
                errors.show(err);
                errors.warn("I'm sorry, there was a problem logging in. Please try again.");
                return err;
              };
            })(this));
          },
          auth_isLoggedIn: function(auth) {
            console.warn("> main.secure > auth_isLoggedIn()");
            return auth.loggedIn;
          }
        }
      }).state('main.secure.reservation-list', {
        url: '/reservation-list',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/reservation/reservation-list.html',
            controller: 'ReservationListController as reservations'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          reservations: function(preflight, data) {
            console.warn("> main.secure.reservation-list > reservations - preflight:", preflight);
            return data.allMerged([data.getActiveReservations(), data.getFutureReservations()]).then(function(data) {
              console.warn("<- reservations resolved", data);
              return data;
            });
          }
        }
      }).state('main.secure.reservation-detail', {
        url: '/reservation/:id',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/reservation/reservation-detail.html',
            controller: 'ReservationDetailController as reservation'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          reservation: function(preflight, data, $stateParams) {
            console.warn("> main.secure.reservation-detail > reservation - preflight:", preflight);
            return data.getReservation({
              orderid: $stateParams.id
            }).then(function(data) {
              console.warn("<- reservation resolved", data);
              return data;
            });
          }
        }
      }).state('main.secure.reservation-form', {
        url: '/reservation-form/:id',
        cache: false,
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/reservation/reservation-form.html',
            controller: 'ReservationFormController as reservationForm'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          services: function(data) {
            return data.getServices().then(function(data) {
              return data.services;
            }).then(function(data) {
              console.warn("<- services resolved", data);
              return data;
            });
          },
          mode: function($stateParams) {
            if ($stateParams.id === 'new') {
              return 'new';
            } else {
              return 'edit';
            }
          },
          reservation: function(preflight, data, wizard, $stateParams) {
            console.warn("> main.secure.reservation-form > reservations - preflight:", preflight);
            if ($stateParams.id === 'new') {
              return wizard.newReservation().then(function(data) {
                console.warn("<- reservation resolved (from wizard)", data);
                return data;
              });
            } else {
              return data.getRawReservation({
                orderid: $stateParams.id
              }).then(function(data) {
                console.warn("<- reservation resolved", data);
                return data;
              });
            }
          }
        }
      }).state('main.secure.contact', {
        url: '/contact',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/contact/contact.html',
            controller: 'ContactController as contact'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          }
        }
      }).state('main.secure.vehicle-list', {
        url: '/vehicle-list',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/vehicle/vehicle-list.html',
            controller: 'VehicleListController as vehicles'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          automakes: function(data) {
            return data.getVehicleMakes().then(function(data) {
              console.warn("<- makes resolved");
              return data.automakes;
            });
          },
          vehicles: function(preflight, data) {
            console.warn("> main.secure.vehicle-list > vehicles", preflight);
            return data.profileVehicles().then(function(response) {
              return response.vehicles;
            }).then(function(data) {
              console.warn("<- vehicles resolved");
              return data;
            });
          }
        }
      }).state('main.secure.credit-card-list', {
        url: '/credit-card-list',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/credit-card/credit-card-list.html',
            controller: 'CreditCardListController as creditCards'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          cards: function(preflight, data) {
            console.warn("> main.secure.credit-card-list > vehicles", preflight);
            return data.getCreditCards().then(function(response) {
              return response.creditcards;
            }).then(function(data) {
              console.warn("<- cards resolved", data);
              return data;
            });
          }
        }
      }).state('main.secure.defaults', {
        url: '/defaults',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/defaults/defaults.html',
            controller: 'DefaultsController as defaults'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          airlines: function(data, preflight) {
            return data.getAirlines().then(function(response) {
              return response.airlinecodes;
            }).then(function(data) {
              console.warn("<- airlinecodes resolved", data);
              return data;
            });
          },
          vehicles: function(data, preflight) {
            return data.profileVehicles().then(function(response) {
              return response.vehicles;
            }).then(function(data) {
              console.warn("<- vehicles resolved", data);
              return data;
            });
          },
          creditcards: function(data, preflight) {
            return data.getCreditCards().then(function(response) {
              return response.creditcards;
            }).then(function(data) {
              console.warn("<- creditcards resolved", data);
              return data;
            });
          },
          defaults: function(data, preflight) {
            return data.getProfileDefaults().then(function(response) {
              return response.defaults;
            }).then(function(data) {
              console.warn("<- defaults resolved", data);
              return data;
            });
          }
        }
      }).state('main.secure.reservation-history', {
        url: '/reservation-history',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/reservation/reservation-history.html',
            controller: 'ReservationHistoryController as reservationHistory'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          }
        }
      }).state('main.secure.reservation-search', {
        url: '/reservation-search?type&fromDate&toDate',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/reservation/reservation-results.html',
            controller: 'ReservationResultsController as reservationResults'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          }
        }
      }).state('main.secure.details', {
        url: '/details',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/profile/details.html',
            controller: 'ProfileDetailsController as details'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          },
          profile: function(data, preflight) {
            return data.getProfileDetails().then(function(response) {
              return response.profile;
            }).then(function(data) {
              console.warn("<- profile resolved", data);
              return data;
            });
          }
        }
      }).state('main.secure.change-password', {
        url: '/change-password',
        data: {
          secure: true
        },
        views: {
          securedContent: {
            templateUrl: 'views/screens/secure/change-password/change-password.html',
            controller: 'ChangePasswordController as changePassword'
          }
        },
        resolve: {
          beforeInit: function(preflight) {
            return preflight;
          }
        }
      });
    });

    return Routes;

  })(App.Base);

}).call(this);
;(function() {
  var HomeController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  HomeController = (function(superClass) {
    extend(HomeController, superClass);

    function HomeController() {
      return HomeController.__super__.constructor.apply(this, arguments);
    }

    HomeController.inject({
      app: 'app',
      auth: 'auth',
      initResult: 'beforeInit',
      events: 'events',
      log: ['Logger', HomeController]
    });

    HomeController.prototype.initialize = function() {
      this.log('initialize', this.initResult);
      if (this.auth.loggedIn) {
        this.log('Logged in, redirecting!', this.app.redirectTo);
        return this.app.navigateTo(this.app.redirectTo.name, this.app.redirectTo.params, {
          clearHistory: true
        });
      } else {
        this.log('NOT Logged in, redirecting!');
        return this.app.navigateTo('main.welcome', null, {
          clearHistory: true
        });
      }
    };

    return HomeController;

  })(App.Controller);

}).call(this);
;(function() {
  var MainController, WWW_LOCATIONS,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  WWW_LOCATIONS = {
    'www.new-customer': '/index.php?page_id=6157',
    'www.about-us': '/index.php?page_id=5836',
    'www.contact-us': '/index.php?page_id=6066'
  };

  MainController = (function(superClass) {
    extend(MainController, superClass);

    function MainController() {
      return MainController.__super__.constructor.apply(this, arguments);
    }

    MainController.inject({
      actionSheet: '$ionicActionSheet',
      app: 'app',
      api: 'api',
      auth: 'auth',
      delay: 'delay',
      errors: 'errors',
      events: 'events',
      log: ['Logger', MainController],
      modalHelper: 'modalHelper',
      popup: '$ionicPopup',
      scope: '$scope',
      uiState: '$state'
    });

    MainController.prototype.initialize = function() {
      this.log('initialize');
      this.scope.loggedIn = this.auth.loggedIn;
      this.events.on('auth.changed', (function(_this) {
        return function(event, isAuthenticated) {
          _this.log('auth.changed', event, isAuthenticated);
          return _this.scope.loggedIn = _this.auth.loggedIn;
        };
      })(this));
      this.events.on('location.changed', (function(_this) {
        return function(event, isAuthenticated) {
          _this.log('location.changed');
          return _this.location = _this.app.location.get();
        };
      })(this));
      this.modal = this.modalHelper.createFor(this, this.scope);
      this.apiVersion = '(loading...)';
      this.location = this.app.location.get();
      this.version = '2.0.111';
      return this.api.run('apiVersion').then((function(_this) {
        return function(ver) {
          _this.log('api version', ver);
          return _this.apiVersion = ver.version;
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          _this.log('error', err);
          return _this.apiVersion = '!';
        };
      })(this));
    };

    MainController.prototype.addReservation = function() {
      this.log('addReservation');
      return this.app.navigateTo('main.secure.reservation-form', {
        id: 'new'
      });
    };

    MainController.prototype.showAddReservation = function() {
      return !this.uiState.includes('main.secure.reservation-form');
    };

    MainController.prototype.logout = function() {
      this.log('logout');
      return this.popup.confirm({
        title: "Logout?"
      }).then((function(_this) {
        return function(res) {
          _this.log("LOGOUT:", res);
          if (res) {
            return _this.auth.logout().then(function() {
              return _this.app.navigateTo('main.welcome', null, {
                clearHistory: true
              });
            });
          }
        };
      })(this));
    };

    MainController.prototype.navigateTo = function(location, params, options) {
      if (options == null) {
        options = {};
      }
      return this.delay(10, (function(_this) {
        return function() {
          var base_url, full_url, uri;
          if (location.startsWith('www.')) {
            if (uri = WWW_LOCATIONS[location]) {
              base_url = _this.app.location.url();
              full_url = "" + base_url + uri;
              _this.log.info("Browse to: " + uri);
              return window.open(full_url, '_system');
            } else {
              throw new Error("Url not found for: " + location);
            }
          } else {
            return _this.app.navigate(location, params, options);
          }
        };
      })(this));
    };

    MainController.prototype.navigateRoot = function(location, params, options) {
      if (options == null) {
        options = {};
      }
      options.clearHistory = true;
      return this.navigateTo(location, params, options);
    };

    return MainController;

  })(App.Controller);

}).call(this);
;(function() {
  var MenuController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  MenuController = (function(superClass) {
    extend(MenuController, superClass);

    function MenuController() {
      this.setHeaderMsg = bind(this.setHeaderMsg, this);
      return MenuController.__super__.constructor.apply(this, arguments);
    }

    MenuController.inject({
      app: 'app',
      auth: 'auth',
      didAutoLogin: 'preload',
      events: 'events',
      log: ['Logger', MenuController],
      scope: '$scope'
    });

    MenuController.prototype.initialize = function() {
      this.log('initialize');
      this.log(' - didAutoLogin?', this.didAutoLogin);
      this.setHeaderMsg();
      this.events.on('auth.changed', this.setHeaderMsg);
      return this.events.on('api.unauthorized', (function(_this) {
        return function() {
          _this.log('No longer logged in, redirecting!');
          return _this.app.navigateTo('main.welcome', null, {
            clearHistory: true
          });
        };
      })(this));
    };

    MenuController.prototype.setHeaderMsg = function() {
      return this.headerMessage = this.auth.welcomeMessage();
    };

    return MenuController;

  })(App.Controller);

}).call(this);
;(function() {
  var LoginController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  LoginController = (function(superClass) {
    extend(LoginController, superClass);

    function LoginController() {
      this.locationChanged = bind(this.locationChanged, this);
      this.navigateToReservationList = bind(this.navigateToReservationList, this);
      this.checkForExpiredCards = bind(this.checkForExpiredCards, this);
      this.didAuthenticate = bind(this.didAuthenticate, this);
      return LoginController.__super__.constructor.apply(this, arguments);
    }

    LoginController.inject({
      app: 'app',
      data: 'data',
      api: 'api',
      cache: ['Session', 'fp-username'],
      errors: 'errors',
      log: ['Logger', LoginController],
      scope: '$scope'
    });

    LoginController.prototype.initialize = function() {
      this.log('initialize');
      this.error = null;
      this.locationDisabled = !this.app.supportMultipleLocations;
      this.showLocation = Host.isNative || Host.isStaging || Host.isLocal;
      this.formDisabled = false;
      this.loginInProgress = false;
      this.form = {
        cellnumber: this.cache.get('username') || '',
        password: '',
        location: this.app.location.get(),
        rememberme: this.cache.get('remember') || false
      };
      this.scope.$on('$ionicView.enter', (function(_this) {
        return function() {
          return _this.loginInProgress = false;
        };
      })(this));
      return this.scope.$on('$ionicView.leave', (function(_this) {
        return function() {
          return _this.loginInProgress = false;
        };
      })(this));
    };

    LoginController.prototype.authenticate = function(form) {
      if (form.$valid) {
        this.formDisabled = true;
        this.loginInProgress = true;
        this.errors.clear();
        return this.app.auth.login(this.form).then(this.didAuthenticate).then(this.checkForExpiredCards).then((function(_this) {
          return function(data) {
            _this.formDisabled = false;
            if (data.success) {
              return data;
            } else {
              _this.loginInProgress = false;
              return data;
            }
          };
        })(this)).then(this.navigateToReservationList);
      }
    };

    LoginController.prototype.didAuthenticate = function(data) {
      this.log('didAuthenticate', data);
      if (data.success) {
        this.log('Logged in!');
        this.errors.info(data.welcome, 5 * 1000);
        this.form.password = '';
        if (this.form.rememberme) {
          this.cache.set('username', this.form.cellnumber);
          this.cache.set('remember', true);
        } else {
          this.form.username = '';
          this.form.cellnumber = '';
          this.cache.set('username', '');
          this.cache.set('remember', false);
        }
      }
      return data;
    };

    LoginController.prototype.checkForExpiredCards = function(data) {
      if (data.success) {
        this.data.hasExpiredCreditCards().then((function(_this) {
          return function(result) {
            if (result.expiredcreditcards) {
              _this.errors.warn("You have recently expired credit card(s).  You may optionally update the expiration date under in the Credit Cards section.");
            }
            return result;
          };
        })(this));
      }
      return data;
    };

    LoginController.prototype.navigateToReservationList = function(data) {
      this.log('navigateToReservationList');
      if (data.success) {
        return this.app.navigateTo('main.secure.reservation-list', null, {
          clearHistory: true
        });
      }
    };

    LoginController.prototype.locationChanged = function() {
      return this.app.location.set(this.form.location);
    };

    return LoginController;

  })(App.Controller);

}).call(this);
;(function() {
  var ResetController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ResetController = (function(superClass) {
    extend(ResetController, superClass);

    function ResetController() {
      this.locationChanged = bind(this.locationChanged, this);
      return ResetController.__super__.constructor.apply(this, arguments);
    }

    ResetController.inject({
      app: 'app',
      cache: ['Session', 'fp-username'],
      cellnumber: 'cellnumber',
      confirm: 'confirm',
      data: 'data',
      errors: 'errors',
      log: ['Logger', ResetController],
      scrollDelegate: '$ionicScrollDelegate'
    });

    ResetController.prototype.initialize = function() {
      this.log('initialize');
      this.errors.clear();
      this.emailFailure = false;
      this.locationDisabled = !this.app.supportMultipleLocations;
      this.showLocation = Host.isNative || Host.isStaging || Host.isLocal;
      return this.formData = {
        cellnumber: this.cellnumber,
        location: this.app.location.get()
      };
    };

    ResetController.prototype.save = function(form) {
      if (form.$valid) {
        this.errors.clear();
        return this.data.callApi('forgotPassword', this.formData).then((function(_this) {
          return function(result) {
            if (result.success && result.emailsent) {
              _this.errors.info("A temporary password should arrive in your inbox shortly.", 3000);
              _this.formData = {
                cellnumber: _this.cache.get('username') || '',
                location: _this.app.location.get()
              };
              return _this.app.navigateTo('main.login');
            } else {
              if (result.success) {
                _this.errors.warn("Email failure.", 3000);
                return _this.emailFailture = true;
              } else {
                return _this.errors.show(result.failure);
              }
            }
          };
        })(this))["catch"]((function(_this) {
          return function(err) {
            return _this.errors.show(err);
          };
        })(this));
      } else {
        return this.log('Nothing to save', form);
      }
    };

    ResetController.prototype.cancel = function(form) {
      return this.app.navigateTo('main.login');
    };

    ResetController.prototype.locationChanged = function() {
      return this.app.location.set(this.formData.location);
    };

    return ResetController;

  })(App.Controller);

}).call(this);
;(function() {
  var SecureController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  SecureController = (function(superClass) {
    extend(SecureController, superClass);

    function SecureController() {
      return SecureController.__super__.constructor.apply(this, arguments);
    }

    SecureController.inject({
      app: 'app',
      auth: 'auth',
      isLoggedIn: 'auth_isLoggedIn',
      log: ['Logger', SecureController]
    });

    SecureController.prototype.initialize = function() {
      return this.log('initialize', this);
    };

    return SecureController;

  })(App.Controller);

}).call(this);
;(function() {
  var ChangePasswordController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ChangePasswordController = (function(superClass) {
    extend(ChangePasswordController, superClass);

    function ChangePasswordController() {
      return ChangePasswordController.__super__.constructor.apply(this, arguments);
    }

    ChangePasswordController.inject({
      confirm: 'confirm',
      data: 'data',
      errors: 'errors',
      log: ['Logger', ChangePasswordController],
      scrollDelegate: '$ionicScrollDelegate'
    });

    ChangePasswordController.directive('compareTo', {
      restrict: 'A',
      require: "ngModel",
      scope: {
        otherModelValue: '=compareTo'
      },
      link: function(scope, elem, attr, ngModel) {
        ngModel.$validators.compareTo = function(modelValue) {
          return modelValue === scope.otherModelValue;
        };
        return scope.$watch("otherModelValue", function() {
          return ngModel.$validate();
        });
      }
    });

    ChangePasswordController.prototype.initialize = function() {
      this.log('initialize');
      return this.formData = {};
    };

    ChangePasswordController.prototype.save = function(form) {
      if (form.$dirty) {
        if (this.formData.newpassword !== this.formData.confirmpassword) {
          this.errors.clear();
          this.errors.show(new Error("New Password and Confirm Password must be the same."));
          return;
        }
        this.errors.clear();
        return this.data.callApi('changePassword', this.formData).then((function(_this) {
          return function(result) {
            if (result.success) {
              _this.errors.info("Saved new password.", 3000);
              return _this.formData = {};
            } else {
              return _this.errors.show(result.failure);
            }
          };
        })(this))["catch"]((function(_this) {
          return function(err) {
            return _this.errors.show(err);
          };
        })(this));
      } else {
        return this.log('Nothing to save');
      }
    };

    ChangePasswordController.prototype.cancel = function(form) {
      if (form.$dirty) {
        return this.confirm.mayLoseChanges('This').then((function(_this) {
          return function(confirmed) {
            if (confirmed) {
              _this.formData = {};
              _this.errors.clear();
              return _this.scrollDelegate.scrollTop(true);
            }
          };
        })(this));
      } else {
        this.errors.clear();
        return this.scrollDelegate.scrollTop(true);
      }
    };

    return ChangePasswordController;

  })(App.Controller);

}).call(this);
;(function() {
  var ContactController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ContactController = (function(superClass) {
    extend(ContactController, superClass);

    function ContactController() {
      return ContactController.__super__.constructor.apply(this, arguments);
    }

    ContactController.inject({
      app: 'app',
      log: ['Logger', ContactController],
      scope: '$scope'
    });

    ContactController.prototype.initialize = function() {
      this.log('initialize');
      this.location = this.app.location.get();
      return this.scope.$on('$ionicView.enter', (function(_this) {
        return function() {
          return _this.location = _this.app.location.get();
        };
      })(this));
    };

    return ContactController;

  })(App.Controller);

}).call(this);
;(function() {
  var CreditCardDetailController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CreditCardDetailController = (function(superClass) {
    extend(CreditCardDetailController, superClass);

    function CreditCardDetailController() {
      return CreditCardDetailController.__super__.constructor.apply(this, arguments);
    }

    CreditCardDetailController.inject({
      confirm: 'confirm',
      data: 'data',
      errors: 'errors',
      log: ['Logger', CreditCardDetailController],
      scope: '$scope'
    });

    CreditCardDetailController.prototype.initialize = function() {
      this.log('initialize', this);
      this.stateList = this.data.stateList();
      this.cardTypeList = this.data.cardTypeList();
      return this.scope.$on('modal.shown', (function(_this) {
        return function() {
          _this.detail = _this.scope.detail || {};
          _this.formData = _.clone(_this.detail);
          _this.mode = _this.scope.mode || 'new';
          _this.title = _this.mode === 'new' ? 'New Credit Card' : "Credit Card";
          if (_this.scope.form != null) {
            _this.log("FORM RESET!");
            _this.scope.form.$setPristine();
            return _this.scope.form.$setUntouched();
          } else {
            return _this.log("NO FORM!");
          }
        };
      })(this));
    };

    CreditCardDetailController.prototype.save = function(form) {
      var action, params, ref;
      if (form.$valid && !form.$pristine) {
        action = this.mode === 'edit' ? 'updateCreditCard' : 'addCreditCard';
        this.log('save', action);
        this.errors.clear();
        params = _.clone(this.formData);
        params.cardnumber = ((ref = params.lastfourdigits) != null ? ref.length : void 0) === 4 ? null : params.lastfourdigits;
        params.expdate = moment(params.expdate).date(1).add('months', 1).subtract('days', 1).toDate();
        this.log('params:', params);
        return this.data.callApi(action, params).then((function(_this) {
          return function(result) {
            _this.log('Save result:', result);
            if (result.success) {
              _this.errors.info('Saved!', 3000);
              _this.data.clearCache('getCreditCards');
              return _this.scope.closeActiveModal(result);
            } else {
              return _this.errors.show(result.failure);
            }
          };
        })(this))["catch"]((function(_this) {
          return function(error) {
            _this.log.warn('Save error:', error);
            return _this.errors.show(error);
          };
        })(this));
      } else {
        return this.log('Not saving: Form invalid or pristine.');
      }
    };

    CreditCardDetailController.prototype.cancel = function(form) {
      this.log('cancel', this.scope, form);
      this.errors.clear();
      if (form != null ? form.$dirty : void 0) {
        return this.confirm.mayLoseChanges().then((function(_this) {
          return function(doIt) {
            if (doIt) {
              return _this.scope.closeActiveModal({
                cancel: true
              });
            }
          };
        })(this));
      } else {
        return this.scope.closeActiveModal({
          cancel: true
        });
      }
    };

    CreditCardDetailController.prototype["delete"] = function(form) {
      var card;
      this.errors.clear();
      card = this.scope.detail || this.formData;
      return this.data.deleteCreditCard(card).then((function(_this) {
        return function(result) {
          _this.log('delete result:', result);
          if (result.deleted) {
            _this.log('BE GONE!');
            return _this.scope.closeActiveModal({
              cancel: false,
              success: true,
              "delete": true
            });
          } else {
            return _this.log('Oops... Not gone.', result);
          }
        };
      })(this));
    };

    return CreditCardDetailController;

  })(App.Controller);

}).call(this);
;(function() {
  var CreditCardListController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CreditCardListController = (function(superClass) {
    extend(CreditCardListController, superClass);

    function CreditCardListController() {
      this.defaultLabelsFor = bind(this.defaultLabelsFor, this);
      this.isDefaulted = bind(this.isDefaulted, this);
      this.cardExpDate = bind(this.cardExpDate, this);
      this.getDetailModal = bind(this.getDetailModal, this);
      return CreditCardListController.__super__.constructor.apply(this, arguments);
    }

    CreditCardListController.inject({
      app: 'app',
      confirm: 'confirm',
      data: 'data',
      delay: 'delay',
      errors: 'errors',
      filter: '$filter',
      listView: '$ionicListDelegate',
      list: 'cards',
      log: ['Logger', CreditCardListController],
      modalHelper: 'modalHelper',
      scope: '$scope'
    });

    CreditCardListController.prototype.initialize = function() {
      this.log('initialize', this.list);
      this.thisMonth = moment().endOf('month');
      this.log('End of this month:', this.thisMonth);
      return this.delay(500, this.getDetailModal);
    };

    CreditCardListController.prototype.getDetailModal = function() {
      if (this.detailModal != null) {
        return this.detailModal;
      } else {
        this.detailModal = this.modalHelper.createForUrl('views/screens/secure/credit-card/credit-card-detail.html', this, this.scope);
        return this.detailModal;
      }
    };

    CreditCardListController.prototype.view = function(card) {
      this.log('view', {
        id: card.creditcardid
      });
      this.listView.closeOptionButtons();
      this.errors.clear();
      this.scope.detail = card;
      this.scope.mode = 'edit';
      return this.getDetailModal().show({
        detail: card,
        mode: 'edit'
      }).then((function(_this) {
        return function(response) {
          _this.log.warn(">> Modal RESPONSE", response);
          if ((response != null) && response.success) {
            return _this.refreshData();
          }
        };
      })(this));
    };

    CreditCardListController.prototype.create = function() {
      this.log('create()');
      this.listView.closeOptionButtons();
      this.scope.detail = {};
      this.scope.mode = 'new';
      this.errors.clear();
      return this.getDetailModal().show({
        detail: {},
        mode: 'new'
      }).then((function(_this) {
        return function(response) {
          _this.log.warn(">> Modal RESPONSE", response);
          if ((response != null) && response.success) {
            return _this.refreshData();
          }
        };
      })(this));
    };

    CreditCardListController.prototype.setAsDefault = function(card) {
      var selectorPopup;
      this.log('setAsDefault()');
      this.listView.closeOptionButtons();
      this.scope.popupData = {
        creditcardid: card.creditcardid,
        tip: card.tipdefault || false,
        services: card.servicesdefault || false,
        parking: card.traveldefault || false
      };
      selectorPopup = this.confirm.custom({
        title: "Set Default Credit Card",
        subTitle: "Select charge types:",
        scope: this.scope,
        template: '<div>\n  <ion-checkbox ng-model="popupData.tip">Tip</ion-checkbox>\n  <ion-checkbox ng-model="popupData.services"/> Services</ion-checkbox>\n  <ion-checkbox ng-model="popupData.parking"/> Parking</ion-checkbox>\n</div>',
        buttons: [
          {
            text: 'Cancel'
          }, {
            text: 'Save',
            type: 'button-positive',
            onTap: ((function(_this) {
              return function(e) {
                return _this.scope.popupData;
              };
            })(this))
          }
        ]
      });
      return selectorPopup.then((function(_this) {
        return function(result) {
          _this.errors.clear();
          if (result != null) {
            _this.log("Calling setDefaultCreditCard api:", result);
            return _this.data.callApi('setDefaultCreditCard', result).then(function(response) {
              if (response.success) {
                _this.data.clearCache('getDefaults');
                _this.data.clearCache('getCreditCards');
                return _this.refreshData();
              } else {
                return _this.errors.show(response.failure);
              }
            });
          } else {
            return _this.log("Canceled tip popup!");
          }
        };
      })(this));
    };

    CreditCardListController.prototype.verifyDelete = function(card) {
      this.log('verifyDelete()');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.data.deleteCreditCard(card).then((function(_this) {
        return function(result) {
          _this.log('delete result:', result);
          if (result.deleted) {
            _this.log('BE GONE!');
            _this.data.clearCache('getDefaults');
            _this.data.clearCache('getCreditCards');
            return _this.refreshData();
          } else {
            return _this.log('Oops... Not gone.');
          }
        };
      })(this));
    };

    CreditCardListController.prototype.refreshData = function() {
      this.log('refreshData');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.data.getCreditCards(null, {
        refresh: true
      }).then((function(_this) {
        return function(data) {
          _this.scope.$broadcast('scroll.refreshComplete');
          _this.list = data.creditcards;
          return data;
        };
      })(this));
    };

    CreditCardListController.prototype.isExpired = function(card) {
      return moment(card.expdate).isBefore(this.thisMonth);
    };

    CreditCardListController.prototype.cardExpDate = function(card) {
      if (this.isExpired(card)) {
        return "Expired";
      } else {
        return this.filter('date')(card.expdate, 'M/y');
      }
    };

    CreditCardListController.prototype.isDefaulted = function(card) {
      return card.tipdefault || card.servicesdefault || card.traveldefault;
    };

    CreditCardListController.prototype.defaultLabelsFor = function(card) {
      var labels;
      labels = [];
      if (card.traveldefault) {
        labels.push('P');
      }
      if (card.servicesdefault) {
        labels.push('S');
      }
      if (card.tipdefault) {
        labels.push('T');
      }
      return labels.join('/');
    };

    return CreditCardListController;

  })(App.Controller);

}).call(this);
;(function() {
  var DefaultsController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  DefaultsController = (function(superClass) {
    extend(DefaultsController, superClass);

    function DefaultsController() {
      this.tipTypeChanged = bind(this.tipTypeChanged, this);
      return DefaultsController.__super__.constructor.apply(this, arguments);
    }

    DefaultsController.inject({
      airlines: 'airlines',
      confirm: 'confirm',
      creditcards: 'creditcards',
      data: 'data',
      defaults: 'defaults',
      errors: 'errors',
      log: ['Logger', DefaultsController],
      scrollDelegate: '$ionicScrollDelegate',
      vehicles: 'vehicles'
    });

    DefaultsController.prototype.initialize = function() {
      var tip;
      this.log('initialize', this);
      this.formData = _.clone(this.defaults);
      this.airlineList = this.airlines;
      this.creditCardList = this.creditcards.map(function(cc) {
        return {
          id: cc.creditcardid,
          label: cc.cardtype + " - " + (cc.description || cc.lastfourdigits)
        };
      });
      this.vehicleList = this.vehicles.map(function(car) {
        return {
          id: car.vehicleid,
          label: car.make + " " + car.model
        };
      });
      tip = this.formData.defaulttip;
      return this.formData.defaulttiptype = (tip != null) && tip > 0 && tip < 1 ? (this.amountLabel = "% Amount", this.formData.defaulttip = this.formData.defaulttip * 100, "percent") : (this.amountLabel = "$ Amount", "fixed");
    };

    DefaultsController.prototype.tipTypeChanged = function() {
      this.log('tipTypeChanged', this.formData.defaulttiptype);
      if (this.formData.defaulttiptype === 'fixed') {
        return this.amountLabel = "$ Amount";
      } else {
        return this.amountLabel = "% Amount";
      }
    };

    DefaultsController.prototype.cancel = function(form) {
      if (form.$dirty) {
        this.log("Confirm before reset!");
        return this.confirm.mayLoseChanges('This').then((function(_this) {
          return function(confirmed) {
            var tip;
            if (!confirmed) {
              return;
            }
            _this.formData = _.clone(_this.defaults);
            tip = _this.formData.defaulttip;
            _this.formData.defaulttiptype = (tip != null) && tip > 0 && tip < 1 ? (_this.amountLabel = "$ Amount", "fixed") : (_this.amountLabel = "% Amount", "percent");
            _this.errors.clear();
            return _this.scrollDelegate.scrollTop(true);
          };
        })(this));
      } else {
        this.errors.clear();
        return this.scrollDelegate.scrollTop(true);
      }
    };

    DefaultsController.prototype.save = function(form) {
      var data;
      if (form.$dirty) {
        this.log("Saving...");
        this.errors.clear();
        data = _.clone(this.formData);
        if (data.defaulttiptype === 'percent') {
          data.defaulttip = data.defaulttip / 100;
        }
        return this.data.callApi('updateDefaults', data).then((function(_this) {
          return function(results) {
            if (results.success) {
              _this.errors.info('Saved new defaults.', 3000);
              _this.data.clearCache('getDefaults');
              _this.data.clearCache('getCreditCards');
              _this.data.clearCache('profileVehicles');
            } else {
              _this.errors.show(results.failure);
            }
            return _this.scrollDelegate.scrollTop(true);
          };
        })(this));
      } else {
        this.log("No changes to save!");
        this.errors.clear();
        return this.scrollDelegate.scrollTop(true);
      }
    };

    return DefaultsController;

  })(App.Controller);

}).call(this);
;(function() {
  var ProfileDetailsController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ProfileDetailsController = (function(superClass) {
    extend(ProfileDetailsController, superClass);

    function ProfileDetailsController() {
      return ProfileDetailsController.__super__.constructor.apply(this, arguments);
    }

    ProfileDetailsController.inject({
      data: 'data',
      confirm: 'confirm',
      errors: 'errors',
      log: ['Logger', ProfileDetailsController],
      profile: 'profile',
      scrollDelegate: '$ionicScrollDelegate'
    });

    ProfileDetailsController.prototype.initialize = function() {
      this.log('initialize');
      return this.formData = _.clone(this.profile);
    };

    ProfileDetailsController.prototype.cancel = function(form) {
      if (form.$dirty) {
        this.log("Confirm before reset!");
        return this.confirm.mayLoseChanges('This').then((function(_this) {
          return function(confirmed) {
            if (!confirmed) {
              return;
            }
            _this.formData = _.clone(_this.profile);
            _this.errors.clear();
            return _this.scrollDelegate.scrollTop(true);
          };
        })(this));
      } else {
        this.errors.clear();
        return this.scrollDelegate.scrollTop(true);
      }
    };

    ProfileDetailsController.prototype.save = function(form) {
      var data;
      this.errors.clear();
      if (form.$dirty) {
        this.log("Saving...");
        data = _.clone(this.formData);
        return this.data.callApi('updateProfileDetails', data).then((function(_this) {
          return function(results) {
            if (results.success) {
              _this.errors.info('Saved profile.', 3000);
              _this.data.clearCache('profileDetails');
            } else {
              _this.errors.show(results.failure);
            }
            return _this.scrollDelegate.scrollTop(true);
          };
        })(this));
      } else {
        this.log("No changes to save!");
        return this.scrollDelegate.scrollTop(true);
      }
    };

    return ProfileDetailsController;

  })(App.Controller);

}).call(this);
;(function() {
  var ReservationDetailController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationDetailController = (function(superClass) {
    extend(ReservationDetailController, superClass);

    function ReservationDetailController() {
      this.renderStatus = bind(this.renderStatus, this);
      this.getInstructionsModal = bind(this.getInstructionsModal, this);
      return ReservationDetailController.__super__.constructor.apply(this, arguments);
    }

    ReservationDetailController.inject({
      app: 'app',
      confirm: 'confirm',
      data: 'data',
      delay: 'delay',
      detail: 'reservation',
      errors: 'errors',
      log: ['Logger', ReservationDetailController],
      modalHelper: 'modalHelper',
      sce: '$sce',
      scope: '$scope'
    });

    ReservationDetailController.prototype.initialize = function() {
      this.log('initialize');
      this.title = "Reservation " + (this.detail.reservationnumber || 'Pending');
      return this.delay(1500, this.getInstructionsModal);
    };

    ReservationDetailController.prototype.getInstructionsModal = function() {
      if (this._instructionsModal != null) {
        return this._instructionsModal;
      } else {
        this._instructionsModal = this.modalHelper.createForUrl('views/screens/secure/reservation/reservation-instructions-dialog.html', this, this.scope);
        return this._instructionsModal;
      }
    };

    ReservationDetailController.prototype.updateReservation = function() {
      this.log('updateReservation');
      return this.app.navigateTo('main.secure.reservation-form', {
        id: this.detail.orderid
      });
    };

    ReservationDetailController.prototype.cancelReservation = function() {
      this.log('cancelReservation');
      this.errors.clear();
      return this.confirm.custom({
        title: "Are you sure?",
        template: "<p>This will cancel your reservation.</p>"
      }).then((function(_this) {
        return function(confirmed) {
          if (confirmed) {
            return _this.actuallyCancelReservation();
          } else {
            return _this.log("Nevermind.");
          }
        };
      })(this));
    };

    ReservationDetailController.prototype.actuallyCancelReservation = function() {
      this.log('actuallyCancelReservation');
      return this.data.callApi('cancelReservation', {
        orderid: this.detail.orderid,
        reservationnumber: this.detail.reservationnumber
      }).then((function(_this) {
        return function(result) {
          if (result.success) {
            _this.errors.info("Reservation canceled.", 3000);
            _this.data.clearCache('getActiveReservations');
            _this.data.clearCache('getFutureReservations');
            return _this.app.navigateTo('main.secure.reservation-list', null, {
              clearHistory: true
            });
          } else {
            return _this.errors.warn("Sorry, reservation could not be canceled. (" + result.failure + ")", 3000);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          _this.log.warn("Reservation could not be canceled, error:", err);
          return _this.errors.show(err);
        };
      })(this));
    };

    ReservationDetailController.prototype.detailedInstructions = function() {
      this.log('detailedInstructions');
      return this.getInstructionsModal().show();
    };

    ReservationDetailController.prototype.sendReceipt = function() {
      this.log('sendReceipt');
      this.errors.clear();
      return this.data.callApi('sendReceipt', {
        orderid: this.detail.orderid
      }).then((function(_this) {
        return function(result) {
          if (result.success) {
            return _this.errors.info("Receipt sent to your email address.", 3000);
          } else {
            return _this.errors.warn("Sorry, an email could not be sent. (" + result.failure + ")", 3000);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          _this.log.warn("Email could not be sent, error:", err);
          return _this.errors.show(err);
        };
      })(this));
    };

    ReservationDetailController.prototype.renderCharge = function(charge, type) {
      var value;
      if (charge != null) {
        value = parseFloat(charge);
        if (type === 'tip' && (value > 0.0 && value < 1.0)) {
          return (value * 100) + "%";
        } else {
          return "$" + (value.toFixed(2));
        }
      } else {
        return "n/a";
      }
    };

    ReservationDetailController.prototype.renderStatus = function(status) {
      if (status === 'Please Call') {
        return this.sce.trustAsHtml("<a class=\"button button-small button-outline button-assertive icon-left ion-ios-telephone\" href='tel:" + (this.app.location.phone()) + "'>" + status + "</a>");
      } else {
        return status;
      }
    };

    return ReservationDetailController;

  })(App.Controller);

}).call(this);
;(function() {
  var ReservationFormController, anyAreEmpty, areEmpty, areNotEmpty, as_time, today,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty,
    slice = [].slice;

  ReservationFormController = (function(superClass) {
    extend(ReservationFormController, superClass);

    function ReservationFormController() {
      this.serviceSelectionDidChange = bind(this.serviceSelectionDidChange, this);
      this.formDataChanged = bind(this.formDataChanged, this);
      this.setup = bind(this.setup, this);
      return ReservationFormController.__super__.constructor.apply(this, arguments);
    }

    ReservationFormController.inject({
      app: 'app',
      auth: 'auth',
      confirm: 'confirm',
      data: 'data',
      delay: 'delay',
      detail: 'reservation',
      filter: '$filter',
      fieldFormatter: 'fieldFormatter',
      errors: 'errors',
      preflight: 'preflight',
      log: ['Logger', ReservationFormController],
      modalHelper: 'modalHelper',
      mode: 'mode',
      sce: '$sce',
      scope: '$scope',
      scrollDelegate: '$ionicScrollDelegate',
      services: 'services',
      wizard: 'wizard'
    });

    ReservationFormController.prototype.initialize = function() {
      this.log('initialize', this);
      this.scope.$on('$ionicView.loaded', (function(_this) {
        return function() {
          _this.log.info('$ionicView.loaded');
          return _this.setup();
        };
      })(this));
      return this.scope.$on('$ionicView.enter', (function(_this) {
        return function() {
          var error, ignore;
          _this.log.info('$ionicView.enter!!!! RESERVATION FORM', _this);
          _this.prepareInboundData(_this.detail);
          _this.updateAmountLabel(false);
          _this.title = _this.mode === 'new' ? "New Reservation" : "Reservation " + (_this.detail.reservationnumber || 'Pending');
          try {
            _this.scrollDelegate.scrollTop(true);
          } catch (error) {
            ignore = error;
          }
          return _this.flightDatesChanged();
        };
      })(this));
    };

    ReservationFormController.prototype.setup = function() {
      var today;
      this.log('setup', this);
      this.title = this.mode === 'new' ? "New Reservation" : "Reservation " + (this.detail.reservationnumber || 'Pending');
      this.creditHold = this.auth.hasCreditHold;
      this.creditLock = this.creditHold && this.mode === 'new';
      this.today = today = new Date();
      this.location = this.app.location.get();
      this.airlineList = this.preflight.airlinecodes;
      this.creditCardList = this.preflight.creditcards.filter(function(cc) {
        return moment(cc.expdate).isAfter(today);
      }).map(function(cc) {
        return {
          id: cc.creditcardid,
          label: cc.cardtype + " - " + (cc.description || cc.lastfourdigits)
        };
      });
      this.vehicleList = this.preflight.vehicles.map(function(car) {
        return {
          id: car.vehicleid,
          label: car.make + " " + car.model
        };
      });
      this.airportEntrances = [
        {
          code: 'EAST',
          label: 'East'
        }, {
          code: 'WEST',
          label: 'West'
        }
      ];
      this.meetTimes = [
        {
          code: '15',
          label: '15 minutes'
        }, {
          code: '30',
          label: '30 minutes'
        }, {
          code: '45',
          label: '45 minutes'
        }, {
          code: '60',
          label: '60 minutes'
        }, {
          code: '90',
          label: '90 minutes'
        }, {
          code: 'Custom',
          label: 'Custom...'
        }
      ];
      this.initializeServices();
      this.scope.formData = this.formData;
      if (this.vehicleList.length === 0 || this.creditCardList.length === 0) {
        this.failedRequirements = true;
        return;
      } else {
        this.failedRequirements = false;
      }
      this.prepareInboundData(this.detail);
      return this.updateAmountLabel(false);
    };

    ReservationFormController.prototype.formDataChanged = function(form) {
      this.log('Data changed!', arguments);
      if (this.mode === 'new') {
        return this.wizard.scheduleSave(this.formData);
      }
    };

    ReservationFormController.prototype.initializeServices = function() {
      var ccid, i, len, ref, service, serviceSrc;
      this.serviceById = {};
      this.washServices = [];
      this.otherServices = [];
      this.fuelGrades = [
        {
          code: 'Regular',
          label: 'Regular'
        }, {
          code: 'Mid',
          label: 'Medium',
          labelX: 'Mid-Grade'
        }, {
          code: 'Premium',
          label: 'Premium'
        }, {
          code: 'Diesel',
          label: 'Diesel'
        }
      ];
      ref = this.services;
      for (i = 0, len = ref.length; i < len; i++) {
        serviceSrc = ref[i];
        ccid = this.preflight.defaults.defaultccservices || this.creditCardList[0].id;
        service = _.extend({}, serviceSrc, {
          selected: false,
          selectedGrade: this.fuelGrades[0].code,
          creditcardid: ccid
        });
        this.serviceById[service.serviceid] = service;
        if (service.userainorshine) {
          this.washServices.push(service);
        } else {
          this.otherServices.push(service);
        }
      }
      return this.log('Services done', this);
    };

    ReservationFormController.prototype.deselectAllServices = function() {
      var ccid, id, ref, service;
      ccid = this.preflight.defaults.defaultccservices || this.creditCardList[0].id;
      ref = this.serviceById;
      for (id in ref) {
        service = ref[id];
        _.extend(service, {
          selected: false,
          selectedGrade: this.fuelGrades[0].code,
          creditcardid: ccid
        });
      }
      return this;
    };

    ReservationFormController.prototype.prepareInboundData = function(data) {
      var i, len, ref, selected, service;
      this.formData = _.clone(data);
      this.readOnly = data.canaddservices && data.canupdatearrival && data.canupdatedeparture ? false : true;
      this.bookMinDate = this.mode === 'edit' ? this.formData.outdate : this.today;
      this.formData.tip = this.formData.tip || this.preflight.defaults.defaulttip || 0;
      if (!this.formData.tiptype || this.formData.tiptype === "" || this.mode === 'new') {
        this.formData.tiptype = this.formData.tip > 0.0 && this.formData.tip < 1.0 ? (this.formData.tip = this.formData.tip * 100, 'percent') : 'fixed';
      }
      this.formData.beforeflight = '60';
      this.formData.outairline = this.formData.outairline || this.preflight.defaults.defaultairline;
      this.formData.inairline = this.formData.inairline || this.preflight.defaults.defaultairline;
      this.formData.vehicleid = this.formData.vehicleid || this.preflight.defaults.defaultvehicle;
      this.deselectAllServices();
      this.formData.washService = 'none';
      this.formData.washRainOrShine = false;
      ref = this.formData.reservationservices || [];
      for (i = 0, len = ref.length; i < len; i++) {
        selected = ref[i];
        service = this.serviceById[selected.serviceid];
        this.log.info('Selected service:', service, selected);
        if (selected.creditcardid != null) {
          service.creditcardid = selected.creditcardid;
        }
        if (service.userainorshine) {
          this.formData.washService = service.serviceid;
          this.formData.washRainOrShine = selected.rainorshine;
        } else if (service.usegrade) {
          service.selected = true;
          service.selectedGrade = selected.grade;
        } else {
          service.selected = true;
        }
      }
      this.formData.parkingcreditcardid = this.formData.parkingcreditcardid || this.preflight.defaults.defaultcctravel || this.creditCardList[0].creditcardid;
      return this.formData.tipcreditcardid = this.formData.tipcreditcardid || this.preflight.defaults.defaultcctip || this.creditCardList[0].creditcardid;
    };

    ReservationFormController.prototype.prepareOutboundData = function() {
      var data, i, len, selectedServices, service, washService;
      data = _.clone(this.formData);
      if (data.tiptype === 'percent') {
        data.tip = parseFloat(data.tip) / 100;
      }
      delete data.beforeflight;
      delete data.tiptype;
      delete data.washService;
      delete data.washRainOrShine;
      selectedServices = this.getSelectedOtherServices();
      washService = this.serviceById[this.formData.washService];
      if (washService != null) {
        washService.rainorshine = this.formData.washRainOrShine;
        selectedServices.push(washService);
      }
      data.reservationservices = [];
      for (i = 0, len = selectedServices.length; i < len; i++) {
        service = selectedServices[i];
        data.reservationservices.push({
          serviceid: service.serviceid,
          creditcardid: service.creditcardid,
          rainorshine: service.rainorshine,
          grade: service.selectedGrade || service.grade
        });
      }
      return this.fieldFormatter.fieldFormats(JSON.parse(JSON.stringify(data)), {
        outdate: 'date',
        outtime: 'time',
        outmeetstart: 'time',
        outarrivaltime: 'time',
        indate: 'date',
        intime: 'time',
        indeparturetime: 'time'
      });
    };

    ReservationFormController.prototype.serviceSelectionDidChange = function(service) {
      var i, len, selectedServices, washService;
      selectedServices = this.getSelectedOtherServices();
      washService = this.serviceById[this.formData.washService];
      if (washService != null) {
        washService.rainorshine = this.formData.washRainOrShine;
        selectedServices.push(washService);
      }
      this.formData.reservationservices = [];
      for (i = 0, len = selectedServices.length; i < len; i++) {
        service = selectedServices[i];
        this.formData.reservationservices.push({
          serviceid: service.serviceid,
          creditcardid: service.creditcardid,
          rainorshine: service.rainorshine,
          grade: service.selectedGrade || service.grade
        });
      }
      return this.formDataChanged();
    };

    ReservationFormController.prototype.lookupFlight = function(type) {
      var airline, date, flight;
      if (type === 'Departure') {
        date = moment(this.formData.outdate).format('YYYYMMDD');
        airline = this.formData.outairline;
        flight = this.formData.outflight;
      } else {
        date = moment(this.formData.indate).format('YYYYMMDD');
        airline = this.formData.inairline;
        flight = this.formData.inflight;
      }
      this.errors.clear();
      return this.data.callApi('getFlightInfo', {
        type: type,
        date: date,
        airline: airline,
        flight: flight
      }).then((function(_this) {
        return function(result) {
          if (result.success) {
            _this.log('FLIGHT INFO:', result);
            if (type === 'Departure') {
              _this.formData.outtime = as_time(result.leg.departurescheduled);
              _this.formData.outarrivalcity = result.leg.arrivalcity;
              _this.formData.outarrivaltime = as_time(result.leg.arrivalscheduled);
              _this.outFlightTimeChanged();
            } else {
              _this.formData.intime = as_time(result.leg.arrivalscheduled);
              _this.formData.indeparturecity = result.leg.departurecity;
              _this.formData.indeparturetime = as_time(result.leg.departurescheduled);
            }
            return _this.formDataChanged();
          } else {
            _this.log.warn("Ooops!", result);
            return _this.errors.warn(result.failure, 10000);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          return _this.errors.show(err);
        };
      })(this));
    };

    ReservationFormController.prototype.canLookupFlight = function(type) {
      if (type === 'Departure') {
        return areNotEmpty(this.formData, 'outdate', 'outairline', 'outflight');
      } else {
        return areNotEmpty(this.formData, 'indate', 'inairline', 'inflight');
      }
    };

    ReservationFormController.prototype.toggleRainOrShine = function() {
      this.formData.washRainOrShine = !this.formData.washRainOrShine;
      return this.serviceSelectionDidChange();
    };

    ReservationFormController.prototype.toggleWashService = function(service) {
      this.formData.washService = service != null ? service.serviceid : 'none';
      return this.serviceSelectionDidChange();
    };

    ReservationFormController.prototype.toggleOtherService = function(service) {
      this.log('toggleOtherService:', service);
      service.selected = !service.selected;
      return this.serviceSelectionDidChange();
    };

    ReservationFormController.prototype.toggleFuelGrade = function(service, grade, event) {
      service.selectedGrade = grade.code;
      if (typeof event.preventDefault === "function") {
        event.preventDefault();
      }
      if (typeof event.stopPropagation === "function") {
        event.stopPropagation();
      }
      this.serviceSelectionDidChange();
      return true;
    };

    ReservationFormController.prototype.outFlightTimeChanged = function(form) {
      return this.meetTimeChanged(form);
    };

    ReservationFormController.prototype.meetTimeChanged = function(form) {
      var before, newDateTime;
      if (this.formData.beforeflight === 'Custom') {
        return;
      }
      before = parseInt(this.formData.beforeflight, 10);
      this.log("Move outmeetstart", before, 'minutes before', this.formData.outtime);
      newDateTime = moment(this.formData.outtime).subtract(before, 'minutes').toDate();
      this.formData.outmeetstart = newDateTime;
      return this.meetStartTimeChanged();
    };

    ReservationFormController.prototype.meetStartTimeChanged = function(form) {
      var newDateTime;
      this.log("Move outmeetend 15 minutes after:", this.formData.outmeetstart);
      newDateTime = moment(this.formData.outmeetstart).add(15, 'minutes').toDate();
      this.formData.outmeetend = newDateTime;
      return this.formDataChanged();
    };

    ReservationFormController.prototype.flightDatesChanged = function(field, onBlur) {
      var inDate, outDate;
      this.log('A date changed!', field, typeof this.formData.outdate, this.formData.outdate, typeof this.formData.indate, this.formData.indate);
      if (this.formData.outdate && this.formData.indate) {
        this.log.warn("Date math time!");
        outDate = moment(this.formData.outdate);
        inDate = moment(this.formData.indate);
        if (inDate.isBefore(outDate)) {
          return this.indateBeforeOutdate = true;
        } else {
          return this.indateBeforeOutdate = false;
        }
      } else {
        this.log("No date math without two dates.");
        this.indateBeforeOutdate = false;
        if (field === 'outdate' && onBlur) {
          outDate = moment(this.formData.outdate);
          return this.formData.indate = outDate.toDate();
        }
      }
    };

    ReservationFormController.prototype.canSave = function(form) {
      return form.$valid;
    };

    ReservationFormController.prototype.save = function(form) {
      var apiMethod, params;
      this.log('save', form);
      params = this.prepareOutboundData();
      apiMethod = this.mode === 'edit' ? params.reservationservices.length ? 'updateReservationWithServices' : 'updateReservation' : params.reservationservices.length ? 'addReservationWithServices' : 'addReservation';
      this.log("Save:", apiMethod, params);
      this.errors.clear();
      params.services = params.reservationservices;
      if (this._servicesAreValid(params.services) === false) {
        this.errors.show("Invalid service(s) data. Please select a Credit Card.");
        return;
      }
      return this.data.callApi(apiMethod, params).then((function(_this) {
        return function(result) {
          if (result.success) {
            _this.log("DONE!!!", result);
            _this.errors.info("Reservation saved.", 5000);
            _this.data.clearCache('getActiveReservations');
            _this.data.clearCache('getFutureReservations');
            if (_this.mode === 'new') {
              _this.wizard.clearDraft();
            }
            return _this.app.backOrNavigateTo('main.secure.reservation-list');
          } else {
            return _this.errors.show(result.failure);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          return _this.errors.show(err);
        };
      })(this));
    };

    ReservationFormController.prototype.cancel = function(form) {
      this.log('cancel', form);
      if (form.$dirty || this.formData.$fromDraft) {
        this.log("Confirm before reset!");
        return this.confirm.mayLoseChanges('This').then((function(_this) {
          return function(confirmed) {
            if (!confirmed) {
              return;
            }
            if (_this.formData.$fromDraft) {
              _this.prepareInboundData(_this.wizard.buildReservation());
            } else {
              _this.prepareInboundData(_this.detail);
            }
            _this.errors.clear();
            if (_this.mode === 'new') {
              _this.wizard.clearDraft();
            }
            return _this.scrollDelegate.scrollTop(true);
          };
        })(this));
      } else {
        this.errors.clear();
        if (this.mode === 'new') {
          this.wizard.clearDraft();
        }
        return this.scrollDelegate.scrollTop(true);
      }
    };

    ReservationFormController.prototype.updateAmountLabel = function(triggerChange) {
      if (triggerChange == null) {
        triggerChange = true;
      }
      this.amountLabel = this.formData.tiptype === 'fixed' ? '$ Amount' : '% Amount';
      if (triggerChange) {
        this.formDataChanged();
      }
      return this.amountLabel;
    };

    ReservationFormController.prototype.getSelectedOtherServices = function() {
      return this.otherServices.filter(function(s) {
        return s.selected;
      });
    };

    ReservationFormController.prototype.getSelectedServices = function() {
      var otherServices, service;
      otherServices = this.otherServices.filter(function(s) {
        return s.selected;
      });
      if (service = this.serviceById[this.formData.washService]) {
        return [service].concat(otherServices);
      } else {
        return otherServices;
      }
    };

    ReservationFormController.prototype.renderServiceRate = function(rate, type) {
      if (type == null) {
        type = 'wash';
      }
      if (rate != null) {
        return this.filter('currency')(rate);
      } else if (type === 'wash') {
        return "";
      } else {
        return "Varies";
      }
    };

    ReservationFormController.prototype._servicesAreValid = function(services) {
      var i, len, service;
      this.log('validating services:', services);
      for (i = 0, len = services.length; i < len; i++) {
        service = services[i];
        if (service.creditcardid == null) {
          return false;
        }
      }
      return true;
    };

    return ReservationFormController;

  })(App.Controller);

  today = moment(new Date()).format('MM/DD/YYYY');

  as_time = function(source) {
    console.info("Convert to time:", source);
    return moment(today + " " + source).toDate();
  };

  anyAreEmpty = function() {
    var i, len, value, values;
    values = 1 <= arguments.length ? slice.call(arguments, 0) : [];
    for (i = 0, len = values.length; i < len; i++) {
      value = values[i];
      if (value === null || value === "") {
        return true;
      }
    }
    return false;
  };

  areEmpty = function() {
    var keys, source, values;
    source = arguments[0], keys = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    values = keys.map(function(key) {
      return source[key];
    });
    return anyAreEmpty.apply(null, values);
  };

  areNotEmpty = function() {
    var keys, source;
    source = arguments[0], keys = 2 <= arguments.length ? slice.call(arguments, 1) : [];
    return !areEmpty.apply(null, [source].concat(slice.call(keys)));
  };

}).call(this);
;(function() {
  var ReservationHistoryController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationHistoryController = (function(superClass) {
    extend(ReservationHistoryController, superClass);

    function ReservationHistoryController() {
      return ReservationHistoryController.__super__.constructor.apply(this, arguments);
    }

    ReservationHistoryController.inject({
      app: 'app',
      errors: 'errors',
      log: ['Logger', ReservationHistoryController]
    });

    ReservationHistoryController.prototype.initialize = function() {
      this.log('initialize');
      return this.formData = {
        type: 'search'
      };
    };

    ReservationHistoryController.prototype.showLastFive = function() {
      this.errors.clear();
      return this.app.navigateTo('main.secure.reservation-search', {
        type: 'last5'
      });
    };

    ReservationHistoryController.prototype.search = function(form) {
      var params;
      if (!form.$valid) {
        return;
      }
      this.errors.clear();
      params = _.clone(this.formData);
      params.fromDate = moment(params.fromDate).format('MM/DD/YYYY');
      params.toDate = moment(params.toDate).format('MM/DD/YYYY');
      this.log(">>>> SEARCH", params);
      return this.app.navigateTo('main.secure.reservation-search', params);
    };

    return ReservationHistoryController;

  })(App.Controller);

}).call(this);
;(function() {
  var ReservationInstructionsDialog,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationInstructionsDialog = (function(superClass) {
    extend(ReservationInstructionsDialog, superClass);

    function ReservationInstructionsDialog() {
      return ReservationInstructionsDialog.__super__.constructor.apply(this, arguments);
    }

    ReservationInstructionsDialog.inject({
      app: 'app',
      log: ['Logger', ReservationInstructionsDialog],
      scope: '$scope'
    });

    ReservationInstructionsDialog.prototype.initialize = function() {
      this.log('initialize');
      return this.location = this.app.location.get();
    };

    ReservationInstructionsDialog.prototype.close = function() {
      return this.scope.closeActiveModal({
        cancel: true
      });
    };

    return ReservationInstructionsDialog;

  })(App.Controller);

}).call(this);
;(function() {
  var ReservationListController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationListController = (function(superClass) {
    extend(ReservationListController, superClass);

    function ReservationListController() {
      this.getValetModal = bind(this.getValetModal, this);
      return ReservationListController.__super__.constructor.apply(this, arguments);
    }

    ReservationListController.inject({
      app: 'app',
      data: 'data',
      delay: 'delay',
      errors: 'errors',
      log: ['Logger', ReservationListController],
      list: 'reservations',
      modalHelper: 'modalHelper',
      scope: '$scope'
    });

    ReservationListController.prototype.initialize = function() {
      this.log("initialize", this);
      this.location = this.app.location.get();
      this.showActivePager = this.list.activereservations.length > 1;
      return this.delay(1500, this.getValetModal);
    };

    ReservationListController.prototype.getValetModal = function() {
      if (this._valetModal != null) {
        return this._valetModal;
      } else {
        this._valetModal = this.modalHelper.createForUrl('views/screens/secure/reservation/reservation-valet-dialog.html', this, this.scope);
        return this._valetModal;
      }
    };

    ReservationListController.prototype.refreshData = function() {
      this.log('refreshData');
      this.list = [];
      this.errors.clear();
      return this.data.allMerged([
        this.data.getActiveReservations(null, {
          refresh: true
        }), this.data.getFutureReservations(null, {
          refresh: true
        })
      ]).then((function(_this) {
        return function(data) {
          _this.scope.$broadcast('scroll.refreshComplete');
          _this.list = data;
          _this.showActivePager = _this.list.activereservations.length > 1;
          return data;
        };
      })(this));
    };

    ReservationListController.prototype.checkedLuggage = function(res) {
      var params;
      this.log('checked luggage:', res.luggage);
      this.errors.clear();
      params = {
        reservationnumber: res.reservationnumber,
        luggage: !res.luggage
      };
      return this.data.callApi('updateLuggage', params).then((function(_this) {
        return function(result) {
          _this.log('Result', result);
          if (result.success) {
            return res.luggage = params.luggage;
          } else {
            return _this.errors.show(result.failure);
          }
        };
      })(this));
    };

    ReservationListController.prototype.runningEarly = function(res) {
      this.log('running early');
      if (res.runningearly) {
        return;
      }
      return this.adjustExpectations('runningEarly', res).then((function(_this) {
        return function(result) {
          if (result.success) {
            res.runningearly = true;
            return res.runninglate = false;
          }
        };
      })(this));
    };

    ReservationListController.prototype.runningOnTime = function(res) {
      this.log('running on time');
      if (!res.runningearly && !res.runninglate) {
        return;
      }
      return this.adjustExpectations('runningOnTime', res).then((function(_this) {
        return function(result) {
          if (result.success) {
            res.runningearly = false;
            return res.runninglate = false;
          }
        };
      })(this));
    };

    ReservationListController.prototype.runningLate = function(res) {
      this.log('running late');
      if (res.runninglate) {
        return;
      }
      return this.adjustExpectations('runningLate', res).then((function(_this) {
        return function(result) {
          if (result.success) {
            res.runningearly = false;
            return res.runninglate = true;
          }
        };
      })(this));
    };

    ReservationListController.prototype.adjustExpectations = function(apiMethod, res) {
      this.log('adjustExpectations', apiMethod, res);
      this.errors.clear();
      return this.data.callApi(apiMethod, {
        reservationnumber: res.reservationnumber
      }).then((function(_this) {
        return function(result) {
          _this.log('Result:', result);
          if (!result.success) {
            _this.errors.show(result.failure);
          }
          return result;
        };
      })(this));
    };

    ReservationListController.prototype.updateDirection = function(res, leg, direction) {
      var dir_field, reservationnumber;
      reservationnumber = res.reservationnumber;
      dir_field = leg === 'DEPARTURE' ? 'outentrydirection' : 'inexitdirection';
      if (res[dir_field] === direction) {
        return;
      }
      this.log('Calling updateDirection:', {
        reservationnumber: reservationnumber,
        leg: leg,
        direction: direction
      });
      this.errors.clear();
      return this.data.callApi('updateDirection', {
        reservationnumber: reservationnumber,
        leg: leg,
        direction: direction
      }).then((function(_this) {
        return function(result) {
          if (result.success) {
            return res[dir_field] = direction;
          } else {
            return _this.errors.show(result.failure);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          return _this.errors.show(err);
        };
      })(this));
    };

    ReservationListController.prototype.valetDetail = function(type, source) {
      var params;
      params = {
        name: source[type + "valet"],
        image: source[type + "valetimage"]
      };
      return this.getValetModal().show(params);
    };

    return ReservationListController;

  })(App.Controller);

}).call(this);
;(function() {
  var PAGE_SIZE, ReservationResultsController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  PAGE_SIZE = 5;

  ReservationResultsController = (function(superClass) {
    extend(ReservationResultsController, superClass);

    function ReservationResultsController() {
      return ReservationResultsController.__super__.constructor.apply(this, arguments);
    }

    ReservationResultsController.inject({
      data: 'data',
      log: ['Logger', ReservationResultsController],
      params: '$stateParams'
    });

    ReservationResultsController.prototype.initialize = function() {
      this.log('initialize', this.params);
      this.title = "Search Results";
      this.showMoreBtn = false;
      this.list = [];
      this.current_page = 1;
      this.from = this.params.fromDate || "";
      this.to = this.params.toDate || "";
      return this.doSearch();
    };

    ReservationResultsController.prototype.loadMore = function() {
      this.current_page += 1;
      return this.doSearch();
    };

    ReservationResultsController.prototype.doSearch = function() {
      var apiMethod, params;
      this.log('doSearch');
      apiMethod = this.params.type === 'last5' ? 'lastFiveReservations' : 'searchForReservations';
      params = {
        startdate: this.from,
        enddate: this.to,
        pagesize: PAGE_SIZE,
        page: this.current_page
      };
      return this.data.callApi(apiMethod, params).then((function(_this) {
        return function(data) {
          _this.log("Search Results!", data);
          _this.list = _this.list.concat(data.reservations);
          return _this.showMoreBtn = _this.current_page < data.pages;
        };
      })(this));
    };

    return ReservationResultsController;

  })(App.Controller);

}).call(this);
;(function() {
  var ReservationValetDialog,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationValetDialog = (function(superClass) {
    extend(ReservationValetDialog, superClass);

    function ReservationValetDialog() {
      return ReservationValetDialog.__super__.constructor.apply(this, arguments);
    }

    ReservationValetDialog.inject({
      log: ['Logger', ReservationValetDialog],
      scope: '$scope'
    });

    ReservationValetDialog.prototype.initialize = function() {
      this.log('initialize');
      this.ready = false;
      this.valetName = "";
      this.valetImage = "";
      return this.scope.$on('modal.shown', (function(_this) {
        return function() {
          _this.valetName = _this.scope.activeModalParams.name;
          _this.valetImage = _this.scope.activeModalParams.image || 'img/valet_unknown.jpg';
          return _this.ready = true;
        };
      })(this));
    };

    ReservationValetDialog.prototype.close = function() {
      return this.scope.closeActiveModal({
        cancel: true
      });
    };

    return ReservationValetDialog;

  })(App.Controller);

}).call(this);
;(function() {
  var VehicleDetailController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  VehicleDetailController = (function(superClass) {
    extend(VehicleDetailController, superClass);

    function VehicleDetailController() {
      return VehicleDetailController.__super__.constructor.apply(this, arguments);
    }

    VehicleDetailController.inject({
      api: 'api',
      app: 'app',
      confirm: 'confirm',
      data: 'data',
      errors: 'errors',
      log: ['Logger', VehicleDetailController],
      scope: '$scope'
    });

    VehicleDetailController.prototype.initialize = function() {
      this.log('initialize');
      this.stateList = this.data.stateList();
      this.models = [];
      return this.scope.$on('modal.shown', (function(_this) {
        return function() {
          var params;
          params = _this.scope.activeModalParams;
          _this.log('Modal shown!', params);
          _this.makes = params.makes;
          _this.detail = params.detail;
          _this.mode = params.mode;
          _this.formData = _.clone(_this.detail);
          _this.title = _this.mode === 'new' ? 'New Vehicle' : "Vehicle";
          return _this.loadVehicleModels();
        };
      })(this));
    };

    VehicleDetailController.prototype.loadVehicleModels = function() {
      var makeid, name, ref;
      name = this.formData.make;
      if (_.isEmpty(name)) {
        return;
      }
      makeid = (ref = _.findWhere(this.makes, {
        name: name
      })) != null ? ref.makeid : void 0;
      return this.data.getVehicleModels({
        makeid: makeid
      }).then((function(_this) {
        return function(modelsData) {
          _this.log('Models:', modelsData);
          return _this.models = modelsData.automodels;
        };
      })(this))["catch"]((function(_this) {
        return function(error) {
          _this.log.error('Models Error:', error);
          return _this.models = [];
        };
      })(this));
    };

    VehicleDetailController.prototype.save = function(form) {
      if (form.$valid) {
        this.log('saving', this.formData, form);
        this.errors.clear();
        if (this.mode === 'edit') {
          return this._vehicleMutation('updateVehicle', form, this.formData);
        } else {
          return this._vehicleMutation('addVehicle', form, this.formData);
        }
      } else {
        return this.log.warn('Form not valid!');
      }
    };

    VehicleDetailController.prototype.cancel = function(form) {
      this.log('cancel', form);
      this.errors.clear();
      if (form != null ? form.$dirty : void 0) {
        return this.confirm.mayLoseChanges().then((function(_this) {
          return function(doIt) {
            if (doIt) {
              return _this.scope.closeActiveModal({
                cancel: true
              });
            }
          };
        })(this));
      } else {
        return this.scope.closeActiveModal({
          cancel: true
        });
      }
    };

    VehicleDetailController.prototype["delete"] = function(form) {
      this.log('delete', form);
      this.errors.clear();
      return this.data.deleteVehicle(this.detail).then((function(_this) {
        return function(result) {
          _this.log('delete result:', result);
          if (result.deleted) {
            _this.log('BE GONE!');
            _this.data.clearCache('profileVehicles');
            return _this.scope.closeActiveModal({
              cancel: false,
              success: true,
              "delete": true
            });
          } else {
            return _this.log('Oops... Not gone.');
          }
        };
      })(this));
    };

    VehicleDetailController.prototype._vehicleMutation = function(action, form, formData) {
      this.log("->", action);
      return this.api.run(action, formData).then((function(_this) {
        return function(result) {
          _this.log(action, "result:", result);
          if (result.success) {
            _this.errors.info("Saved vehicle.", 3000);
            _this.data.clearCache('profileVehicles');
            return _this.scope.closeActiveModal(result);
          } else {
            return _this.errors.show(result.failure);
          }
        };
      })(this))["catch"]((function(_this) {
        return function(err) {
          _this.log.error(err);
          return _this.errors.show(err);
        };
      })(this));
    };

    return VehicleDetailController;

  })(App.Controller);

}).call(this);
;(function() {
  var VehicleListController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  VehicleListController = (function(superClass) {
    extend(VehicleListController, superClass);

    function VehicleListController() {
      this.getDetailModal = bind(this.getDetailModal, this);
      return VehicleListController.__super__.constructor.apply(this, arguments);
    }

    VehicleListController.inject({
      app: 'app',
      confirm: 'confirm',
      data: 'data',
      delay: 'delay',
      errors: 'errors',
      list: 'vehicles',
      listView: '$ionicListDelegate',
      log: ['Logger', VehicleListController],
      makes: 'automakes',
      modalHelper: 'modalHelper',
      scope: '$scope'
    });

    VehicleListController.prototype.initialize = function() {
      this.log('initialize', this.list);
      return this.delay(500, this.getDetailModal);
    };

    VehicleListController.prototype.getDetailModal = function() {
      if (this.detailModal != null) {
        return this.detailModal;
      } else {
        this.detailModal = this.modalHelper.createForUrl('views/screens/secure/vehicle/vehicle-detail.html', this, this.scope);
        return this.detailModal;
      }
    };

    VehicleListController.prototype.create = function() {
      this.log('create()');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.getDetailModal().show({
        detail: {},
        mode: 'new',
        makes: this.makes
      }).then((function(_this) {
        return function(response) {
          _this.log.warn(">> Modal RESPONSE", response);
          if ((response != null) && response.success) {
            return _this.refreshData();
          }
        };
      })(this));
    };

    VehicleListController.prototype.view = function(vehicle) {
      this.log('view()');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.getDetailModal().show({
        detail: vehicle,
        mode: 'edit',
        makes: this.makes
      }).then((function(_this) {
        return function(response) {
          _this.log.warn(">> Modal RESPONSE", response);
          if ((response != null) && response.success) {
            return _this.refreshData();
          }
        };
      })(this));
    };

    VehicleListController.prototype.setAsDefault = function(vehicle) {
      this.log('setAsDefault()');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.data.callApi('setDefaultVehicle', {
        vehicleid: vehicle.vehicleid
      }).then((function(_this) {
        return function(response) {
          if (response.success) {
            _this.data.clearCache('getDefaults');
            return _this.refreshData();
          } else {
            return _this.errors.show(response.failure);
          }
        };
      })(this));
    };

    VehicleListController.prototype.verifyDelete = function(vehicle) {
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.data.deleteVehicle(vehicle).then((function(_this) {
        return function(result) {
          _this.log('delete result:', result);
          if (result.deleted) {
            _this.log('BE GONE!');
            return _this.refreshData();
          } else {
            return _this.log('Oops... Not gone.');
          }
        };
      })(this));
    };

    VehicleListController.prototype.refreshData = function() {
      this.log('refreshData');
      this.listView.closeOptionButtons();
      this.errors.clear();
      return this.data.profileVehicles(null, {
        refresh: true
      }).then((function(_this) {
        return function(data) {
          _this.scope.$broadcast('scroll.refreshComplete');
          _this.list = data.vehicles;
          return data;
        };
      })(this));
    };

    return VehicleListController;

  })(App.Controller);

}).call(this);
;(function() {
  var WelcomeController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  WelcomeController = (function(superClass) {
    extend(WelcomeController, superClass);

    function WelcomeController() {
      this.onRandomQuote_Error = bind(this.onRandomQuote_Error, this);
      this.onRandomQuote_Load = bind(this.onRandomQuote_Load, this);
      return WelcomeController.__super__.constructor.apply(this, arguments);
    }

    WelcomeController.inject({
      api: 'api',
      app: 'app',
      autoLogin: 'preload',
      delay: 'delay',
      log: ['Logger', WelcomeController]
    });

    WelcomeController.prototype.initialize = function() {
      this.log('initialize');
      if (this.autoLogin.success) {
        this.log('logged in... redirect?');
        this.app.navigateTo('main.secure.reservation-list', null, {
          clearHistory: true
        });
      }
      return this.delay(1000, this.api.run('getRandomQuote').then(this.onRandomQuote_Load)["catch"](this.onRandomQuote_Error));
    };

    WelcomeController.prototype.login = function() {
      if (this.app.auth.loggedIn) {
        return this.app.navigateTo('main.secure.reservation-list', null, {
          clearHistory: true
        });
      } else {
        return this.app.navigateTo('main.login', null, {
          clearHistory: true
        });
      }
    };

    WelcomeController.prototype.onRandomQuote_Load = function(quote) {
      this.log('Quote loaded!', quote);
      this.quote = quote;
      return this.quote.hasDate = !_.isEmpty(quote.date);
    };

    WelcomeController.prototype.onRandomQuote_Error = function(error) {
      this.log('Quote Load Error!', error);
      return this.error = error.message || String(error);
    };

    return WelcomeController;

  })(App.Controller);

}).call(this);
;(function() {
  var ErrorPanelController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ErrorPanelController = (function(superClass) {
    var MAX_ERRORS;

    extend(ErrorPanelController, superClass);

    function ErrorPanelController() {
      this.hide = bind(this.hide, this);
      return ErrorPanelController.__super__.constructor.apply(this, arguments);
    }

    ErrorPanelController.inject({
      log: ['Logger', ErrorPanelController],
      _animate: '$animate',
      _rootScope: '$rootScope',
      _timeout: '$timeout'
    });

    ErrorPanelController.directive('errorPanel', {
      restrict: 'E',
      replace: true,
      templateUrl: 'views/tags/error-panel.html',
      controller: 'ErrorPanelController',
      link: function(s, e, a, ctrl) {
        return ctrl.link(s, e);
      }
    });

    MAX_ERRORS = 5;

    ErrorPanelController.prototype.link = function(scope, elem) {
      this.scope = scope;
      this.elem = elem;
      this.scope.errors = [];
      this.scope.hide = this.hide;
      this.scope.$on('flash.info', (function(_this) {
        return function(d, msg, delay) {
          return _this._timeout(function() {
            var item;
            if (_this.alreadyShowingMessage(msg)) {
              return;
            }
            item = {
              message: msg,
              id: (new Date).getTime(),
              type: 'info'
            };
            _this.scope.errors.push(item);
            if (_this.scope.errors.length > MAX_ERRORS) {
              _this.scope.errors.shift();
            }
            if ((delay != null) && delay > 0) {
              return _this._timeout((function() {
                return _this.hide(item);
              }), delay);
            }
          });
        };
      })(this));
      this.scope.$on('flash.error', (function(_this) {
        return function(e, msg, delay) {
          return _this._timeout(function() {
            if (_this.alreadyShowingMessage(msg)) {
              return;
            }
            _this.scope.errors.push({
              message: msg,
              id: (new Date).getTime(),
              type: (delay != null ? 'warn' : 'error')
            });
            if (_this.scope.errors.length > MAX_ERRORS) {
              _this.scope.errors.shift();
            }
            if (delay != null) {
              return _this._timeout(_this.hide, delay + 250);
            }
          });
        };
      })(this));
      this.scope.$on('flash.warning', (function(_this) {
        return function(e, msg, delay) {
          return _this._timeout(function() {
            var item;
            if (_this.alreadyShowingMessage(msg)) {
              return;
            }
            item = {
              message: msg,
              id: (new Date).getTime(),
              type: 'warn'
            };
            _this.scope.errors.push(item);
            if (_this.scope.errors.length > MAX_ERRORS) {
              _this.scope.errors.shift();
            }
            return _this._timeout((function() {
              return _this.hide(item);
            }), 2900);
          });
        };
      })(this));
      return this.scope.$on('flash.clear', (function(_this) {
        return function(e) {
          return _this._timeout(function() {
            return _this.scope.errors.length = 0;
          });
        };
      })(this));
    };

    ErrorPanelController.prototype.hide = function(item) {
      this.log("HIDE!");
      if (item != null) {
        return this.scope.errors.remove(function(i) {
          return i.id === item.id;
        });
      } else {
        return this.scope.errors.length = 0;
      }
    };

    ErrorPanelController.prototype.alreadyShowingMessage = function(msg, recentCheck) {
      var err, j, len, now, ref;
      if (recentCheck == null) {
        recentCheck = true;
      }
      now = (new Date).getTime();
      ref = this.scope.errors;
      for (j = 0, len = ref.length; j < len; j++) {
        err = ref[j];
        if (err.message === msg) {
          this.log("Already showing message:", msg);
          if (recentCheck) {
            if ((now - err.id) < 1000) {
              this.log("(But not recently.)");
              return true;
            }
          } else {
            return true;
          }
        }
      }
      return false;
    };

    return ErrorPanelController;

  })(App.Controller);

}).call(this);
;(function() {
  var FieldErrorController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  FieldErrorController = (function(superClass) {
    extend(FieldErrorController, superClass);

    function FieldErrorController() {
      return FieldErrorController.__super__.constructor.apply(this, arguments);
    }

    FieldErrorController.inject({
      log: ['Logger', FieldErrorController]
    });

    FieldErrorController.directive('fieldErrors', function(Logger) {
      var log;
      log = Logger('[field-errors]');
      return {
        restrict: 'E',
        replace: true,
        transclude: true,
        scope: {
          form: '=',
          field: '@'
        },
        templateUrl: 'views/tags/field-errors.html',
        controller: 'FieldErrorController',
        link: function(scope, elem, attr, ctrl) {
          return ctrl.initFromDirective(scope, elem, attr);
        }
      };
    });

    FieldErrorController.prototype.initFromDirective = function(scope1, el, attr) {
      var field, form, ref;
      this.scope = scope1;
      this.el = el;
      this.log('initFromDirective', this);
      ref = this.scope, field = ref.field, form = ref.form;
      return this.scope.fieldInfo = form[field];
    };

    return FieldErrorController;

  })(App.Controller);

}).call(this);
;
/*
<form-field label="Model" type="select" for="model">
  <select
    name="model"
    ng-model="vehicle.formData.model"
    ng-options="model.name as model.name for model in vehicle.models"
    required>
  </select>
</form-field>
 */

(function() {
  var FormFieldController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  FormFieldController = (function(superClass) {
    extend(FormFieldController, superClass);

    function FormFieldController() {
      return FormFieldController.__super__.constructor.apply(this, arguments);
    }

    FormFieldController.inject({
      log: ['Logger', FormFieldController]
    });

    FormFieldController.directive('formField', function(Logger) {
      return {
        restrict: 'E',
        replace: true,
        transclude: true,
        scope: true,
        templateUrl: 'views/tags/form-field.html',
        controller: 'FormFieldController',
        link: function(scope, elem, attr, ctrl) {
          return ctrl.initFromDirective(scope, elem, attr);
        }
      };
    });

    FormFieldController.prototype.initFromDirective = function(scope1, el, attrs) {
      this.scope = scope1;
      this.el = el;
      this.attrs = attrs;
      this.scope._ffAtts = this.attrs;
      return this.scope.ctrl = this.ctrl = {
        required: 'required' in this.attrs,
        label: this.attrs.label,
        target: this.attrs["for"],
        type: this.attrs.type || 'input',
        form: this.scope.form,
        field: this.scope.form[this.attrs["for"]]
      };
    };

    return FormFieldController;

  })(App.Controller);

}).call(this);
;(function() {
  var FormOnChangeController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  FormOnChangeController = (function(superClass) {
    extend(FormOnChangeController, superClass);

    function FormOnChangeController() {
      return FormOnChangeController.__super__.constructor.apply(this, arguments);
    }

    FormOnChangeController.inject({
      log: ['Logger', FormOnChangeController],
      parse: '$parse'
    });

    FormOnChangeController.directive('formOnChange', function($parse) {
      return {
        restrict: 'A',
        require: 'form',
        link: function(scope, element, attrs, form) {
          var cb;
          cb = $parse(attrs.formOnChange);
          return element.on("change", function() {
            return cb(form, scope, arguments);
          });
        }
      };
    });

    return FormOnChangeController;

  })(App.Controller);

}).call(this);
(function() {
  var IfDebugController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  IfDebugController = (function(superClass) {
    extend(IfDebugController, superClass);

    function IfDebugController() {
      return IfDebugController.__super__.constructor.apply(this, arguments);
    }

    IfDebugController.inject({
      app: 'app',
      log: ['Logger', IfDebugController]
    });

    IfDebugController.directive('ifDebug', function(Logger) {
      var log;
      log = Logger('[if-debug]');
      return {
        restrict: 'E',
        replace: true,
        transclude: true,
        scope: {},
        templateUrl: 'views/tags/if-debug.html',
        controller: 'IfDebugController',
        link: function(scope, elem, attr, ctrl) {
          return ctrl.initFromDirective(scope, elem, attr);
        }
      };
    });

    IfDebugController.prototype.initFromDirective = function(scope1, el, attr) {
      this.scope = scope1;
      this.el = el;
      return this.scope.isDebugMode = this.app.debug;
    };

    return IfDebugController;

  })(App.Controller);

}).call(this);
;(function() {
  var IfLocation,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  IfLocation = (function(superClass) {
    extend(IfLocation, superClass);

    function IfLocation() {
      return IfLocation.__super__.constructor.apply(this, arguments);
    }

    IfLocation.directive('ifLocation', {
      link: function(s, e, a, ctrl) {
        return ctrl.initFromDirective(s, e, a);
      },
      restrict: 'E',
      controller: 'IfLocation',
      replace: true,
      scope: {},
      templateUrl: 'views/tags/if-location.html',
      transclude: true
    });

    IfLocation.inject({
      app: 'app',
      events: 'events',
      log: ['Logger', IfLocation]
    });

    IfLocation.prototype.initFromDirective = function(scope, el, attrs) {
      this.scope = scope;
      this.el = el;
      this.attrs = attrs;
      this.scope.showContent = this.attrs.is === this.app.location.get();
      return this.events.on('location.changed', (function(_this) {
        return function() {
          _this.log('Location changed!');
          return _this.scope.showContent = _this.attrs.is === _this.app.location.get();
        };
      })(this));
    };

    return IfLocation;

  })(App.Controller);

}).call(this);
;(function() {
  var IosRedrawHack,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  IosRedrawHack = (function(superClass) {
    extend(IosRedrawHack, superClass);

    function IosRedrawHack() {
      return IosRedrawHack.__super__.constructor.apply(this, arguments);
    }

    IosRedrawHack.inject({
      log: ['Logger', IosRedrawHack],
      parse: '$parse'
    });

    IosRedrawHack.directive('iosRedrawHack', function($parse) {
      return {
        restrict: 'A',
        link: function(scope, element, attrs) {
          element.on('focus', function() {
            var sel;
            element.css('display', 'block');
            element.css('width', '65%');
            sel = element[0];
            sel.style.display = 'none';
            sel.offsetHeight;
            return sel.style.display = '';
          });
          return setTimeout((function() {
            var sel;
            element.css('display', 'block');
            sel = element[0];
            sel.style.display = 'none';
            sel.offsetHeight;
            sel.style.display = '';
            return element.css('width', '65%');
          }), 1000);
        }
      };
    });

    return IosRedrawHack;

  })(App.Controller);

}).call(this);
(function() {
  var ReservationCardController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ReservationCardController = (function(superClass) {
    extend(ReservationCardController, superClass);

    function ReservationCardController() {
      return ReservationCardController.__super__.constructor.apply(this, arguments);
    }

    ReservationCardController.directive('reservationCard', {
      restrict: 'E',
      replace: true,
      scope: {
        reservation: '='
      },
      transclude: true,
      templateUrl: 'views/tags/reservation-card.html',
      controller: 'ReservationCardController',
      link: function(scope, elem, attr, ctrl) {
        return ctrl.initFromDirective(scope, elem, attr);
      }
    });

    ReservationCardController.inject({
      app: 'app',
      log: ['Logger', ReservationCardController]
    });

    ReservationCardController.prototype.initFromDirective = function(scope1, elem1, attrs) {
      this.scope = scope1;
      this.elem = elem1;
      this.attrs = attrs;
      this.log('initFromDirective', this.scope);
      this.scope.location = this.app.location.get();
      return this.scope.isActive = false;
    };

    return ReservationCardController;

  })(App.Controller);

}).call(this);
;(function() {
  var RoFieldController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  RoFieldController = (function(superClass) {
    extend(RoFieldController, superClass);

    function RoFieldController() {
      return RoFieldController.__super__.constructor.apply(this, arguments);
    }

    RoFieldController.inject({
      app: 'app',
      log: ['Logger', RoFieldController],
      filters: '$filter'
    });

    RoFieldController.directive('roField', {
      restrict: 'E',
      replace: true,
      scope: {
        value: '='
      },
      templateUrl: 'views/tags/ro-field.html',
      controller: 'RoFieldController',
      link: function(s, e, a, ctrl) {
        return ctrl.initFromDirective(s, e, a);
      }
    });

    RoFieldController.prototype.initFromDirective = function(scope, el, attrs) {
      var filter;
      this.scope = scope;
      this.el = el;
      this.attrs = attrs;
      this.scope.label = this.attrs.label;
      this.scope.filterValue = this.attrs.filter ? (filter = this.filters(this.attrs.filter), (function(_this) {
        return function(value) {
          return filter(value);
        };
      })(this)) : (function(_this) {
        return function(value) {
          return value;
        };
      })(this);
      if (this.attrs.forlocation != null) {
        return this.scope.showField = this.app.location.get() === this.attrs.forlocation;
      } else {
        return this.scope.showField = true;
      }
    };

    return RoFieldController;

  })(App.Controller);

}).call(this);
;(function() {
  var SafeImgController,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  SafeImgController = (function(superClass) {
    extend(SafeImgController, superClass);

    function SafeImgController() {
      return SafeImgController.__super__.constructor.apply(this, arguments);
    }

    SafeImgController.inject({
      log: ['Logger', SafeImgController]
    });

    SafeImgController.directive('safeImg', {
      restrict: 'E',
      replace: true,
      scope: {
        src: '=',
        fallback: '='
      },
      template: '<img ng-src="{{src}}"/>',
      controller: 'SafeImgController',
      link: function(s, e, a, ctrl) {
        return ctrl.initFromDirective(s, e, a);
      }
    });

    SafeImgController.prototype.initFromDirective = function(scope, el, attrs) {
      this.scope = scope;
      this.el = el;
      this.attrs = attrs;
      return this.el.on('error', (function(_this) {
        return function() {
          if (_this.el.attr('src') === _this.scope.fallback) {
            return _this.log('Fallback image failed to load!');
          } else {
            return _this.el.attr('src', _this.scope.fallback);
          }
        };
      })(this));
    };

    return SafeImgController;

  })(App.Controller);

}).call(this);
;
/*
  Automatically adds an 'invalid-state' class to elements when the associated
  form field is $invalid.

  Requires form to the named 'form.'
 */

(function() {
  var StateClassController,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  StateClassController = (function(superClass) {
    extend(StateClassController, superClass);

    function StateClassController() {
      this.checkValidity = bind(this.checkValidity, this);
      return StateClassController.__super__.constructor.apply(this, arguments);
    }

    StateClassController.inject({
      log: ['Logger', StateClassController]
    });

    StateClassController.directive('stateClass', {
      restrict: 'A',
      controller: 'StateClassController',
      scope: true,
      link: function(scope, elem, attr, ctrl) {
        return ctrl.initFromDirective(scope, elem, attr);
      }
    });

    StateClassController.prototype.initFromDirective = function(scope1, el, attr) {
      this.scope = scope1;
      this.el = el;
      this.trackingName = attr.stateClass || "";
      this.tracking = this.scope.form[this.trackingName];
      this.checkValidity();
      return this.scope.$watch("form." + this.trackingName + ".$valid", this.checkValidity);
    };

    StateClassController.prototype.checkValidity = function() {
      this.log("checkValidity:", this.trackingName, this.tracking.$valid);
      if (this.tracking.$valid) {
        this.el.addClass('valid-state');
        return this.el.removeClass('invalid-state');
      } else {
        this.el.removeClass('valid-state');
        return this.el.addClass('invalid-state');
      }
    };

    return StateClassController;

  })(App.Controller);

}).call(this);
;
//# sourceMappingURL=app.js.map